КСРС 3.X.X.X

Легенда:
ADD: Что добавилось или убралось (новая возможность, окно и т.п.)
CHG: Что изменилось
FIX: Исправлена ошибка
INF: Любая информация

Подсистемы:
1. Сервер терминала ЦТРС [ksrs-terminal-server]
2. Графический интерфейс терминала ЦТРС [ksrs-terminal-gui]
3. Агент оповещения о статусе ЦТРС [ksrs-terminal-snmp]
4. Коллектор мониторинга [ksrs-collector-snmp]
5. База данных [ksrs-database]
6. Графический интерфейс СТКУ [ksrs-control]

Базовый функционал версии 3.0.0.Х
1. Системная поддержка ОС [ksrs-terminal-server,ksrs-terminal-gui]:
   Windows (XP,Vista,7,8), Linux ( ядро > 2.6.12)
2. Системная поддержка USB разговорных приборов [ksrs-terminal-server]:
   гарнитур, динамиков, микрофонов, тангент, линейных интерфейсов магнитофона
3. Системная поддержка SIP [ksrs-terminal-server]:
   входящие/исходящие звонки в режиме point-to-point с применением кодека g711alaw
4. Системная поддержка РАДИО [ksrs-terminal-server]:
   расширения RTP реализованные шлюзом производства ООО "ЛЭМЗ" КБ "ЛИРА"
5. Системная поддержка ЗВУКОЗАПИСЬ/ЗВУКОВОСПРОИЗВЕДЕНИЕ [ksrs-terminal-server]:
   с диска и на диск
6. Системная поддержка КОММУТАЦИЯ [ksrs-terminal-server]: микшер аудиопотоков
7. Поддержка ГГС [ksrs-terminal-gui]: настройка и обслуживание кнопок ГГС
8. Поддержка РАДИОСТАНЦИЙ [ksrs-terminal-gui]: настройка и обслуживание кнопок
   РАДИО

16.01.2013 [ksrs-terminal-server] 3.0.0.2
FIX: Плеер после первых нескольких байтов вываливался из проигрывателя
FIX: Падение приложения при сконфигурированой системе воспроизведения звука

17.01.2013 [ksrs-terminal-server] 3.0.0.3
FIX: При выполнении команды коммутации не осуществлялось трансляция статуса сессии
     по сопряженным каналам
CHG: Плеер создается теперь приостановленным и только начало микширования приводит
     к активации возобновлению плеера

18.01.2013 [ksrs-terminal-server] 3.0.0.4
CHG: Изменен механизм работы плееров и синтезаторов. Автоматически они разрушаются
     теперь только по ошибке
ADD: Добавлена индикация запуска и остановки плеера
FIX: Не воспринималось количество проигрышей синтезатора
FIX: Не возобновлялось воспроизведение синтезатора при конечном числе проигрышей

19.01.2013 [ksrs-terminal-server] 3.0.0.5
FIX: Ошибочно высылался статус унечтожаемого USB-слота
FIX: Плеер не разрушался автоматически при ошибке активации
FIX: Возникала исключительная ситуация при разрушении фабрики плееров, если
     в ней были активные сеансы
FIX: Некорректно очищались контексты миксера при выгрузке

21.01.2013 [ksrs-terminal-server] 3.0.0.6
FIX: При остановке миксера удалялся уже освобожденные указатель
ADD: Введена процедура "холостого хода" микшера для корректной остановки фабрики
     сигнализаций. В случае активных каналов существовала вероятность некорректного
     гашения микшера
FIX: Голосовая подсистема инициализировалась некорректно в случае, когда приложение
     запускается не из каталога, в котором расположен исполняемый модуль

22.01.2013 [ksrs-terminal-server] 3.0.0.7
ADD: Добавлена поддержка установки приложения как сервиса ОС
INF: Для дополнительной информации расширена информационная возможность командной строки.
     Для получения этой инфорамции необходимо вызвать следующим образом:
	>krs-terminal-server --help
	-----------------------------------------------------
	Terminal for digital communication (server component)
	-----------------------------------------------------
	3.0.0 (beta 1) build 7
	-----------------------------------------------------
	Usage: krs-terminal-server [--help] | [--version] | [--run] | [--start] | [--stop] | [--install] | [--uninstall]
	--help           show this message
	--version        show version information
	--run            run application (default)
	--start          start service
	--stop           stop service
	--install        install service
	--uninstall      uninstall service

25.01.2013 [ksrs-terminal-server] 3.0.0.8
ADD: Некоторые внутренние объекты для поддержки протокола P2
FIX: В некоторых случаях (для двунаправленных разговорных приборов с самопрослушиванием)
     таблица миксера очищалась некорректно

30.01.2013 [ksrs-terminal-server] 3.0.0.9
FIX: Перекоммутация слота не отменяла предыдущего режима коммутации
ADD: Добавлены штатные обертки для подсистемы трансляции статусов

14.02.2013 [ksrs-terminal-server] 3.0.0.10
FIX: Ошибка в разборе пакета LIRA-USB приводила к падению службы

15.02.2013 [ksrs-terminal-server] 3.0.0.11
FIX: При активации радиостанции текущий статус ptt не индицировался
ADD: Реализована первая ревизия протокола P2 по трансляции статусов
     канальных сессий и событий в активных сессиях

18.02.2013 [ksrs-terminal-server] 3.0.0.11
ADD: Добавлена поддержка высылки статусов терминала по протоколу P2

28.02.2013 [ksrs-terminal-server] 3.0.0.12
FIX: Не передавалось в SIP-стек сообщение алертинг при активации входящего вызова
FIX: Не работал механизм контроля за жизнидеятельностью транспорта P1 (Ping-Pong)
ADD: Поддержка трасляции настроек с СТКУ (написано всё, кроме применения списка синтезаторов
     и локальных настроек ЦТРС)

01.03.2013 [ksrs-terminal-server] 3.0.0.12
ADD: Добавлена поддержка применения списка синтезаторов

06.03.2013 [ksrs-terminal-server] 3.0.0.13
ADD: Добавлена поддержка "PTT pedal inteface"

13.03.2013 [ksrs-terminal-server] 3.0.0.14
ADD: Добавлена поддержка регистраций UAC ЦТРС на внешних UAS (Команда REGISTER)
INF: Теперь для использования какой-либо регистрации необходимо при
     при инициализации вызова указать так callerID в формате: [sip:]<login>@<registrator address>.
     После этого - адрес в calledID и схему указывать не обязательно. Достаточно номера

12.04.2013 [ksrs-terminal-server] 3.0.0.15
ADD: Добавлена поддержка запроса (UAC) подписок типа "presence"
ADD: Добавлена поддержка входящих подписок (UAS) типа "presence"
ADD: Реализована поддержка отображения стаусов присутствия в протокол P1 от:
     а) шлюзов ГГС производства ЛЭМЗ
     б) другого ЦТРС
     в) логинов Астериск
FIX: Не возобновлялись UAC повторить неуспешные попытки зарегистрироваться (REGISTER)
     или получить подписку на статус (SUBSCRIBE - presence)
CHG: Модифицирована процедура остановки приложения с тем, чтобы дать возможность UAC
     освободить текущие регистрации и подписки

13.04.2013 [ksrs-terminal-server] 3.0.0.16
ADD: Добавлена возможность обмена текстовыми сообщениями бежду терминалами

17.04.2013 [ksrs-terminal-server] 3.0.0.17
ADD: Добавлена возможность использовать звуковые платы как источники или потребители
     звуковых данных. Для жтого введен новый тип канала - AUDIO
INF: На данный момент поддерживаются только устройства, которые обеспечивают аудиопоток
     формата PCM 8000Гц 16 бит МОНО

18.04.2013 [ksrs-terminal-server] 3.0.0.18
ADD: Добавлена поддержка plug-and-play аудио устройств

30.04.2013 [ksrs-terminal-server] 3.0.0.19
INF: Тестовая сборка для ЛЭМЗ

22.05.2013 [ksrs-terminal-server] 3.0.0.20
CHG: Изменена процедура таймирования USB-устройств. Теперь перегружаются в независимости
     от скорости сканирования неподключенных устройств
FIX: Устранена причина "падения" в случае перезагрузки настроек каналов

23.05.2013 [ksrs-terminal-server] 3.0.0.20
FIX: Некорректно работала процедура загрузки нескольких файлов конфигурации: висла транзакция
     и файлы имели некорректные имена
FIX: Устранена заглушка гашения SIP-endpoint по таймеру. Она мешала быстрой перегрузке конфигурации
     с СТКУ

24.05.2013 [ksrs-terminal-server] 3.0.0.21
FIX: Происходило падение если были звонки по SIP. Потом перегрузили конфигурацию каналов. На 3-м
     звонке по SIP приложение падало

12.07.2013 [ksrs-terminal-server] 3.0.0.22
FIX: Холсотой ход микшера неоптимально использовал CPU

12.08.2013 [ksrs-terminal-server] 3.0.0.23
FIX: Множество исправлений с утечками памяти

27.08.2013 [ksrs-terminal-server] 3.0.0.24
FIX: Множество исправлений с критическими участками кода по размещению объектов

27.08.2013 [snmp-agent.exe] 3.0.0.9
FIX: Падение приложение после перезагрузок ksrs-terminal-server
     (http://bugs.rinotel.com/view.php?id=503)

28.08.2013 [ksrs-terminal-server] 3.0.0.25
FIX: Исключена вероятность зацикливания под ОС LINUX в случае отсутствия snmp-agent-а
     (http://bugs.rinotel.com/view.php?id=507)

29.08.2013 [snmp-agent.exe] 3.0.0.25
FIX: Некорректно заполнялась таблица локальных приборов - только последние из однотипных попадали в них
     (http://bugs.rinotel.com/view.php?id=509)

29.08.2013 [snmp-agent.exe] 3.0.0.26
FIX: не высылался trap на смену статуса оператора
     (http://bugs.rinotel.com/view.php?id=509)
FIX: версия файла snmp-agent.exe бралась с krs-treminal-server.exe

28.09.2013 [ksrs-terminal-server] 3.0.0.27
FIX: Не очищался список использованных слотов
ADD: Добавлена поддержка перевода входящих неотвеченных вызовов (forward) по SIP
ADD: Добавлена поддержка процедуры HOLD/UNHOLD на уровне сигнализации по SIP
ADD: Добавлена поддержка DTMF INFO по SIP

03.10.2013 [ksrs-terminal-server] 3.0.0.28
FIX: Устранена утечка памяти в обвязке стека RTP

09.10.2013 [ksrs-terminal-server] 3.0.0.29
ADD: Добавлена реакция терминала на манипуляции с педалью

10.10.2013 [ksrs-terminal-server] 3.0.0.30
FIX: Некорректно заполнялоcя атрибут "Contact". Сейчас "Contact" заполняется как
     <sip:<ip>:<port>>

14.10.2013 [ksrs-terminal-server] 3.0.0.31
FIX: Утечка памяти при разрушении RTP-сессии
FIX: Неконролируемое размещение фрагмента IP-адреса в SDP при удержании вызова
     могло приводить к падению приложения

17.10.2013 [ksrs-terminal-server] 3.0.0.32
FIX: Не работал функционал РАДИО: RTP поднималось в заглушенном виде

22.10.2013 [ksrs-terminal-server] 3.0.0.33
FIX: Не сохранялась версия голосовых сообщений в случае подключенного GUI

28.10.2013 [ksrs-terminal-server] 3.0.0.34
FIX: После перезагрузки параметров переставал транслироваться RTP от микшера
     (http://bugs.rinotel.com/view.php?id=518)

06.11.2013 [ksrs-terminal-server] 3.0.0.35
FIX: При отлючении графического интерфейса на агента мониторинга высылался
     некорректный статус

07.11.2013 [ksrs-terminal-server] 3.0.0.35
CHG: Теперь и вплоть до реализации механизма группировок радиостанций
     команда тангенты и смены частоты выдается с включеным флагом Rv
CHG: Флаг Sh ре транслируется в неизменном виде как это приходит
     от радиостанции

21.11.2013 [ksrs-terminal-server] 3.0.0.36
FIX: Устранена проблема в трансляции флагов для графического интерфейса.
     Проблема внесена в версии 12.04.2013 [ksrs-terminal-server] 3.0.0.15
ADD: Логирование новых радийных флагов

02.12.2013 [ksrs-terminal-server] 3.0.0.39
FIX: Дублирование микшируемых потоков звука в случае если источников сигнала более одного

03.12.2013 [ksrs-terminal-server] 3.0.0.40
FIX: Не отрабатывался контроль за переполнением динамического диапазона при суммировании
     звуковых потоков

05.12.2013 [ksrs-terminal-server] 3.0.0.41
FIX: Введена защита от зависания сессии дозвона SIP после неудачной попытки отмены вызова
ADD: Введена процедура ускорения разрушения соединений при дозвоне на "мертвые" хосты

06.12.2013 [ksrs-terminal-server] 3.0.0.42
FIX: Подсистема взаимных индикаций ЦТРС, написанная 8 месяцев назад работала с изъянами

07.12.2013 [ksrs-collector-snmp] 3.0.0.11
FIX: Предыдущее добавление в функционале (поддержка создания новых системных элементов в СТКУ)
     "поломало" функцию контроля за соединением (Инцидент №558)

07.12.2013 [ksrs-control] 3.0.0.34
CHG: Увеличено "окно контроля" за соединением с коллектором в 2 раза

09.12.2013 [ksrs-collector-snmp] 3.0.0.12
FIX: Не учитывался тот факт, что одна переменная может участвовать в нескольких индикаторах

11.12.2013 [ksrs-terminal-server] 3.0.0.43
FIX: Падение сервера при получении команды на коммутацию несуществующей сессии (Инцидент №560)
FIX: После применения конфигурации не публикуется в подписках текущей статус ЦТРС (Инцидент №561)

11.12.2013 [ksrs-terminal-gui] 3.0.0.34
FIX: Кнопки других ЦТРС, находящихся в состоянии занятости или недоступности (серые и оранжевые),
     не воспринимали нажатия даже при попытке включения прослушивания и т.п.
FIX: Нарушалась логика работы кнопок после отбоя входящих вызовов

11.12.2013 [ksrs-control] 3.0.0.34
ADD: На иконку шлюзов и ИБП добавлена минииконка со статусом аппаратуры

13.12.2013 [ksrs-terminal-gui] 3.0.0.35
FIX: Обнаружение несущей на радиокнопках моргало даже после отключения соответствующей кнопки ПРМ или ПРД
CHG: Убрана автоматическая активация ПРД при нажатии экранной кнопки тангенты
ADD: После сигнала о пропаже несущей кнопки мигают ещё 3 секунды. Позже этот параметр будет приходить с СТКУ
FIX: Временный фикс проблемы неподнятия первых устройств ППРП после применения новой конфигурации
FIX: При обновлении конфигурации, если был активный разговор, то кнопка Отбой остаётся красной на новой конфигурации

13.12.2013 [ksrs-control] 3.0.0.35
FIX: Иконка общего статуса системного элемента не обновлялась пока не было фокуса
CHG: Пункт меню "Обновить конфигурацию" блокируется на время процесса обновления
FIX: При удалении системного элемента окно с его статусами оставалось открытым

13.12.2013 [ksrs-terminal-server] 3.0.0.44
FIX: Падение сервера при перетыкании прибора в который ативно пишут (нужно умудриться несколько раз успеть передернуть)

16.12.2013 [ksrs-control] 3.0.0.35
FIX: При создании новых системных элементов СТКУ падал при обращении к системе мониторинга.
     Падения в некоторых случаях случались потом и при последующем запуске СТКУ.
ADD: Добавлен параметр радиокнопки "Текст на кнопке"

16.12.2013 [ksrs-terminal-gui] 3.0.0.35
CHG: Кнопка тангенты не нажимается при отсутствии RX
ADD: Добавлен параметр радиокнопки "Текст на кнопке"
FIX: Обнаружение несущей на радио моргало даже при отсутствии вызова

17.12.2013 [ksrs-control] 3.0.0.36
CHG: Отключено лишнее сохранение Схемы в БД при отсутствии изменений в окне редактора соответствующего типа элемента.
     Это должно сократить проблемы с настройками при одновременной работе нескольких СТКУ с одной БД.
ADD: Списки индикаторов и статусов мониторинга отсортированы по алфавиту
ADD: Оcновные настройки\Печать. Позже будут добавлены параметры печати.

17.12.2013 [ksrs-terminal-server] 3.0.0.45
ADD: Добавлена поддержка управления уровнем сигнала в диапазоне -20..20 децибел

18.12.2013 [ksrs-terminal-server] 3.0.0.46
FIX: Невозможно было установить уровень сигнала на сессию, у которой на момент получения команды
     медиасреда не была активирована
CHG: Теперь статус "НА РАДИО" устанавливается только при владении тангентой и сбрасывается при
     её освобождении
ADD: Поддержка индикации стороны удержания (удаленная или локальная)
FIX: Ошибка упаковки пакета информирования о статусе удержания

18.12.2013 [ksrs-terminal-snmp] 3.0.0.38
CHG: Теперь статус "НА РАДИО" устанавливается только при владении тангентой и сбрасывается при
     её освобождении

18.12.2013 [ksrs-terminal-gui] 3.0.0.35
CHG: Теперь пакет информции о статусе сессии логируется, исходя из его семантики в Р1

18.12.2013 [ksrs-control] 3.0.0.36
CHG: Иконки схемы сделаны поинформативнее
ADD: Добавлено 'распознавание' Инвертора
ADD: Для внутреннего использования во все кнопочные компоненты добавлен параметр ButtonID
CHG: В настройках SNMP теперь не нужно использовать кавычки при указании списков адресов

18.12.2013 [ksrs-terminal-gui] 3.0.0.36
ADD: Разговор находящийся на удержании снять с него может только инициатор удержания.
     Вторая сторона может только сбросить 'синий' вызов.
FIX: Занятие тангенты отображалось только на первой попавшейся с ней радиостанции, сделано на всех

19.12.2013 [ksrs-control] 3.0.0.36
FIX: Списки индикаторов и статусов мониторинга ещё раз отсортированы по алфавиту
FIX: На новых радиокнопках не была проинициализирована частота (было поломано 16.12.20)
FIX: При восстановлении связи с терминалом не обновлялась иконка терминала на схеме

19.12.2013 [ksrs-terminal-gui] 3.0.0.36
FIX: Тангента радиокнопки без фиксации 'залипала' при быстром нажатии и отпускании

24.12.2013 [ksrs-control] 3.0.0.37
CHG: Отфильтрованы списки выбора ППРП устройств (например в списке 'Предпочитаемый динамик'
     оставлены только устройства умеющие воспроизводить звук). #0000533

24.12.2013 [ksrs-terminal-gui] 3.0.0.37
FIX: Вторжение: некорректная работа вторжения, после отключения вторжения кнопки ЦТРС оставались оранжевыми. #0000581
FIX: Прослушивание: после отбоя прослушиваемых соединений, сессии прослушки оставались в коммутации с устройствами ППРП
ADD: Окно выбора РП и регулировки громкости #0000570 #0000575

27.12.2013 [ksrs-control] 3.0.0.38
ADD: Параметр кнопки ГГС: Циркуляр. #0000574
     Чекбоксами отмечаются кнопки которые будут вызываться при нажатии кнопки 'Циркуляр'.
     Если отмечена хоть одна кнопка в дереве, то редактируемая кнопка становится кнопкой типа 'Циркуляр'.
     Собственные параметры дозвона кнопки 'Циркуляр' (адрес и АОН) использоваться не будут.
     Сейчас такая кнопка сделана в обоих вариантах - и с фиксацией и сипплекс.

27.12.2013 [ksrs-terminal-gui] 3.0.0.38
ADD: Поддержка кнопок типа 'Циркуляр'. #0000574

28.12.2013 [ksrs-control] 3.0.0.38
FIX: Невозможно было открыть свойства элемента типа Инвертор

28.12.2013 [ksrs-terminal-gui] 3.0.0.38
CHG: Доделка циркуляра

30.12.2013 [ksrs-terminal-gui] 3.0.0.39
ADD: Предварительный вариант панели входящих косвенных вызовов
ADD: Окно регулировок уровня звуковых сигналов оповещения #0000573

03.01.2014 [ksrs-terminal-server] 3.0.0.48
FIX: Восстановлена работа плеера #0000590
FIX: Устранена возможность падения при выгрузке [ksrs-terminal-gui] #0000592

03.01.2013 [ksrs-terminal-gui] 3.0.0.40
FIX: Не регулировался уровень акустического сигнала (перепутаны направления) #0000591#c2933
FIX: При переключении разговорного прибора для оповещения тестовый режим не корректировался

06.01.2014 [ksrs-terminal-server] 3.0.0.48
FIX: Транскодер alaw в линейное представление звукового сигнала и обратно имел дефект
     "паразитного" смещения в области -7..-1 отсчетов. Это приводило к тому, что при
     понижении мощности сигнала на -1 дБ возникали шумовые эффекты. Теоретически -
     эти же шумовые эффекты могли возникать и в конференциях на 3 канала и более #0000591

08.01.2014 [ksrs-terminal-server] 3.0.0.48
           [ksrs-terminal-gui] 3.0.0.40
	   [ksrs-terminal-snmp] 3.0.0.38
INF: Сборка под Linux RH 19
INF: Обновлен драйвер под Linux для ППРП и скрипт для udev

10.01.2014 [ksrs-terminal-gui] 3.0.0.40
FIX: Не удалялись кнопки входящих косвенных вызовов, отбитых со стороны Б

13.01.2014 [ksrs-terminal-gui] 3.0.0.41
FIX: После применения новых настроек не всегда поднимались (зеленели) первые устройства ППРП
CHG: Фиксированная панель входящих косвенных вызовов выделена в отдельное окно.
     История вызовов пока не доделана.

14.01.2014 [ksrs-terminal-gui] 3.0.0.41
ADD: Индикация на кнопке окна входящих косвенных вызовов.
     Пока такая: мигает желтый фон = новый входящий вызов, зеленый фон = есть активные разговоры
FIX: Был поломан реконнект гуя к серверу
FIX: Правая часть рабочего поля терминала перекрывалась скрытым окном
FIX: Невозможно вернуться к входящему вызову поставленному на удержание со стороны терминала.
     Вызов отбивался при нажатии на синюю кнопку.
CHG: Визуально расширен режим блокировки терминала.
     Нужно держать кнопку блокировки пока прогрессбар не добежит до 100%.

15.01.2014 [ksrs-terminal-server] 3.0.0.49
CHG: Скорость трансляции звука ППРП теперь засинхронизирована от потока звуковых данных
     РП (пакеты статуса тангенты не учитываются) - проверено на адыкватность только в Windows
FIX: Периодически при входящем или исходящем вызове от абонента нет звукового сигнала #0000596

15.01.2014 [ksrs-terminal-gui] 3.0.0.41
ADD: Все окна запоминают последнюю позицию и размер
CHG: Статус о блокировке терминала теперь рассылается по подпискам и виден на других ЦТРС
ADD: История в окне косвенных вызовов. Ещё в процессе улучшения.

16.01.2014 [ksrs-terminal-gui] 3.0.0.41
CHG: Доделана история в окне косвенных вызовов
CHG: Разные мелочи, в т.ч. косметические

17.01.2014 [ksrs-control] 3.0.0.40
CHG: Настройки терминала: изменен принцип хранения таблицы SIP маршрутов.
     Теперь настройки храняться не в UI а в собственных таблицах БД
	 (требуется БД с соответствующими изменениями).
ADD: Добавлены 3 новых параметра канала шлюза
ADD: Теперь выводится версия прошивки шлюза

18.01.2014 [ksrs-terminal-server] 3.0.0.50
FIX: ЦТРС некорректно обновляет конфигурацию голосовых сообщений #0000598

18.01.2014 [ksrs-terminal-gui] 3.0.0.41
ADD: Деактивация файловых каналов при обновлении конфигурации
CHG: Разные мелочи, в т.ч. косметические

21.01.2014 [ksrs-terminal-server] 3.0.0.51
FIX: Если данные от радиостанций (нескольких) транслировались на один порт, то
     имело место проникновение потоков данных из одной сессии в другую

22.01.2014 [ksrs-control] 3.0.0.41
ADD: Добавлена настройка шрифта кнопки Радио
ADD: На кнопке Радио с флагом "Только прослушивание" оставлена только кнопка ПРМ
CHG: Изменения панели настройки параметров кнопок

22.01.2014 [ksrs-terminal-gui] 3.0.0.41
ADD: Добавлена настройка шрифта кнопки Радио
ADD: На кнопке Радио с флагом "Только прослушивание" оставлена только кнопка ПРМ

23.01.2014 [ksrs-control] 3.0.0.41
FIX: Удалены лишние запросы к БД при настройке "Внешних шлюзов"
FIX: Удалены лишние запросы к БД при сохранении настроек в редакторе ЦТРС
ADD: Настройка кооординат и размеров кнопок в редакторе ЦТРС

23.01.2014 [ksrs-terminal-server] 3.0.0.51
FIX: При использовании функции "Прослушивание" как слушатель, так и слушаемый
     индицировались как занятые разговором

23.01.2014 [ksrs-terminal-gui] 3.0.0.42
FIX: Прослушивание: после разрушения прослушиваемых соединений устройства ППРП оставались на прослушке. #600

24.01.2014 [ksrs-terminal-server] 3.0.0.52
FIX: Некорректно детектировался статус ЦТРС при его сетевой недоступности #0000601

24.01.2014 [ksrs-terminal-gui] 3.0.0.42
FIX: Удержание: кнопка сама снималась с удержания при осуществлении следующего вызова с этого же ЦТРС. #539

24.01.2014 [ksrs-control] 3.0.0.41
CHG: Настройки терминала: убраны вызовы процедур БД при отсутствии изменений в таблице SIP маршрутов.
     Изменена логика сохранения конфигураций (для этого требуется БД с соответствующими изменениями).

27.01.2014 [ksrs-terminal-gui] 3.0.0.43
CHG: Изменение главного интерфейса. Под функциональные кнопки организована правая панель.

28.01.2014 [ksrs-control] 3.0.0.41
CHG: Настройки терминала: разные оптимизации и правки.

29.01.2014 [ksrs-terminal-gui] 3.0.0.43
FIX: Удержание: кнопка 'отвеченная на входящий вызов и удержанная' сама снималась с удержания
     при осуществлении следующего вызова с этого же ЦТРС. #602
FIX: Сессии прослушки попадали под документирование в Line_interface_#2

01.02.2014 [ksrs-terminal-gui] 3.0.0.44
CHG: Прослушивание: Полностью изменена логика функции 'Прослушивание' на стороне инициаторе.
     Теперь поведение полностью соответсвует описанию в документе "Описание функций КСРС версии 3.doc"
FIX: Прослушивание: в некоторых случаях с прослушки снимался канал входящего вызова. Была ошибка в логике коммутации.
FIX: Прослушивание: в некоторых случаях не прослушивались разговорные устройства радиокнопок

03.02.2014 [ksrs-terminal-gui] 3.0.0.44
ADD: Прослушивание: защита от самопрослушивания. Сессии прослушки ставятся на удержание
     на время разговора между соответсвующими абонентами.

04.02.2014 [ksrs-terminal-gui] 3.0.0.44
FIX: Кнопки 'Общий Ответ' и 'Общий Отбой' обрабатывали вызовы в случайном порядке. #563

05.02.2014 [ksrs-terminal-gui] 3.0.0.44
ADD: Удержание: переключение между вызовами с помощью кнопки УДЕРЖ. #611

07.02.2014 [ksrs-control] 3.0.0.41
FIX: Настройки терминала: при перемещении кнопок не менялись актуальные значения в полях редактирования позиции.
CHG: Главное окно: панели с деревом и окном сообщений можно сделать любого размера, который запомнится при перезагрузке

07.02.2014 [ksrs-terminal-gui] 3.0.0.44
CHG: Протокольчик: ширина окна по умолчанию уменьшена чтобы не перекрывать правую панель сервисных кнопок

10.02.2014 [ksrs-control] 3.0.0.41
CHG: Оптимизация прорисовки схемы

11.02.2014 [ksrs-terminal-server] 3.0.0.54
FIX: Ошибка освобождения пула регистрации ранше чем освободится объект точки подключения
ADD: Jitter-buffer размером в 32 мс для приборов ППРП с 8 мс "детектором воды"

11.02.2014 [ksrs-terminal-gui] 3.0.0.45
CHG: Шрифт функциональных кнопок сделан жирнее
FIX: Множество изменений в функциях прослушивания и документирования
FIX: Радиокнопки обрезались под Linux при больших шрифтах

11.02.2014 [ksrs-control] 3.0.0.41
FIX: Редактор ЦТРС: окно параметров кнопки под Linux сделано с флагом 'Поверх всех окон', чтобы не пряталось

12.02.2014 [ksrs-terminal-server] 3.0.0.55
FIX: Из-за ошибок квантования звуковых пакетов возникал эффект http://bugs.rinotel.com/view.php?id=611#c2978
CHG: В джиттере буфере исключен механизм повторения пакета в "детекторе воды". Приводило к щелчкам при отключении
     когерентных сигналов

12.02.2014 [ksrs-control] 3.0.0.41
CHG: Окно состояния системного элемента запоминает позицию и размер

13.02.2014 [ksrs-terminal-gui] 3.0.0.46
FIX: Множество изменений в функциях прослушивания и документирования

14.02.2014 [ksrs-terminal-gui] 3.0.0.46
FIX: Разные правки в функциях прослушивания и документирования
CHG: Симплекс приведён в соответствие с "Описание функций КСРС версии 3.doc"
ADD: Симплекс: для обеих сторон добавлена визуальная индикация того что вызов симплексный
CHG: Симплекс: зависимые от предыдущих пунктов изменения в циркуляре
FIX: Симплекс: на принимающей стороне был активирован 'микрофон'
FIX: При входящих и исходящих вызовах теперь отключаются все сессии прослушивания,
     но возобновляются после завершения этих вызовов. #610

15.02.2014 [ksrs-control] 3.0.0.42
FIX: Ломается структура версии каналов ЦТРС при изменении SIP-маршрутов. #627
     Так же изменена процедура БД save_outer_gw_conf.
CHG: Облагорожены названия разговорных устройств, в том числе и в сообщениях мониторинга. #621
CHG: Ещё одно изменение которое должно убрать задержку отрисовки после закрытия окон настроек ЦТРС и шлюзов. #621
CHG: Информационное окно скрывается при входе в режим конфигурации объекта. #621
CHG: Высота заголовков закладок в уменьшена с 40px до 30px, оптимально под две строки текста. #621
FIX: Не обновлялись стили после изменения расположения закладок (в окне настроек по двойному клику на закладке)
CHG: Во всплывающей подсказке оставлена минимальная информация об объекте схемы. #621
CHG: Редактор ЦТРС: Диалоги выбора шрифта переведены на русский язык. #621
CHG: Редактор ЦТРС: пока cпрятаны TODO параметры. #621
FIX: Редактор ЦТРС: убраны дублирующиеся варианты размеров кнопок. #621

15.02.2014 [ksrs-terminal-gui] 3.0.0.46
CHG: Облагорожены названия разговорных устройств. #621
CHG: Высота заголовков закладок в уменьшена с 40px до 30px, оптимально под две строки текста. #621

16.02.2014 [ksrs-control] 3.0.0.42
CHG: Редактор ЦТРС: реализованы все TODO параметры кроме таймаута на ответ. #621

16.02.2014 [ksrs-terminal-gui] 3.0.0.46
CHG: Реализованы все TODO параметры из СТКУ, кроме таймаута на ответ. #621
FIX: В некоторых случаях на кнопках ГГС и Радио неверно индицировались иконки активных разговорных устройств

17.02.2014 [ksrs-terminal-gui] 3.0.0.46
ADD: Добавлено проигрывание звуковых событий на ошибочное нажатие, входящий вызов, удержание с удаленной стороны.

18.02.2014 [ksrs-terminal-gui] 3.0.0.47
ADD: Добавлено постоянное отображение назначенных разговорных приборов на кнопках. #612
     черная пиктограмма прибора: назначенный прибор на кнопку готов к работе и доступен для использования
     красная пиктограмма прибора: назначенный прибор не готов к работе (неисправен или отключен), но прибор по-умолчанию готов к работе и будет использован в активных сессиях
     красный крест: ни назначенный прибор ни прибор по-умолчанию не готовы к работе (неисправны или отключены)
	 НО: на время активной сессии на кнопке белыми пиктограммами будут отображаться реально использующиеся в данной сессии устройства
ADD: Добавлено выделение (синим пунктиром) кнопки для которой было открыто окно настройки разговорных устройств
CHG: При потере связи с сервером терминал блокировался до момента ручной разблокироввки.
     Теперь восстанавливается тот статус блокировки который был до дисконнекта.

18.02.2014 [ksrs-control] 3.0.0.43
ADD: Редактор ЦТРС: добавлено постоянное отображение назначенных разговорных приборов на кнопках.
     Если у кнопки стоит настройка 'Использовать прибор ЦТРС по-умолчанию', то на кнопке пиктограмма этого устройства будет отсутствовать.

19.02.2014 [ksrs-terminal-gui] 3.0.0.47
ADD: Выбор разговорных устройств и настройка громкости для тастатуры
CHG: Цвет кнопки при симплексном вызове сделан как у обычного дуплексного вызова
CHG: Оптимизация метода постановки сессий на прослушивание и документирование

20.02.2014 [ksrs-terminal-gui] 3.0.0.47
FIX: Оптимизация метода постановки сессий на прослушивание и документирование
FIX: При запуске ЦТРС не применялись настройки громкости акустических сигналов
ADD: Реализовано циклическое проигрывание сигналов 'КПВ', 'Входящий вызов' и 'Удержание вызова' в соответствующие моменты

21.02.2014 [ksrs-terminal-gui] 3.0.0.47
CHG: Подправлено первоначальное положение окна протокола

21.02.2014 [ksrs-terminal-gui] 3.0.0.47, [ksrs-control] 3.0.0.43
ADD: Параметр превращающий радиокнопку в кнопку включения-выключения радиостанции

22.02.2014 [ksrs-terminal-gui] 3.0.0.47
CHG: Поддержка радиокнопок с функцией удаленного включения-выключения радиостанции. #624
     Если такие кнопки есть при старте терминала, то обычные кнопки управления
     ТОЙ ЖЕ РСТ блокируются, пока РСТ не 'будет включена'.
FIX: Загрузка новой конфигурации происходила не в соответствии с протоколом P1

22.02.2014 [ksrs-control] 3.0.0.43
CHG: В окне авторизации при запуске СТКУ заменён баннер. #635
CHG: Окно с информацией о системном объекте опять сделано с авторазмером по содержимому, чтобы исключить скроллинг. #635
FIX: Окно с информацией о системном объекте автоматически появлялось даже при наличии открытого редактора конфигурации объекта. #635
CHG: Редактор Терминала: оптимизировано положение окна параметров кнопки. #621
CHG: В хинте над иконкой схемы оставлена минимальная информация об объекте. #621

22.02.2014 [ksrs-terminal-server] 3.0.0.56
FIX: Устранена возможность падения в миксере при перегрузке параметров
FIX: Исходящая/входящая подписки могли при "возобновлениях" приводить к падениям приложения
FIX: Не соответствовала протоколу Р1 поведение сервера при перегрузке параметров
FIX: Не освобождался порт после разговора в стеке SIP

23.02.2014 [ksrs-terminal-server] 3.0.0.57
FIX: Под Linux логика обработки РП требовала излишние ресусры CPU. Приводило к искажениям

23.02.2014 [ksrs-terminal-gui] 3.0.0.47, [ksrs-control] 3.0.0.43
FIX: Утечка иконочных ресурсов. Так же устранены libpng warning под Linux

23.02.2014 [ksrs-terminal-gui] 3.0.0.47
FIX: Проигрывание мелодии на удержании включалось и для удерживаемых сессий прослушки

24.02.2014 [ksrs-terminal-gui] 3.0.0.47
ADD: Проигрывание КПВ на исходящих дуплексных вызовах
CHG: Заблокирована возможность выбора неисправных РП в окнах настройки кнопок и акустических сигналов. #630

25.02.2014 [ksrs-terminal-gui] 3.0.0.48
FIX: При смене разговорных приборов на кнопке с активной прослушкой, новые приборы не применялись на сессию прослушки. #634

26.02.2014 [ksrs-terminal-gui] 3.0.0.48
ADD: Переключение активных сессий на разговорные приборы по-умолчанию
     в случае горячего выключения назначенных приборов. #636
CHG: Радиокнопки с функцией удаленного включения-выключения радиостанции:
     добавлен вызов реальных команд и обработка сообщений от РСТ. #624

27.02.2014 [ksrs-control] 3.0.0.43
FIX: Редактор ЦТРC: некорректно работало изменение размера панелей, после изменения размера
     не было возврата в режим перемещения. Теперь работает, но курсор может иногда оставаться в виде 'resize'.

28.12.2013 [ksrs-terminal-snmp] 3.0.0.39
CHG: В агенте ускорена процедура высылки трапов (где-то в 10 раз) - отказались от использования внешний утилиты snmptrap

28.12.2013 [ksrs-collector-snmp] 3.0.0.13
ADD: Поддержка работы с резервным СТКУ в коллекоре (нововведения в протоколе Р3)

28.02.2014 [ksrs-terminal-gui] 3.0.0.48
CHG: При блокировке терминала убрано выставление статуса 'занятости'

28.02.2014 [ksrs-control] 3.0.0.43
ADD: Редактор ЦТРС: добавлена панель для настройки некоторых параметров вкладки на которой находится выбранная кнопка

01.03.2014 [ksrs-control] 3.0.0.43
FIX: Редактор ЦТРС: не сохранялся параметр 'АОН по-умолчанию'
FIX: Редактор ЦТРС: было неудобно задавать размер кнопок вручную

01.03.2014 [ksrs-terminal-gui] 3.0.0.48
ADD: Поддержка параметра 'АОН по-умолчанию'.
     Применяется для исходящих прямых и косвенных вызовов в случае пустого параметра 'АОН' у кнопки.

04.03.2014 [ksrs-terminal-server] 3.0.0.58
FIX: Не корректно анулировались исходящие подписки в случаях: перегрузки параметров и выгрузки сервера
FIX: Графический интерфейс не оповещался об изменении статусов подписок при перегрузке параметров

04.03.2014 [ksrs-control] 3.0.0.43
ADD: Проверка на подключение к БД перед выполнением запросов, и переподключение в случае необходимости

05.03.2014 [ksrs-terminal-gui] 3.0.0.48
FIX: Устранена ещё одна возможная гонка при обновлении конфигурации.
FIX: Удаленное выключение РСТ с одного ЦТРС блокировало соответствующие кнопки РСТ на других ЦТРС навсегда
     (при условии что на этих других ЦТРС отсутствовала кнопки включения данной РСТ).
	 Теперь кнопки радиосвязи на ЦТРС без кнопок удаленного управления питанием РСТ
	 ведут себя адекватно в случаях включения/выключения РСТ с других ЦТРС.

07.03.2014 [ksrs-control] 3.0.0.43
ADD: Редактор состава системного элемента. #576
     Требуется БД с соответствующими изменениями!

11.03.2014 [ksrs-control] 3.0.0.43
CHG: Редактор состава системного элемента: добавлена возможность указания позиции добавляемого элемента,
     если можно добавить более одного элемента. Если для добавления доступен только один экземпляр элемента,
	 то вопрос о позиции не задается.
     Требуется БД с соответствующими изменениями!

12.03.2014 [ksrs-control] 3.0.0.44
ADD: Выдача команд на перезагрузку служб и оборудования
FIX: Редактор ЦТРС: не работали клавишные комбинации с Shift и Ctrl в полях ввода.

12.03.2014 [ksrs-terminal-gui] 3.0.0.48
ADD: Рестарт приложения при получении соответствующей команды с СТКУ. Пока без подтверждения.
FIX: 'АОН по-умолчанию' не применялся на входящих вызовах

13.03.2014 [ksrs-terminal-gui] 3.0.0.48
CHG: Кнопки ПРОТОКОЛ, ВЫХОД, ПОЛНЫЙ ЭКРАН вынесены в отдельное служебное окно "Инструменты" как в старом КАРС.
ADD: В окно "Инструменты" добавлена кнопке перезапуска ГУИ.

14.03.2014 [ksrs-terminal-gui] 3.0.0.48
ADD: Часы

14.03.2014 [ksrs-control] 3.0.0.44
CHG: Редактор ЦТРС: название РСТ можно задавать в несколько строк
CHG: Редактор ЦТРС: размер рабочего поля под панели с кнопками синхронизирован с реальным размером ЦТРС
FIX: Редактор ЦТРС: неправильно сохранялся порядок закладок
FIX: Редактор ЦТРС: не отображалось наличие изменений при перемещении закладок и удалении кнопок

14.03.2014 [ksrs-terminal-server] 3.0.0.59
ADD: Поддержка перезапуска через P1
FIX: Зависание сессий каналов SIP в случаях: симплекс+автоответ

17.03.2014 [ksrs-control] 3.0.0.44
ADD: Редактор ЦТРС: при изменении параметров на странице "Основные настройки" загорается кнопка "Сохранить...". #648
ADD: Редактор ЦТРС: проигрывание выбранных файлов на странице "Звуковые события" в формате G711. Пока с лишним шумом.

17.03.2014 [ksrs-terminal-gui] 3.0.0.48
ADD: На кнопках добавлено отображение номера разговорного прибора.
     Для уменьшения кол-ва информации, номер отображается только если он >=2. #648

18.03.2014 [ksrs-terminal-gui] 3.0.0.48
FIX: Изменен алгоритм поиска кнопки для входящих вызовов. #655
     Теперь вначале жесткий поиск по полному совпадению caller и called,
	 и только в случае когда кнопка не найдёна - лополнительный поиск как раньше (из URI caller-а учитывается только домен).

19.03.2014 [ksrs-control] 3.0.0.44
FIX: Редактор состава элемента: после изменений состава не менялось содержимое информационного окна
ADD: Часы

19.03.2014 [ksrs-terminal-gui] 3.0.0.48
ADD: Подтверждение на Выход и Перезапуск

20.03.2014 [ksrs-terminal-server] 3.0.0.60
FIX: Устранена уязвимость в PJSIP. Эта уязвимость не позволяет процедуре автоматичекого возобновления подписок
     их возобновлять в случае когда идет интенсивный обмен событиями NOTIFY в последние 5 секунд истечения интервала
     подписок. В некоторых случаях это приводило к ислкючительным ситуациям

20.03.2014 [ksrs-control] 3.0.0.44
CHG: Параметры шлюза ЛЭМЗ переведены на русский язык
ADD: Реконнект к БД. Пока кривой, нужно выносить в отдельный поток.

26.03.2014 [ksrs-terminal-gui] 3.0.0.49
FIX: Со стороны СТКУ невозможно поменять присвоенные на кнопку разговорные приборы. #659 #643
     Приборы заданные в конфигурации перебивались локальными настройками ЦТРС.

26.03.2014 [ksrs-control] 3.0.0.44
FIX: Редактор ЦТРС: после закрытия окна редактирования параметров кнопки,
     его можно было открыть обратно только путем переключения страниц редактора. #668
FIX: Изменен механизм работы с временными файлами. Теперь файлы не плодятся до закрытия СТКУ,
     а удаляются сразу после проигрывания или загрузки на ЦТРС.  #666
FIX: Всякие мелочи

27.03.2014 [Кнопочные Библиотеки (влияет и на ksrs-terminal-gui и на ksrs-control)]
FIX: Проблема при отображении на кнопках устройств по-умолчанию. #659

28.03.2014 [ksrs-terminal-gui] 3.0.0.49
FIX: На кнопках не изменяется индикация приборов при горячем отключении/подключении РП. #661

28.03.2014 [ksrs-control] 3.0.0.44
ADD: Редактор ЦТРС: параметр Тангента у радиокнопки. #670

31.03.2014 [ksrs-terminal-gui] 3.0.0.49
ADD: Поддержка привязанной к радиокнопке тангенты, в том числе отображение пиктограммы на кнопке ТНГ. #670

01.04.2014 [ksrs-control] 3.0.0.44
FIX: Окно информации об объекте могло появляться при открытой странице Журнал. #676

01.04.2014 [ksrs-terminal-gui] 3.0.0.49
CHG: Косметика. Раскрашены кнопки. #658

03.04.2014 [ksrs-terminal-gui] 3.0.0.49
FIX: При обновлении до новой конфигурации не всегда активировался таймер отвечающий за разговорные устройства.
     В результате терминал переставал реагировать на нажатия любых кнопок.
FIX: После перезапуска не всегда применялся полноэкранный режим. #680
     Дополнительно, полноэкранный режим сделан включеным по умолчанию при первоначальном запуске.
CHG: Косметические мелочи

07.04.2014 [ksrs-control] 3.0.0.45
ADD: Настройка ЦТРС: новые основные параметры для радиосвязи (4 штуки) - индикация и блокировки. #629

07.04.2014 [ksrs-terminal-gui] 3.0.0.50
FIX: Ужесточен алгоритм поиска кнопки для входящих вызовов. Все вызовы не совпавшие по caller/called
     ни с одной из кнопок становятся косвенными. #655
ADD: Реализован параметр 'Блокировка автоответа на входящие вызовы ГГС во время ведения радиосвязи'. #629
     Работает так - при наличии любой нажатой тангенты РСТ, все входящие вызовы просто моргают желтым
	 без проигрывания звукового оповещения. Если вызов попадает на кнопку с автоответом, то автоответ
	 не производится, вызов тихо моргает как обычный входящий вызов.

08.04.2014 [ksrs-terminal-gui] 3.0.0.50
FIX: Были сломаны симплексные вызовы. Отбивались.
ADD: Поддержка нескольких тангент на одной радио кнопке и оперативное назначение тангент.
     Если назначена одна тангента то её пиктограмма отображается на кнопке ТНГ.
	 Если назначено несколько или 0 то никаких пиктограмм на ТНГ не отображается.
FIX: Терминал не реагировал на нажатия ножной тангенты. #684

08.04.2014 [ksrs-control] 3.0.0.45
ADD: Назначение на радиокнопку нескольких тангент

09.04.2014 [ksrs-terminal-gui] 3.0.0.50
FIX: Не сохранялась оперативная конфигурация из нескольких тангент.
ADD: На кнопке ТНГ теперь отображается нажатая в данный момент тангента.
     Если тангента не захвачена (серая кнопка) то:
       если назначена одна тангента то её пиктограмма отображается на кнопке ТНГ.
	   если назначено несколько или 0 то никаких пиктограмм на ТНГ не отображается.
FIX: Не назначались приборы на кнопки косвенных вызовов.
FIX: Зависали неотвеченные косвенные вызовы если для кнопки был вызван диалог выбора разговорных приборов.
CHG: Диалог выбора разговорных приборов теперь убирается при закрытии тастатуры если он был открыт оттуда.
ADD: Диалог выбора разговорных приборов перерисовывает все кнопки выбора устройств при изменении их состояния в системе.
CHG: Мелкие оптимизации

09.04.2014 [ksrs-terminal-server] 3.0.0.61
ADD: Добавлено возможность для графического интерфейса указывать индикатор статуса использования радиостанции

11.04.2014 [ksrs-terminal-gui] 3.0.0.50
FIX: Тангента включалась даже при неактивной кнопке ПРД (было сломано 08.04.2014).
FIX: Починен запрет на взаимное прослушивание.
FIX: Отсутствовала моргающая индикация на вкладке при ведении радиосвязи

11.04.2014 [ksrs-terminal-server] 3.0.0.62
CHG: Теперь индицируется занятость на приеме радиостанции только в случае детектирования голоса

14.04.2014 [ksrs-control] 3.0.0.45
ADD: Редактор ЦТРС: две опции на управление индикацией пропущенных вызовов

14.04.2014 [ksrs-terminal-gui] 3.0.0.50
FIX: Радио: индикация детектора голоса на ПРМ не срабатывала в некоторых случаях
ADD: Радио: блокировка всех ПРМ при активизации любой передачи по РСТ
ADD: ГГС: индикация пропущенных вызовов и прямых и косвенных
ADD: ГГС: Поддержка опций управления индикацией пропущенных вызовов

15.04.2014 [ksrs-terminal-gui] 3.0.0.50
CHG: Радио: перерисована кнопка питания, теперь отображение пиктограммы не зависит от Linux/Windows
CHG: При включенной опции "Индикация пропущенных симплексных вызовов" все входящие симплексные вызовы считаются пропущенными
CHG: Расширено поведение опции 'Блокировка автоответа на входящие вызовы ГГС во время ведения радиосвязи'. #629
     Входящие симплексные вызовы становятся обычными вызовами, т.е. моргают в ожидании ответа.
FIX: Радио: акустический сигнал об ошибочном нажатии на экранную ТНГ не выдавался если был нажат только ПРМ
ADD: Настройка разговорных приборов для входящих косвенных вызовов путем нажатия на кнопку открытия окна косвенных вызовов
FIX: В Номеронабирателе не запоминался последний выбранный шлюз. #692
FIX: Неправильный формат даты в истории входящих косвенных вызовов. #652
ADD: Поддержка настроек видимости функциональных кнопок
ADD: Номеронабиратель: cохранение набранных номеров в историю и набор из истории

15.04.2014 [ksrs-control] 3.0.0.45
ADD: Редактор ЦТРС: страница с простейшей настройкой видимости функциональных кнопок

16.04.2014 [ksrs-control] 3.0.0.45
FIX: Редактор ЦТРС: не сразу индицировались изменения параметра Циркуляр. #671
CHG: Мониторинг: в имена элементов замены добавлен параметр PLACE и добавлен вывод SIGNATURE

16.04.2014 [ksrs-terminal-gui] 3.0.0.50
FIX: Номеронабиратель: набор номеров был поломан 15.04.2014
ADD: Занятость тангенты теперь индицируется даже если ни ПРМ ни ПРД не нажаты. #534
FIX: При ведении радиосвязи на одном из ЦТРС, кнопки ПРД (если они активированы) на других ЦТРС
     мигают желтым цветом (как будто с них ведется передача). #534
ADD: Радио: восстановление активных ПРМ при рестарте терминала. #679

17.04.2014 [ksrs-terminal-gui] 3.0.0.50
ADD: Радио: восстановление активных ПРД при рестарте терминала. #679
ADD: Моргание закладки при активном входящем симплексном вызове и при входящем дуплексном на кнопку с автоответом. #649
FIX: Входящий вызов при определённых условиях мог попасть в Номеронабиратель

18.04.2014 [ksrs-terminal-gui] 3.0.0.50
CHG: Радио: ПРМ той РСТ по которой включена передача теперь блокируется всегда.
     А при включенной опции "Блокировка всех ПРМ ..." блокируются все ПРМ.
ADD: Поддержка параметра "Использовать тангенту РП "Телефонная трубка" в качестве функции ОТБОЙ"
ADD: Поддержка параметра "Время ожидания ответа на исходящие вызовы"
ADD: Номеронабиратель: поддержка записной книжки настраивающейся на СТКУ. Функция набора ещё требует доработки.

18.04.2014 [ksrs-control] 3.0.0.45
ADD: Редактор ЦТРС: параметр "Использовать тангенту РП "Телефонная трубка" в качестве функции ОТБОЙ"
ADD: Редактор ЦТРС: параметр "Время ожидания ответа на исходящие вызовы"
ADD: Редактор ЦТРС: простейший редактор записной книжки

21.04.2014 [ksrs-terminal-gui] 3.0.0.50
CHG: Номеронабиратель: поддержка набора абсолютных (sip:name@domain) номеров из записной книжки

22.04.2014 [ksrs-control] 3.0.0.45
FIX: При удалении РП Гарнитура из состава ЦТРС, обновление конфигурации выдавало ошибку. #693

28.04.2014 [ksrs-terminal-gui] 3.0.0.50
ADD: При обновлении конфигурации все вспомогательные окна скрываются. #697
ADD: Если тангента трубки выбрана на ОТБОЙ, то её выбор для РСТ запрещен.
     Если трубка уже привязана к РСТ, то реакции на неё не будет.

30.04.2014 [ksrs-control] 3.0.0.45
FIX: Некорректно сбрасывался фильтр на странице Журнал. #695

30.04.2014 [ksrs-terminal-gui] 3.0.0.50
CHG: Сделано чтобы кнопка ОБЩИЙ ОТВЕТ загоралась при любых вызовах кроме симплекса.
     Раньше она загоралась только на косвенные вызовы.

06.05.2014 [ksrs-control] 3.0.0.45
ADD: Редактор ЦТРС: новый параметр Радиокнопок 'Сопряженные РСТ'. #662

07.04.2014 [ksrs-terminal-gui] 3.0.0.50
ADD: Поддержка сопряженности РСТ. #662

08.04.2014 [ksrs-terminal-gui] 3.0.0.50
ADD: Сброс привязок РП к кнопкам на значения по умолчанию (которые приходят с СТКУ в составе настроек ГУИ). #703

10.04.2014 [ksrs-database]
CHG: Теперь порты коммутатора считаются элементами замены
CHG: В процедуре SNMP_RE_ELEMENT_CREATED значение OID_BY_PLACE получило дополнительный смысл. Теперь неопределенный
     смысл свойству дают значения 0 или NULL в таблицах TB_SNMP_PARAMS и TB_SNMP_PARAM_STATUSES. Значение большее
     нуля указывает, что OID создаваемой переменной должен быть такой: OID=BASE_OID.(PLACE+OID_BY_PLACE-1)
CHG: Теперь процедура SNMP_GET_VAR4SE возвращает дополнительно параметр PARAM_ID

10.04.2014 [ksrs-collector-snmp] 3.0.0.15
ADD: Введена возможность применять внутри системного элемента для различных элементов замены одинаковые переменные
FIX: Утечка памяти в процедуре сканирования переменных
INF: Эта версия корректно будет работать только с БД от 10.04.2014

13.04.2014 [ksrs-database]
CHG: Изменены процедуры GET_LIST_UNUSED_RE и ADD_REMOVABLE_ELEMENT.
     Разрешено добавлять любое кол-во элементов замены в системный объект.

13.05.2014 [ksrs-control] 3.0.0.45
CHG: Редактор состава объекта: разрешено добавлять любое кол-во элементов замены.
ADD: Редактор состава объекта: переименование элемента.
FIX: Долгий запуск СТКУ при большом кол-ве записей в Журнале. Временный фикс до оптимизации БД.

19.05.2014 [ksrs-database]
Поддержка многопользовательской авторизации.
ADD: USER_ADD, USER_DEL, USER_LOGIN
CHG: TB_USERS_BI0

19.05.2014 [ksrs-control] 3.0.0.46
ADD: Поддержка пользовательской авторизации. Требуется БД от 19.05.2014.
     Настройка пользователей производится в Настройки системы\Основные.
	 В пустой БД уже создан один пользователь - root без пароля.

20.05.2014 [ksrs-terminal-gui] 3.0.0.50
FIX: Зацикливание микширования при документировании Радио и нажатой тангенте.

21.05.2014 [ksrs-terminal-gui] 3.0.0.50
FIX: Сброс привязок РП к кнопкам на значения по умолчанию: не сбрасывался прибор на передачу
ADD: Сброс привязок РП к кнопкам на значения по умолчанию: добавлен сброс назначенных тангент
ADD: Кнопка Сервисы. Туда перешел Выход и Калибровка.

21.05.2014 [ksrs-control] 3.0.0.46
ADD: Редактор ЦТРС: добавлена кнопка Сервисы.

21.04.2014 [ksrs-collector-snmp] 3.0.0.15
FIX: Не инициализировалась конвертация строк в UTF8. Портилась кириллица в патчах.

22.05.2014 [ksrs-terminal-gui] 3.0.0.51
CHG: Изменен приоритет цветовой индикации на кнопка ГГС: наивысший у прослушивания, затем занятость, затем пропущенный вызов.
FIX: Попытка побороть проблемы при встречных симплексных вызовах

27.05.2014 [ksrs-control] 3.0.0.46
ADD: Редактор ЦТРС: параметр кнопки 'Полудуплекс'

27.05.2014 [ksrs-terminal-gui] 3.0.0.51
ADD: Поддержка кнопок типа 'Полудуплекс'.

27.05.2014 [ksrs-terminal-server] 3.0.0.63
ADD: Поддержка установки IP Алреса с СТКУ

28.05.2014 [ksrs-control] 3.0.0.47
ADD: Поддержка контроля соединения в транспорте клиента P1

28.05.2014 [ksrs-terminal-server] 3.0.0.64
FIX: События ответа на кнотроль соединения и регистрацию высылалсоь только в уровень 0

28.05.2014 [ksrs-terminal-gui] 3.0.0.51
FIX: Полудуплекс: неверно обрабатывались входящие на кнопку вызовы
FIX: На кнопках не всегда обновлялась пиктограмма РП прибора

29.05.2014 [ksrs-control] 3.0.0.47
ADD: Настройка ЦТРС: параметр для радиосвязи "Блокировка автоответа на входящие вызовы ГГС во время активного приема по Радио"
ADD: В папку /sounds можно положить звуковые файлы в формате PCM,
     которые будут проигрываться при появлении событий мониторинга соответствующего приоритета.
	 На данный момент будут работать только следующие имена файлов: emergency.wav, error.wav, alarm.wav, warning.wav.

29.05.2014 [ksrs-terminal-gui] 3.0.0.51
ADD: "Блокировка автоответа на входящие вызовы ГГС во время активного приема по Радио"
FIX: Прослушивание: двоение приема от РСТ

30.05.2014 [ksrs-control] 3.0.0.47
FIX: Не проигрывался звук на события мониторинга. Переделано на другой аудиодвижок.
ADD: Кнопка позволяющая временно отключить звуковые оповещения.
     Левый нижний угол главного окна, под окном протокола.

30.05.2014 [ksrs-terminal-gui] 3.0.0.51
ADD: Предварительная поддержка устройств типа AUDIO.
FIX: Не запускалась утилита калибрации на определённой конфигурации железа

02.06.2014 [ksrs-terminal-gui] 3.0.0.51
CHG: Убрана интеллектуальная блокировка интерфейса терминала при потере связи с сервером.
     Теперь при восстановлении связи всегда происходит безусловная разблокировка.

02.06.2014 [ksrs-terminal-server] 3.0.0.65
FIX: Исключена вероятность паления, если событие о разрушении сигнальной сессии приходит раньше чем событие
     об очистке контекста микшера

03.06.2014 [ksrs-terminal-gui] 3.0.0.51
CHG: Таймаут на пинг между ГУИ и сервером увеличен с 10 до 30 секунд.

04.06.2014 [ksrs-control] 3.0.0.48
CHG: Звук оповещения об авариях играет раз в 5 секунд пока хотя бы у одного элемента на схеме аварийное состояние.

04.06.2014 [ksrs-terminal-server] 3.0.0.66
FIX: Команды протокола Р1 увеличивали интервал жизни соединения на 5 секунд от момента прихода команды, а
     не от момента истечения времени жизни предыдущего интервал, как это предписывает Р1

04.06.2014 [ksrs-collector-snmp] 3.0.0.17
ADD: Поддержка расширений ППРП больше чем это оговорено комплектов (в том числе и аудио устройства)

06.06.2014 [ksrs-control] 3.0.0.49
ADD: Пункт меню Файл\Резервное копирование БД. На данный момент вызывается системный файловый менеджер с указанием
     директории с резервными копиями БД.

07.06.2014 [ksrs-control] 3.0.0.49
CHG: Пункт меню Файл\Восстановление БД.

18.06.2014 [ksrs-terminal-gui] 3.0.0.52
ADD: Возможность переадресации входящих вызовов. Функциональная кнопка 'ПЕРЕАДРЕСАЦИЯ'.

18.06.2014 [ksrs-control] 3.0.0.50
ADD: Настройки ЦТРС\Функциональные кнопки: добавлена кнопка Переадресация.

18.06.2014 [ksrs-terminal-server] 3.0.0.67
FIX: Команда от [ksrs-terminal-gui] на переадресацию вызова приводила к выдаче другой команды (SIP INFO) и падению
ADD: Поддежка установки IP адреса под Windows

23.06.2014 [ksrs-control] 3.0.0.51
FIX: В окне конфигурации объектов типа Шлюз РИНО, ADDPACK и т.п. иногда нельзя было ввести точку и пробел в поле "Название".

24.06.2014 [ksrs-terminal-gui] 3.0.0.53
FIX: Переделана функция переадресации вызовов. Теперь обновление конфигурации не влияет на активную переадресаци.
CHG: Убран отбой косвенных симплексных вызовов. Теперь они ведут себя как обычные косвенные дуплексные вызовы.

25.06.2014 [ksrs-terminal-gui] 3.0.0.53
FIX: Устранено возможное появление служебной информации ("SIMPLEX" и т.п.) на кнопках косвенных вызовов.

25.06.2014 [ksrs-control] 3.0.0.52
ADD: В БД, в таблице типов системных элементов добавилось поле с пиктограммой. PNG размером 48x48.
     На схеме будет отображаться пиктограмма из БД, если она там есть. Иначе - из внутренних ресурсов СТКУ.

25.04.2014 [ksrs-collector-snmp] 3.0.0.15
ADD: Патч #5. Поддержка иконок для типов системных элементов.

26.06.2014 [ksrs-control] 3.0.0.53
ADD: Шлюз ЛЭМЗ: параметр 'Общее: подтип сигнализации канала'

27.06.2014 [ksrs-control] 3.0.0.54
FIX: После смены пользователя с Техника на Админа не появлялись пункты меню "Настройки объекта" и т.п... #727

09.07.2014 [ksrs-terminal-server] 3.0.0.68
INF: Собран релиз

09.07.2014 [ksrs-terminal-gui] 3.0.0.54
INF: Собран релиз

09.07.2014 [ksrs-terminal-snmp] 3.0.0.40
INF: Собран релиз

09.07.2014 [ksrs-collector-snmp] 3.0.0.19
INF: Собран релиз

09.07.2014 [ksrs-control] 3.0.0.55
INF: Собран релиз

10.07.2014 [ksrs-control] 3.0.0.56
CHG: Шлюз ЛЭМЗ: сделана видимость 4-х интерфейсов и 2 каналов в каждом интерфейсе

11.07.2014 [ksrs-control] 3.0.0.57
ADD: После изменения состава ЦТРС, в БД скручивается номер версии конфигурации. #693

14.07.2014 [ksrs-terminal-server] 3.0.0.69
FIX: Были неработоспособны подписки на регистратор (в т.ч. случаи, требующие регистрации)

16.07.2014 [ksrs-control] 3.0.0.58
FIX: При первом же успешном подключении (без реконнекта) СТКУ к ksrs-terminal-server
     начинался слишком частый сетевой обмен между ними (ping), что приводило к высокой загрузке ЦПУ

18.07.2014 [ksrs-control] 3.0.0.59
FIX: Редактор терминала: некорректно сохранялись названия кнопок содержащие спецсимволы типа кавычек, амперсандов и т.п.  #730
FIX: Ошибка выбора номера интерфейса при настройке и синхронизации параметров шлюза радио

24.07.2014 [ksrs-terminal-gui] 3.0.0.54
FIX: Падение при сбросе зависших по причине сетевых разрывов входящих вызовов. #732

08.08.2014 [ksrs-terminal-gui] 3.0.0.56
ADD: Возможность подстраивать частоту активных РСТ

08.08.2014 [ksrs-terminal-server] 3.0.0.70
ADD: Вывод в лог частоту и канал РСТ

08.08.2014 [ksrs-terminal-gui] 3.0.0.57
CHG: Введена возможность дополнительной идентификации ресурса для подписки

08.08.2014 [ksrs-terminal-server] 3.0.0.71
ADD: Добавлена поддерка дополнительной идентификации ресурса для подписки

11.08.2014 [ksrs-terminal-server] 3.0.0.72
CHG: Сделана очередная попытка отучить библиотеку PJSIP "умирать" на "коротких" подписках

12.08.2014 [ksrs-control] 3.0.0.61
FIX: Было "отломлено" редактирование подписок

03.09.2014 [ksrs-control] 3.0.0.62
CHG: Редактирование списка пользователей сделано доступным только Администраторам. #727

03.09.2014 [ksrs-collector-snmp] 3.0.0.20
ADD: Patch #6. Добавлен CASCADE на ключ в таблице TB_USERS_LOGIN, чтобы история чистилась при удалении пользователя.
     Иначе происходил VIOLATION OF FOREIGN KEY.

03.10.2014 [ksrs-collector-snmp] 3.0.0.21
ADD: Patch #7. Удаление протокольных записей при удалении системных элементов и элементов замены. #737
ADD: Patch #8. Предварительные изыскания по поводу последствий удаления РП из состава объекта. #693
               Добавлена поддержка статуса системного элемента "На техобслуживании"

03.10.2014 [ksrs-control] 3.0.0.63
ADD: В KARSControl.conf вынесены параметры настройки отображения конфигурации шлюзов ЛЭМЗ:
     [LEMZGW]
     InterfaceCount=1
     ChannelCount=1
ADD: Возможность постановки любого системного элемента "на техобслуживание".
     Для элемента в таком статусе гасятся сообщения мониторинга и прочие мигалки.

05.10.2014 [ksrs-control] 3.0.0.64
FIX: Для элементов находящихся на ТО СТКУ всё равно издавал писк на плохой статус элемента
FIX: Пустые списки выбора звуковых приборов
CHG: Обновлён скрипт бэкапа БД

05.10.2014 [ksrs-terminal-gui] 3.0.0.59
FIX: Невозможно было назначить разговорный прибор для звуковых сообщений если изначально он не был задан со стороны СТКУ

07.10.2014 [ksrs-control] 3.0.0.64
CHG: Сортировка элементов в окне 'Информация о....'

09.10.2014 [ksrs-collector-snmp] 3.0.0.22
ADD: Patch #9. Ускорение запроса для страницы Журнал в СТКУ

09.10.2014 [ksrs-control] 3.0.0.65
CHG: Изменена логика добычи данных на странице Журнал.
     ТЕПЕРЬ ОТСУТСТВУЕТ ВИСЯЩАЯ ТРАНЗАКЦИЯ В БД, ЧТО В ТЕОРИИ ДОЛЖНО ИСКЛЮЧИТЬ НЕПОНЯТНОЕ РЕГУЛЯРНОЕ ПОВРЕЖДЕНИЕ БД.

15.10.2014 [ksrs-terminal-gui] 3.0.0.60
FIX: Тормоза при интенсивном сетевом обмене уменьшены в ~4 раза. Виновато было логирование.

16.10.2014 [ksrs-terminal-gui] 3.0.0.60
FIX: Пропадали закладки при обновлении конфигурации или перезапуске сервера, если перед этим интерфейс был заблокирован (серый).
FIX: Не всегда происходило с первого раза обновление настроек со стороны СТКУ

16.10.2014 [ksrs-control] 3.0.0.66
CHG: Редактор интерфейса ЦТРС: горячие кнопки изменения размера и перемещения кнопок теперь такие:
     Ctrl+Shift+стрелки - размер, Ctrl+Shift+Alt+стрелки - перемещение

23.10.2014 [ksrs-terminal-server] 3.0.0.74
FIX: Ошибка при выгрузке приложения в случае наличия активной SIP-сессии

24.10.2014 [ksrs-terminal-gui] 3.0.0.61
FIX: Кнопки ГГС с пустым АОН всегда генерили полнодуплексные вызовы, при любых прочих настройках
     (даже если кнопка настроена как симплексная). #726

28.10.2014 [ksrs-collector-snmp] 3.0.0.23
ADD: Patch #10. Добавлена пустая начальная конфигурация голосовых сообщений.

28.10.2014 [ksrs-control] 3.0.0.67
FIX: Редактор ЦТРС: проблемы при начальном конфигурировании только что созданных ЦТРС
ADD: Пункты меню Файл\Управление БД теперь открывают не 'файловый менеджер',
     а диалоги для запуска скриптов резервного копирования и восстановления БД
ADD: В окно настроек конфигурации 'прочих' шлюзов добавлен веб-браузер для доступа
     к веб-интерфейсу конфигурируемого объекта

30.10.2014 [ksrs-control] 3.0.0.68
CHG: Редакторы конфигурации шлюзов: расширена авторизация. Вначале пробуем admin:admin, затем root:router, затем спрашиваем у пользователя

30.10.2014 [ksrs-terminal-server] 3.0.0.75
FIX: При одновременном старте графического интерфейса и сервера терминала существовала вероятность того, что сервер мог выслать сообщениие
     о статусе подписки, которая ещё не запустилась. Таким образом могли возникнуть сообщения о статусе адреса, состоящие из непроиниализировнных строк.
     Это, в свою очередь, могло приводить к нарушению работы логики графического интерфейса

02.11.2014 [ksrs-control] 3.0.0.69
CHG: Бэкап/восстановление БД: добавлен запуск скриптов через sudo.
     Файл примера конфигурации sudoers лежит в инсталляторе: Setup\ksrs_sudoers.
     его нужно положить в etc/sudoers.d

04.11.2014 [ksrs-terminal-gui] 3.0.0.62
CHG: Пересборка изменений в черном ящике BSS

04.11.2014 [ksrs-control] 3.0.0.70
CHG: Бэкап/восстановление БД: скорректированы имена вызываемых скриптов:
       DB_BACKUP_SCRIPT "sudo /var/ksrs/base/scripts/fdb_backup_new.sh"
       DB_RESTORE_SCRIPT "sudo /var/ksrs/base/scripts/fdb_restore.sh"
     Файл примера Setup\ksrs_sudoers так же изменён.
     Мелкие фиксы в диалогах работы с БД.

06.11.2014 [ksrs-control] 3.0.0.69
ADD: Редакторы конфигурации шлюзов: в веб-браузер добавлена кнопка для открытия ссылок во внешнем браузере
CHG: Немного улучшено поведение СТКУ при потере связи с БД

07.11.2014 [ksrs-terminal-gui] 3.0.0.63
FIX: BSS: при включении/выключении ПРМ, ядро bss не оповещалось о том что канал исключен из используемых
FIX: BSS: не переключались разговорные приборы в след за активным каналом
FIX: BSS: при включении/выключении кнопки управления BSS не запоминался и не восстанавливался последний активный канал

10.11.2014 [ksrs-terminal-server] 3.0.0.76
ADD: Добавлена поддержка SIP OPTIONS для контроля за доступностью ресурсов на сети
ADD: В протокол Р1 добавлена поддержка контроля за доступностью сетевых интерфейсов

11.11.2014 [ksrs-terminal-gui] 3.0.0.64
FIX: BSS: при включении ПРМ после предварительного выключения, ядро bss не оповещалось о том что канал снова используется.
     Вследствие этого можно было наблюдать несколько одновременно активных каналов в группе
FIX: BSS: возникало событие отключенной тангенты, хотя действий с тангентой никаких не производилось

12.11.2014 [ksrs-terminal-gui] 3.0.0.65
ADD: Отображение состояний сетевых интерфейсов

12.11.2014 [ksrs-terminal-server] 3.0.0.77
FIX: Не диагностировалось полное пропадание сетевого интерфейса
ADD: Добавлена логика перехода на резерв системы управления удаленной радиостанцией
ADD: Для конфигурирования списка интерфейсов, за которыми наблюдает сервер, необходимо в
     файле конфигурации krs-terminal-server.conf в разделе [MAIN] указать через запятую список имен
     этих интерфейсов в параметре NetworkIFs

13.11.2014 [ksrs-terminal-gui] 3.0.0.65
FIX: Отображение состояний сетевых интерфейсов: анализировались не все флаги

14.11.2014 [ksrs-terminal-server] 3.0.0.78
ADD: Добавлена в протокол и код сервера поддержка селективного вызова на радиостанции и
     возможность перехода на дублирующие радиостанции при удаленном управлении

18.11.2014 [ksrs-control] 3.0.0.71
FIX: Детектор потери связи с БД слишком часто делал переподключение даже без реальной потери связи

19.11.2014 [ksrs-collector-snmp] 3.0.0.24
FIX: При неудачной попытке начального сканирования статусов элементов (например, недоступности ВМ - вычислительного модуля),
     не происходило пересканирования составляющих элементов. В этом случае схемы, расчитанные на работу по trap-ам работали
     не корректно!

19.11.2014 [ksrs-collector-snmp] 3.0.0.25
ADD: В базе появилась новая процедура(SNMP_RESET_SE_VARS), дающая возможность сбросить все статусы и значения переменных
     для отдельного системного элемента
FIX: Сброс (инициализация) переменных затрагивала переменные, относящиеся к trap-ам
CHG: Теперь процедура пересканирования значений переменных для системного элемента случается один раз в момент снятия
     статуса сетевой недоступности (4). Предыдущая реализация страдала избыточным количеством перезапросов

19.11.2014 [ksrs-control] 3.0.0.72
ADD: В редактор конфигурирования шлюзов добавлен вывод типа системного элемента
CHG: На схеме обновлены пиктограммы инверторов

20.11.2014 [ksrs-collector-snmp] 3.0.0.26
FIX: В предыдущем патче базы для функции SNMP_RESET_ALL_VARS не извлекался флаг IS_TRAP_OID. Таким образом анализ производился
     по неопределенной переменной
FIX: В предыдущем патче базы не учитывалась возможность конфигурирования SNMP переменной с неопределенным флагом IS_TRAP_OID

26.11.2014 [ksrs-terminal-gui] 3.0.0.66
FIX: Не менялось состояние кнопок Радио при наличии активных подписок на соответствующие шлюзы ЛЭМЗ

27.11.2014 [ksrs-terminal-gui] 3.0.0.67
CHG: При детектировании ресурса в подписках теперь не учитывается индикатор схемы (SIP или TEL)

27.11.2014 [ksrs-terminal-server] 3.0.0.79
FIX: При обновлении конфигурации "терялись" настройки сетевых интерфесов для наблюдения
CHG: Изменен формат параметра CalledID для сессий каналов типа "РАДИО". Было: <IP-адрес>:<Номер порта>
     стало: RADIO-PORT-<Номер порта>@<IP-адрес>

27.11.2014 [ksrs-terminal-server] 3.0.0.80
FIX: В предыдущей версии "отломились" SIP-вызова

28.11.2014 [ksrs-control] 3.0.0.73
ADD: Перезачет из БД текущих статусов элементов при реконнекте к контроллеру

03.12.2014 [ksrs-terminal-gui] 3.0.0.68
CHG: Изменена логика работы с сессиями радиокнопок для уменьшения нагрузки сервера на ЦПУ.
     Изменения затронули как стандартные функции кнопок так и "Питание" и "BSS".

03.12.2014 [ksrs-control] 3.0.0.74
CHG: Для радиокнопки типа "BSS выключатель" разрешено не назначать радиостанцию (выбор оборудования).

06.12.2014 [ksrs-terminal-gui] 3.0.0.69
ADD: Поддержка работы радиостанций в составе циркуляра ГГС.

06.12.2014 [ksrs-control] 3.0.0.75
ADD: Разрешено добавление радиостанций в состав циркуляра кнопки ГГС.

08.12.2014 [ksrs-terminal-gui] 3.0.0.70
FIX: Не включалось прослушивание на кнопках ГГС с АОН по-умолчанию.
CHG: Кнопки ГГС с пустым адресом для исходящих вызовов сделаны недоступными по-умолчанию.

08.12.2014 [ksrs-control] 3.0.0.76
CHG: Редактор ЦТРС: Подписки: добавление подписок на все радиошлюзы заменено
     на добавление только доступных шлюзов (у которых в таблице "RADIO-подключения" доступность = "да").

10.12.2014 [ksrs-control] 3.0.0.77
ADD: Меню Файл\Питание: перезагрузка и завершение работы. Под Linux выполняется через sudo,
     поэтому требуется настройка sudoers, например чтобы команду shutdown мог выполнить весь user или процесс СТКУ

11.12.2014 [ksrs-control] 3.0.0.77
ADD: Поддержка удаленного завершения работы ЦТРС

11.12.2014 [ksrs-collector-snmp] 3.0.0.27
ADD: Добавлен мониторинг нового инвертора формата 1U

12.12.2014 [ksrs-control] 3.0.0.78
FIX: При обновлении схемы на резервном СТКУ после добавления или удаления объектов на основном СТКУ
     некорректно удалялись старые TCP подключения к ЦТРС, что в итоге приводило к якобы недоступным ЦТРС
     (серые пиктограммы на схеме)

12.12.2014 [ksrs-terminal-gui] 3.0.0.71
FIX: Статусы удаленных ЦТРС полученные по подпискам обрабатывались с 2-хсекундной задержкой.
     Визуально это проявлялось так: кнопка ЦТРС оставалась оранжевой в течение 2-х секунд после завершения разговора.

17.12.2014 [ksrs-terminal-server] 3.0.0.83
CHG: Подключена ранее отключенная логика работы с системными аудиоустройствами

19.12.2014 [ksrs-terminal-server] 3.0.0.84
ADD: реализован адаптивный jitter buffer для потока звуковых данных аудиоустройства
CHG: убран тайм-аут на перезагрузку и выключение вычислительного модуля терминалаа

24.12.2014 [ksrs-terminal-gui] 3.0.0.72
ADD: ВНС: в дополнение к ПРМ теперь так же включается и ПРД
CHG: ВНС: логика сопряженности РСТ отключается на время работы этих РСТ в режиме ВНС

24.12.2014 [ksrs-control] 3.0.0.79
ADD: Редактор шлюза ЛЭМЗ: вывод имени файла паттерна вместо содержимого.
     Файлы всех паттернов должны находиться в папке patterns рядом с СТКУ.

29.12.2014 [ksrs-terminal-gui] 3.0.0.73
FIX: Падение терминала при отключении РП назначенных на РСТ и так же являющихся приборами по-умолчанию

05.01.2015 [ksrs-collector-snmp] 3.0.0.28
ADD: Корректировки скриптов сканирования сетевых портов (patch 15)
FIX: Ошибочное срабатывание индикатора изменений, в некоторых случаях, при сохранении переменных (patch 15)
FIX: Вместо вызова процедуры сброса переменных одного системного элемента вызывалась процедура сброса всех

12.01.2015 [ksrs-collector-snmp] 3.0.0.29
FIX: В patch 15 добавлена принудительная корректировка таблицы TB_SYS_ELEMENT_TYPES с целью убедится в наличии
     обоих поддерживаемых коммутаторов Advantech

12.01.2015 [ksrs-control] 3.0.0.80
FIX: Попытка починить падения СТКУ при получении события об изменении объекта с другого СТКУ через Систему Мониторинга

16.12.2014 [ksrs-terminal-gui] 3.0.0.74
FIX: Падение терминала при определённом нажатии на кнопки сопряженных РСТ.
     Возникала ситуация при которой были одновременно активированы ПРМ двух сопряженных РСТ,
     что вызывало бесконечный цикл в логике сопряженности и приложение в итоге падало.

17.12.2014 [ksrs-terminal-gui] 3.0.0.75
CHG: ВНС: обновлено ядро, введена задержка реакции на освобождение тангенты

19.01.2015 [ksrs-control] 3.0.0.81
ADD: Редактор Терминала: временно добавлена настройка низкоуровневых параметров ВНС

19.01.2015 [ksrs-terminal-gui] 3.0.0.76
CHG: ВНС: обновлено ядро
ADD: ВНС: применение параметров ВНС полученных с СТКУ
FIX: ВНС: тангенты включались одновременно для всех РСТ в группе, а не только для активной в данный момент РСТ
FIX: ВНС: после отключения ВНС на ПРМ не возвращались назначенные разговорные приборы

20.01.2015 [ksrs-control] 3.0.0.81
ADD: В основное окно добавлен индикатор наличия связи с Системой Мониторинга

20.01.2015 [ksrs-terminal-gui] 3.0.0.77
CHG: ВНС: обновлено ядро
FIX: ВНС: экранные кнопки тангент в определенных случаях не отключали динамики (РП назначенные на ПРМ)

21.01.2015 [ksrs-terminal-gui] 3.0.0.78
FIX: ВНС: не всегда включались назначенные на ПРД разговорные приборы при включении ВНС с одновременной активацией кнопок ПРМ и ПРД.
     Проблема не наблюдалась при наличии уже активированных ПРМ и ПРД _ДО_ включения ВНС.

22.01.2015 [ksrs-collector-snmp] 3.0.0.31
FIX: Корректировка логики индикатора 2-го инвертора 2U (патч 16) - синтаксическая ошибка
FIX: Исправлена ошибка фиксации ещё не актуального статуса. Приводило к некорректным индикациям статусов элементов замены

22.01.2015 [ksrs-terminal-gui] 3.0.0.79
FIX: Радиокнопки: в версии .78 случайно вернулся кусок старого кода который поломал работу экранных радиокнопок.
     После использования экранной тангенты отключался РП ПРД.

23.01.2015 [ksrs-terminal-gui] 3.0.0.80
ADD: Циркуляр: новый параметр, если вызываемый по циркуляру абонент недоступен то использовать для вызова механизм Вторжения.

23.01.2015 [ksrs-control] 3.0.0.82
ADD: Редактор ЦТРС: новый параметр для применения механизма Вторжения в Циркуляре
ADD: Редактор шлюза ЛЭМЗ: добавлены параметры RCSelectInterface, RCSelectChannel, RadioTypeCall, Type

26.01.2015 [ksrs-collector-snmp] 3.0.0.32
ADD: Патч 17: новые процедуры get_terminal_ui_versions и get_ui_conf_list.
     Поддержка возможности загружать различные конфигурации ЦТРС в редакторе СТКУ

26.01.2015 [ksrs-control] 3.0.0.83
ADD: Редактор ЦТРС: возможность открывать другие конфигурации ЦТРС

27.01.2015 [ksrs-control] 3.0.0.84
FIX: Падение СТКУ при получении изменений от мониторинга (со второго СТКУ),
     если при этом в нём открыт какой либо редактор (шлюза, терминала...)

28.01.2015 [ksrs-terminal-gui] 3.0.0.81
FIX: Чем дольше работал терминал тем больше появлялось тормозов при работе с кнопками.
     Разрасталась очередь подписочных событий AddressStatus. Никогда не удалялись статусы тех элементов
     которые реально отсутствуют в текущей конфигурации конкретного ЦТРС.
ADD: Активность ВНС запоминается и восстанавливается при обновлении конфигурации или перезапуска ЦТРС

29.01.2015 [ksrs-terminal-gui] 3.0.0.82
FIX: Неадекватно работал циркуляр состоящий только из одних Радиокнопок.
FIX: Симплексный вызов на принимающей стороне отбивался при попытке нажатия на зеленую кнопку вызывающей стороны.
     Сейчас отбой заблокирован и добавлено воспроизведение сигнала "Неверное нажатие".

29.01.2015 [ksrs-terminal-server] 3.0.0.85
FIX: Ликвидирована утечка памяти при отсоединение клиента протокола Р1 (~64K на соединение)
FIX: Ликвидирована утечка памяти при нажатии(отжатии) тангенты (~60 байтов на действие)

30.01.2015 [ksrs-terminal-gui] 3.0.0.83
CHG: Обновлён модуль ВНС.

02.02.2015 [ksrs-control] 3.0.0.85
ADD: Редактор ЦТРС: новый параметр Радиокнопок - отправка сообщений в систему пеленга

02.02.2015 [ksrs-terminal-gui] 3.0.0.84
FIX: При прослушивании РСТ на время активности гарнитуры не отключался поток ПРМ, хотя даже РП от ПРМ отключался
ADD: Выдача команд для системы пеленга радиосвязи

02.02.2015 [ksrs-terminal-server] 3.0.0.86
ADD: Добавлена возможность передачи пеленга на систему наблюдения

03.02.2015 [ksrs-terminal-server] 3.0.0.87
FIX: При высылке пеленга указывалась не верная частота

04.02.2015 [ksrs-control] 3.0.0.86
ADD: Редактор ЦТРС: возможность копировать кнопки на другие панели и страницы

05.02.2015 [ksrs-terminal-gui] 3.0.0.85
CHG: На время работы ВНС, аппаратные тангенты назначенные на кнопку ВНС 'назначаются' на все радиокнопки группы.
     После отключения ВНС, радиокнопки группы возвращаются к 'своим' тангентам.

10.02.2015 [ksrs-terminal-gui] 3.0.0.86
FIX: В некоторых случаях некорректно работала логика назначения механических тангент на радиокнопки
     на время их работы в режиме ВНС.

12.02.2015 [ksrs-control] 3.0.0.87
CHG: Редактор ЦТРС: возможность задавать частоту РСТ до третьего знака после запятой

12.02.2015 [ksrs-terminal-gui] 3.0.0.87
ADD: Вывод частоты на радиокнопках с точностью до третьего знака после запятой
CHG: Если частота не задана (равна 0.000), то теперь она вообще не выводится на кнопку

13.02.2015 [ksrs-terminal-server] 3.0.0.88
ADD: Новый механизм коммутации сессий с возможностью указания уровня сигнала

13.02.2015 [ksrs-control] 3.0.0.87
CHG: Редактор ЦТРС: транзакция для редактирования записной книжки создаётся теперь
     только в момент открытия закладки "Записная книжка". Раньше эта транзакция была всегда
     активна во время работы Редактора ЦТРС.

13.02.2015 [ksrs-terminal-gui] 3.0.0.87
FIX: В момент обновления конфигурации не останавливались различные служебные таймеры.
     Проявлялось в случае если не дожидаясь загрузки новой конфигурации на терминале
     в СТКУ ещё раз быстро нажать 'Обновление конфигурации'.

17.02.2015 [ksrs-terminal-gui] 3.0.0.88
CHG: У полудуплексных кнопок убран автоответ на входящие вызовы

18.02.2015 [ksrs-control] 3.0.0.88
ADD: Редактор Шлюза ЛЭМЗ: первая версия редактора внутренних таблиц маршрутизации

20.02.2015 [ksrs-terminal-gui] 3.0.0.88
FIX: Если в параметрах кнопки ГГС протокол был указан заглавными буквами ("SIP:" вместо "sip:"),
     то переставала работать часть логики в симплексе и в прослушивании

20.02.2015 [ksrs-collector-snmp] 3.0.0.36
ADD: Патч 18: изменена процедуры load_terminal_conf.
     Неверно генерировался параметр Capacity для канала типа FILE

26.02.2015 [ksrs-terminal-gui] 3.0.0.88
CHG: При выводе частоты РСТ на кнопке сделано обрезание хвостовых нулей

27.02.2015 [ksrs-collector-snmp] 3.0.0.37
FIX: Если одна из переменных возвращалась агентом как не существующая, то все остальные переменные пакета отбрасывались
ADD: Патч 18: Добавлена логика мониторинга шлюза AddPac и его линейных плат (системные элементы этого типа надо пересоздавать)

04.03.2015 [ksrs-control] 3.0.0.89
ADD: Редактор Шлюза ЛЭМЗ: добавлены новые параметры для редактирования

05.03.2015 [ksrs-control] 3.0.0.90
FIX: Редактор Шлюза ЛЭМЗ: один из вчерашних параметров был ошибочно добавлен как числовой вместо строкового

06.03.2015 [ksrs-terminal-server] 3.0.0.89
FIX: При работе нового механизма коммутации очистка слушающего пула приводила к очистке всей сетки коммутации для сессии

07.03.2015 [ksrs-terminal-server] 3.0.0.90
FIX: Не инициализировался корректно генератор случайных чисел библиотеки SIPPJ. Это приводило к сбоям в установке сессионых
     соединений (в том числе и подписок)

11.03.2015 [ksrs-terminal-gui] 3.0.0.90
FIX: При полностью неуспешном дозвоне в циркуляре с фиксацией не гасилось проигрывание КПВ. #772
CHG: Завершен переход на новый протокол коммутации. Требуется полная проверка функционала.

13.03.2015 [ksrs-terminal-gui] 3.0.0.90
FIX: При коммутации неправильно применялись уровни громкостей

14.03.2015 [ksrs-terminal-gui] 3.0.0.90
CHG: Сигнатура описателя устройств типа АУДИО, определеннная как "Аудио(вх)", не могла быть назначена для разговорного
     прибора. В сессии для таких устройств передается информация в caller_id, а не в called_id

16.03.2015 [ksrs-collector-snmp] 3.0.0.38
FIX: обновление БД №19 - процедура LOAD_TERMINAL_CONF не корректно формировала конфигурацию для элементов замены:
     "Аудио(вх)", "Аудио(исх)"
FIX: обновление БД №19 - процедура LOAD_TERMINAL_CONF не предусматривала наличия нескольких элементов замены:
     "Аудио(вх)", "Аудио(исх)" и "Аудио(вх/исх)"
FIX: обновление БД №19 - таблица TB_SNMP_PARAMS не содержала прототипов переменных для элементов замены:
     "Аудио(вх)", "Аудио(исх)"

16.03.2015 [ksrs-terminal-snmp] 3.0.0.43
FIX: Не предусматривалось наличия нескольких устройств типа "АУДИО"

16.03.2015 [ksrs-terminal-server] 3.0.0.91
FIX: Не предусматривалось индексации нескольких устройств типа "АУДИО"
INF: ВНИМАНИЕ!!! Теперь если предусматривается несколько устройств типа "АУДИО", то для корректного мониторинга
     необходимо задавать уникальное расположение при конфигурировании в СТКУ. В дальнейшем эту особенность будет
     отслеживать сама СТКУ
CHG: Латентность jitter buffer-а увеличена в 2 раза (с 10 до 20 мс). Это должно улучшить качество звука

16.03.2015 [ksrs-terminal-gui] 3.0.0.91
FIX: Некоторые устройства типа АУДИО не индицировались кнопками, хотя при этом работали
ADD: ВНС: для кнопки активного канала добавлена дополнительная индикация в виде красной рамки

17.03.2015 [ksrs-terminal-server] 3.0.0.92
FIX: Не закрыта была отладочная информация измерения jitter buffer-а на РП. Приводило к быстрому переполнению диска
FIX: Падение при получении команды на коммутацию с несуществующей сессией

17.03.2015 [ksrs-terminal-gui] 3.0.0.92
FIX: РП после завершения соединений не снимались с прослушки и документирования. #773

18.03.2015 [ksrs-terminal-gui] 3.0.0.93
FIX: При наличии плат документирования странно работала коммутация РП

18.03.2015 [ksrs-collector-snmp] 3.0.0.39
FIX: обновление БД №19 - в сборке в процедуру LOAD_TERMINAL_CONF не вошли изменения нумерации аудиоустройств
FIX: обновление БД №19 - в процедуре ADD_REMOVABLE_ELEMENT перепутаны направления аудиопотоков

18.03.2015 [ksrs-terminal-server] 3.0.0.93
FIX: При переоткрытии RTP-сессии (перегрузке шлюза) долго происходила пересинхронизация потоков данных
     (более 3-х минут)

23.03.2015 [ksrs-terminal-server] 3.0.0.94
FIX: Не отображалось состояние доступности оператора
FIX: Очистка миксера не диагностировалась изменением зависимых статусов

23.03.2015 [ksrs-terminal-gui] 3.0.0.94
CHG: При выводе частоты РСТ на кнопке и обрезании хвостовых нулей, теперь остаётся минимум одна цифра после точки.
     Например, было "208", стало "208.0".
FIX: При назначении РП на кнопку в случае когда изначально на неё не было назначенных РП, ничего реально не происходило

24.03.2015 [ksrs-terminal-server] 3.0.0.95
FIX: После остановки потока RTP удержанием существовала вероятность сбоя последовательностей RTP-пакетов. Это приводило
     к потере звукового потока

26.03.2015 [ksrs-collector-snmp] 3.0.0.40
ADD: обновление БД №20 - в процедуре IND_STATUS добавлен возвращаемый параметр IND_STATUS
ADD: добавлена возможность в скрипте обработки индикатора обрабатывать предыдущее значение статуса


27.03.2015 [ksrs-collector-snmp] 3.0.0.41
ADD: обновление БД №21 - для инвертера питания изменена логика индикаторов параметров

30.03.2015 [ksrs-control] 3.0.0.91
FIX: после обновления конфигурации ЦТРС, на втором СТКУ не пропадает мигающая пиктограмма о необходимости обновления этого ЦТРС. #778

02.04.2015 [ksrs-terminal-gui] 3.0.0.95
ADD: Функциональная кнопка КОНФЕРЕНЦ-СВЯЗИ. Пока реализовано лишь 60% функционала!
     Режим конференц-связи активируется (и деактивируется) длительным нажатием на кнопку КОНФ.
       Кнопка при активации режима сменит цвет на зелёный.
     Режим добавления нового участника в конференцию включается кратковременным нажатием на кнопку КОНФ.
       При этом на кнопке КОНФ появляется соответствующая пиктограмма. Далее необходимо нажать кнопку ПД требуемого участника.

02.04.2015 [ksrs-control] 3.0.0.92
ADD: В Редактор Терминала на странице функциональных кнопок добавлена поддержка кнопка конференц-связи.

03.04.2015 [ksrs-terminal-gui] 3.0.0.96
FIX: При долгом простое и остановленном терминал-сервере, KARSTerminal цеплял 37000 порт на себя, в итоге серверу после старта данный
     порт становился недоступен. #781

07.04.2015 [ksrs-terminal-server] 3.0.0.96
CHG: Звуковой микшер переведен в режим (тестовый) периодического таймирования с корректировкой шага


08.04.2015 [ksrs-collector-snmp] 3.0.0.42
ADD: обновление БД №22 - добавлена процедура SNMP_GET_VAR4VAR
FIX: Сделана попытка исключить возможность "гонок" при обработки трапов в процессе активной транзакции сканирования. Это приводит в ряде случаев к некорректным
     состояниям элементов замены. #779

08.04.2015 [ksrs-terminal-gui] 3.0.0.96
CHG: функция конференц-связи реализована, требуется проверка

10.04.2015 [ksrs-terminal-gui] 3.0.0.97
FIX: конференц-связь: при выключении режима конференц-связи не происходило завершение всех конференц-соединений
FIX: конференц-связь: кнопка ОТБОЙ отбивает соединения начиная с первого (в обычном режиме связи соединения отбиваются начиная с последнего)

10.04.2014 [ksrs-terminal-snmp] 3.0.0.43
FIX: Не отсылался трап по изменению статусов канальных сессий

10.04.2015 [ksrs-collector-snmp] 3.0.0.43
ADD: обновление БД №22 - добавлено: процедура SAVE_TERMINAL_STATISTIC, генератор GN_TERM_SSN_PROT_ID, таблица TB_TERMINAL_PROT_SSN
ADD: заполнения таблицы (TB_TERMINAL_PROT_SSN) протоколов сессий

14.04.2015 [ksrs-control] 3.0.0.93
FIX: В определённых случаях информационное окно с информацией о системном объекте пропадает навсегда.
CHG: Редактор ЦТРС: при смене IP адреса ЦТРС, автоматически не менялись старые адреса SIP на странице Соединений.
     Требуется БД версии 23.

14.04.2015 [ksrs-collector-snmp] 3.0.0.44
ADD: обновление БД №23 - добавлено: триггер tb_ip_address_au0 для автоматической смены IP адреса у SIP ендпоинтов ЦТРС

14.04.2015 [ksrs-terminal-gui] 3.0.0.97
FIX: вторжение: не нажималась кнопка ПД если вторгаемый ЦТРС был занят (оранжевый цвет кнопки)
FIX: конференц-связь: в режиме конференции на кнопках вызываемых сторон не выключался автоответ
ADD: конференц-связь: в режиме конференции на левой грани кнопки участника появляется пиктограмма
ADD: конференц-связь: на время активной конференции на всех кнопках включается режим нажатия "с фиксацией"

15.04.2015 [ksrs-control] 3.0.0.93
ADD: Редактор ЦТРС: кнопки с незаданным каналом или те на которые БД возвращает ошибку при сохранении конфигурации
     теперь выделяются красным перечеркиванием
ADD: Редактор ЦТРС: параметр 'Максимальная продолжительность разговора', по истечении которой будет сброшен активный вызов ГГС.
     Значение по-умолчанию 600 секунд.

15.04.2015 [ksrs-terminal-gui] 3.0.0.97
ADD: Поддержка параметра 'Максимальная продолжительность разговора'.
     Дополнительно, при сбросе разговоров будет проиграно событие "Сигнал необслуживания".
ADD: Событие "Сигнал необслуживания" будет проигрываться и при сбросе неотвеченных исходящих вызовов,
     при срабатывании настройки 'Время ожидания ответа на исходящие вызовы'.
CHG: Номеронабиратель: восстановлена работоспособность кнопки повторного набора последнего номера.
     Пока только в ручном режиме.

16.04.2015 [ksrs-control] 3.0.0.93
ADD: Редактор ЦТРС: кнопки с вызываемым адресом совпадающим с адресом редактируемого ЦТРС
     теперь так же выделяются красным перечеркиванием

16.04.2015 [ksrs-collector-snmp] 3.0.0.46
CHG: Переделана логика анализа "гонок" между запросами и трапами

16.04.2014 [ksrs-terminal-snmp] 3.0.0.44
CHG: Временно "закрыта" высылка трапа об изменении статуса сессий

20.04.2015 [ksrs-collector-snmp] 3.0.0.47
FIX: обновление БД №24 - исправлено: процедура ADD_REMOVABLE_ELEMENT. Невозможно было создать элементы типа AUDIO.

22.04.2015 [ksrs-control] 3.0.0.94
ADD: Редактор ЦТРС: новый параметр Радиокнопок - SELCAL

22.04.2015 [ksrs-terminal-gui] 3.0.0.98
ADD: Поддержка вызова SELCAL внутри Радиокнопок. Сама панель SELCAL пока ещё находится в разработке.

23.04.2015 [ksrs-collector-snmp] 3.0.0.48
FIX: Обновление БД №25 - исправлено: процедуры LOAD_TERMINAL_CONF и GET_LIST_CHANNELS. Ошибки при формировании имён элементов типа AUDIO.
FIX: Обновление БД №25 - исправлено: процедура INT_GET_OBJ_DESC. На странице Журнал СТКУ для некоторых элементов
     не выводился порядковый номер. Например для элементов типа 'Порт сети'.

23.04.2015 [ksrs-control] 3.0.0.94
FIX: Редактор ЦТРС: не во всех случаях верно отображались имена устройств типа AUDIO
FIX: Журнал: для некоторых элементов не выводился порядковый номер.

23.04.2015 [ksrs-terminal-gui] 3.0.0.98
ADD: Добавлена временная панель SELCAL.

28.04.2015 [ksrs-terminal-gui] 3.0.0.99
FIX: На TiPro нестабильно восстанавливались нажатые кнопки ПРМ/ПРД. Очередная попытка исправить ситуацию.
CHG: SELCAL: реализовано на 50%.

30.04.2015 [ksrs-terminal-server] 3.0.0.97
CHG: Изменен код управления Селективным вызовом согласно изменению протокоа

06.05.2015 [ksrs-terminal-gui] 3.0.0.99
CHG: SELCAL: реализовано на 80%.

07.05.2015 [ksrs-terminal-gui] 3.0.0.99
CHG: SELCAL: новая панель. История работает.

08.05.2015 [ksrs-terminal-gui] 3.0.0.100
FIX: SELCAL: падение при пустой истории вызовов.
FIX: SELCAL: падение при открытой панели и обновлении конфигурации с СТКУ.

13.05.2015 [ksrs-terminal-gui] 3.0.0.100
CHG: SELCAL: скорректированы стили окна под конфигурацию шрифтов linux на ЦТРС

14.05.2015 [ksrs-terminal-gui] 3.0.0.101
FIX: SELCAL: падение при открытой панели и потере связи с сервером

21.05.2015 [ksrs-control] 3.0.0.95
FIX: Редактор ЦТРС: автоматическое создание всех подписок: создавались дубли если если у существующей подписки не был указан порт по-умолчанию 5060. #771
     Т.е. если существовала подписка "...192.168.12.12", то создавался её дубль в виде "...192.168.12.12:5060".

21.05.2015 [ksrs-terminal-gui] 3.0.0.101
FIX: Циркуляр с фиксацией: не прерывался сигнал КПВ если все вызываемый абонент не ответил и вызов отбился по таймауту на ответ. #772

22.05.2015 [ksrs-terminal-gui] 3.0.0.102
ADD: Если у кнопки ГГС недоступны разговорные приборы (красные кресты), то кнопка при нажатии выдаёт сигнал ошибки. #685
     При этом, для симплексных кнопок достаточно наличие только 'микрофонного' прибора, т.к. 'динамик' в коммутации всё равно не используется.
     Для радиокнопок ПРМ и ПРД это уже было давно сделано.

26.05.2015 [ksrs-terminal-gui] 3.0.0.103
FIX: На ЦТРС настроены РП по умолчанию. У кнопки нет назначенных РП. Инициируем разговор. Пытаемся назначить на кнопку новые РП.
     При первом назначении (первый клик), из коммутации не исключаются ранее назначенные РП (которые являются РП по умолчанию на весь ЦТРС). #762
FIX: На ЦТРС могло пробиться несколько одновременных входящих симплексных вызовов. Сделано отбитие опоздавших с кодом занятости. #698
FIX: Кнопки косвенных вызовов не реагировали на нажатия. Проблема появилась при разработке конференц-связи.

28.05.2015 [ksrs-control] 3.0.0.96
ADD: Редактор ЦТРС: новым кнопкам ГГС автоматически присваивается адрес для исходящих вызовов "sip:@192.168.12."
ADD: Редактор ЦТРС: новым кнопкам ГГС автоматически присваивается предпочитаемые РП Динамик3 и Микрофон1
ADD: Редактор ЦТРС: при первоначальной настройке только что созданного ЦТРС, на базе IP адреса ЦТРС формируется параметр "АОН по-умолчанию".
     Т.е. при создании ЦТРС с адресом "192.168.12.111", его "АОН по-умолчанию" будет сделан равным "sip:111@192.168.12.111".

28.05.2015 [ksrs-terminal-gui] 3.0.0.104
CHG: Функция оперативной смены частоты РСТ приведена в соответствие с актуальным протоколом.
     Новая частота сразу отображается на кнопках и в окне смены частоты.

29.05.2015 [ksrs-terminal-gui] 3.0.0.104
FIX: Функция оперативной смены частоты РСТ: окно не скрывалось в момент обновления конфигурации с СТКУ.

29.05.2015 [ksrs-collector-snmp] 3.0.0.49
ADD: обновление БД №26 - изменена процедура SYS_GET_REMOVABLES (добавлен один возвращаемый параметр).

29.05.2015 [ksrs-control] 3.0.0.97
ADD: Редактор шлюза ЛЭМЗ: количество отображаемых в дереве интерфейсов
     теперь зависит от количества элементов "Плата ЛИ УНИВЕРСАЛЬНАЯ" в составе объекта.
ADD: Редактор ЦТРС: на кнопках не отображались назначенные РП типа Аудио.

02.06.2015 [ksrs-control] 3.0.0.98
ADD: Редактор ЦТРС: в функциональные кнопки добавлена кнопка КДРМ
ADD: Редактор шлюза ЛЭМЗ: количество отображаемых в дереве каналов привязано к параметру "Тип линейного интерфейса". Полностью ещё не проверено.

02.06.2015 [ksrs-terminal-gui] 3.0.0.105
ADD: Функция КДРМ в разработке.

03.06.2015 [ksrs-terminal-server] 3.0.0.99
INF: Добавлена функциональность локальной записи переговоров терминала
FIX: Некорректно функционировал микшер в работе со слотами локальной звукозаписи

04.06.2015 [ksrs-collector-snmp] 3.0.0.50
ADD: обновление БД №27 - добавлен новый системный элемент: "Сетевой коммутатор MOXA EDS-518A".

08.06.2015 [ksrs-terminal-gui] 3.0.0.106
CHG: Функция КДРМ доделана в первом приближении. Нужно проверять.

09.06.2015 [ksrs-terminal-gui] 3.0.0.106
CHG: В КДРМ добавлена регистрация Tx по Радио.
CHG: Изменено поведение вывода окна Selcal. Selcal на радиокнопке зеленеет только при открытом окне.
     Так же, при недоступности Selcal теперь выдаётся сигнал ошибочного действия.

10.06.2015 [ksrs-collector-snmp] 3.0.0.51
ADD: обновление БД №28 - изменена процедура load_terminal_conf. Для функции КДРМ увеличено кол-во каналов типа FILE.

10.06.2015 [ksrs-terminal-gui] 3.0.0.106
FIX: КДРМ: если документирование не включалось по какой-то причине (например не было свободных файловых каналов),
     то кнопка включения КДРМ зависала в 'промежуточном' состоянии с оранжевым индикатором.
FIX: КДРМ: терминал падал при обновлении конфигурации с СТКУ и при открытом окне КДРМ.

11.06.2015 [ksrs-control] 3.0.0.99
ADD: Пиктограммы объектов схемы теперь могут быть зачитаны из внешних файлов.
     Приоритет чтения такой:
       1. читаем внешний файл,
       2. если файла нет или ошибка чтения то берём пиктограмму из БД (таблица TB_SYS_ELEMENT_TYPES),
       3. если и в БД её нет, то используем внутренний ресурс ksrs-control.
     Файлы должны находиться в подпапке "config\images\scheme"
     и иметь имя в формате "setypeX.png", где X это идентификатор типа системного элемента в БД.
     Например для ЦТРС это файл "setype1.png", для Moxa 518 это "setype11.png".
     Параметры изображения: PNG-24, 48x48, с прозрачностью.

16.06.2015 [ksrs-terminal-gui] 3.0.0.106
ADD: ПДРМ.

16.06.2015 [ksrs-control] 3.0.0.99
ADD: ПДРМ.

17.06.2015 [ksrs-collector-snmp] 3.0.0.52
FIX: Откорректировано обновление БД №27 - не учитывалась структура первичного ключа таблицы TB_SYS_ELEMENT_COMPLECT

17.06.2015 [ksrs-terminal-gui] 3.0.0.107
CHG: КДРМ. Кнопка включения/выключения записи вынесена в окно КДРМ.
CHG: КДРМ. После выключения записи сохраняется возможность прослушать ранее записанные переговоры.

18.06.2015 [ksrs-control] 3.0.0.100
ADD: Редактор ЦТРС. Радиосвязь. Настройка приоритета тангент по умолчанию на весь ЦТРС. Начальное значение приоритета у всех ЦТРС = 7.
ADD: Редактор ЦТРС. Радио-кнопки. Настройка приоритета тангент.
ADD: Редактор ЦТРС. Радио-кнопки. Параметр "Приоритет приёма".

18.06.2015 [ksrs-terminal-gui] 3.0.0.108
ADD: Радио. При активации тангенты в оборудование передаётся настроенное значение приоритета.
     Значение берётся из кнопки, а если у кнопки не настроен приоритет тангенты то используется значение по умолчанию.
CHG: Selcal. При открытом окне Selcal и отключении ПРМ или ПРД, окно автоматически скрывается и кнопка SELCAL отжимается.

22.06.2015 [ksrs-terminal-gui] 3.0.0.108
ADD: Для Радио реализован "Приоритет Приема". У радиокнопки с приоритетом ПРМ отмечен черным уголком.

23.06.2015 [ksrs-control] 3.0.0.101
ADD: Редактор ЦТРС. Функциональные кнопки. Кнопка "Ретрансляция радио".

23.06.2015 [ksrs-terminal-gui] 3.0.0.109
ADD: Функциональная кнопка РЕТР (Ретрансляция). Полная/частичная переключается длинным нажатием.
     Режим добавления Радиокнопок в группу ретрансляции включается/выключается одиночным нажатием РЕТР.
     Сама ретрансляция звуковых потоков ещё не доделана.

26.06.2015 [ksrs-terminal-gui] 3.0.0.109
ADD: РЕТР. Доделана ретрансляция звуковых потоков.

29.06.2015 [ksrs-terminal-gui] 3.0.0.110
FIX: Не выдавался приоритет при отключении ТНГ

30.06.2015 [ksrs-terminal-gui] 3.0.0.110
FIX: Не выдавался приоритет для селективного вызова радиостанции
FIX: Под Linux на радиокнопках не отрисовывались пиктограммы ретрансляции.
CHG: Приоритет прослушивания: изменена логика работы. Теперь вместо поднятия громкости приоритетного канала
     занижается громкость всех остальных каналов.
FIX: КДРМ: терминал падал при обновлении конфигурации с СТКУ и при открытом окне КДРМ. Повторное исправление.
CHG: Изменёна логика получения и применения настроек с СТКУ. Все операции сделаны последовательными,
     теперь не должно повториться ситуации когда не всегда поднимались разговорные приборы (цифры вместо пиктограмм на кнопке выбора приборов).
ADD: "Радиосвязь\Блокировка приемников РСТ во время ведения радиосвязи": добавлена обработка третьего состояния - 'не блокировать ничего'.

30.06.2015 [ksrs-control] 3.0.0.101
CHG: Редактор ЦТРС. Расширен параметр "Радиосвязь\Блокировка приемников РСТ во время ведения радиосвязи":
       Галка выставлена - во время передачи будут заблокированы приемники ВСЕХ РСТ
       Галка в промежуточном состоянии - во время передачи будет заблокирован приемник только той РСТ по которой ведётся передача
       Галка снята - во время передачи никакие приемники блокироваться не будут

01.07.2015 [ksrs-terminal-gui] 3.0.0.111
FIX: Приоритет тангенты. Теперь тангента нормально перехватывается нажатием на оранжевую кнопку.
CHG: Кнопка ВТОРЖЕНИЕ переименована в ПРИОР_ВЫЗОВ.
ADD: Конференцсвязь. Выбор разговорных приборов и громкостей путём последовательного нажатия кнопки выбора РП и кнопки КОНФ.

02.07.2015 [ksrs-collector-snmp] 3.0.0.53
ADD: Обновление БД №29
     - изменена процедура user_del (заблокировано удаление последнего Администратора)
     - в tb_users добавлен Техник по умолчанию
     - исправление мониторинга Moxa518

02.07.2015 [ksrs-control] 3.0.0.102
ADD: Автологин под специальным пользователем - Техником по умолчанию.
     Так же, для отладки, можно использовать параметры в KARSControl.conf: Debug/AutoLoginUser и Debug/AutoLoginPass

03.07.2015 [ksrs-control] 3.0.0.103
ADD: Параметр кнопки ГГС: "Циркуляр в режиме конференции"
ADD: Параметр кнопки Радио: "Запрещено полное отключение приёма"

03.07.2015 [ksrs-terminal-gui] 3.0.0.112
ADD: Функция циркуляра-конференции с предопределенными участниками

07.07.2015 [ksrs-terminal-gui] 3.0.0.113
FIX: Кнопки инициаторов циркуляров с фиксацией оставались зелёными после удаленного отбоя всех участников
ADD: Реакция на флаг SQL из шлюза - индикация голоса на ПРМ

08.07.2015 [ksrs-terminal-gui] 3.0.0.113
ADD: Запрет полного отключения ПРМ радиоканала. Если ПРМ 'последний', то вокруг него будет красная рамка
     и выдача звукового сигнала при нажатии. Требуется сервер 3.0.0.100.

08.07.2015 [ksrs-terminal-server] 3.0.0.100
ADD: Добавлен функционал трансляции статистики использования каналов между ЦТРС
FIX: В версии 3.0.0.96 была "отломлена" функция трансляция статуса "на РАДИО" из-за переработки уровней коммутации

09.07.2015 [ksrs-terminal-gui] 3.0.0.113
FIX: Запрет полного отключения ПРМ радиоканала. Не во всех случаях очищалась статистика, и кнопка ПРМ не краснела.
FIX: Реакция на флаг SQL из шлюза - индикация голоса на ПРМ

10.07.2015 [ksrs-terminal-gui] 3.0.0.114
ADD: Вызов группы абонентов до получения ответа на входящий вызов (пункт 10.40).
     Достаточно у кнопки в СТКУ указать несколько исходящих адресов через запятую.
     При дозвоне, справа на кнопке отображается порядковый номер набираемого абонента в списке дозвона.

10.07.2015 [ksrs-terminal-server] 3.0.0.101
ADD: Добавлен функционал трансляции графического интерфейса на СТКУ
ADD: Добавлен функционал трансляции команды удаленного перевода наземной связи в графический интерфейс

13.07.2015 [ksrs-control] 3.0.0.104
ADD: Редактор ЦТРС: Функциональные кнопки: Р+Т

13.07.2015 [ksrs-terminal-gui] 3.0.0.115
ADD: Функция Р+Т. Перекоммутация происходит как при установлении новых исходящих соединений,
     так и по нажатию кнопки Р+Т по существующим соединениям, так и при включении/отключении ПРМ.

14.07.2015 [ksrs-control] 3.0.0.104
ADD: Окно информации о ЦТРС. Вывод текущего статуса (который сообщает о себе сам ЦТРС) и включена ли переадресация.

14.07.2015 [ksrs-terminal-gui] 3.0.0.115
ADD: Поддержка команды СТКУ на установление дистанционной переадресации. В самом СТКУ эта функция ещё не работает.

15.07.2015 [ksrs-control] 3.0.0.104
FIX: Редактор состава элемента. Значение позиции было ограничено числом 99.

15.07.2015 [ksrs-terminal-gui] 3.0.0.115
ADD: Отправка статистики по состоявшимся переговорам на СТКУ. На самом СТКУ отображения этой информации пока нет.

16.07.2015 [ksrs-control] 3.0.0.105
ADD: Контекстное меню ЦТРС. Установка удаленной переадресации.

18.07.2015 [ksrs-terminal-server] 3.0.0.102
ADD: Ретрансляция статистики разговоров ЦТРС в агента SNMP
FIX: Не устанавливалась кодировка строк по-умолчанию (UTF-8)

18.07.2015 [ksrs-terminal-snmp] 3.0.0.45
ADD: Ретрансляция статистики разговоров ЦТРС в коллектор SNMP
FIX: Не устанавливалась кодировка строк по-умолчанию (UTF-8)

18.07.2015 [ksrs-collector-snmp] 3.0.0.54
ADD: Обновление БД №30 - структуры под хранение статистики разговоров
ADD: Ретрансляция статистики разговоров ЦТРС в БД

18.07.2015 [ksrs-terminal-gui] 3.0.0.115
ADD: Отправка информации о статусе ЦТРС на СТКУ.
FIX: Поддержка команды СТКУ на установление дистанционной переадресации.

18.07.2015 [ksrs-control] 3.0.0.105
ADD: Отображение текущего статуса ЦТРС в информационном окне.
ADD: При включенной на ЦТРС переадресации, на пиктограмме этого ЦТРС на схеме отображается стрелочка.

19.07.2015 [ksrs-control] 3.0.0.106
ADD: Редактор ЦТРС. Параметр ГГС "Пауза между попытками повторного вызова при занятости вызываемого, в секундах".
     По умолчанию - 3 секунды.
ADD: Редактор ЦТРС. АВТОДОЗВОН в функциональных кнопках.
ADD: Редактор ЦТРС. Кнопки ГГС. Параметр "Функция аварийного оповещения".
ADD: Редактор ЦТРС. Параметры для автоматической переадресации. На самом ЦТРС пока полностью не реализовано.

19.07.2015 [ksrs-terminal-gui] 3.0.0.116
ADD: 10.43 Функция АВТОДОЗВОН с соответствующей кнопкой активации. Работает только на кнопках с фиксацией.
     На время активности индицируется на кнопке ПД пиктограммой, постоянной зелёной рамкой и горящей кнопкой ОТБОЙ.
     Недозвоном считается как получение занятости и прочих кодов недоступности с вызываемой стороны,
     так и прерывание по таймауту на ожидание ответа (параметр настраивается на СТКУ) с вызывающей стороны.
     Каждая попытка дозвона производится после настраиваемой на СТКУ паузы.
     Состояние автодозвона сбрасывается при:
         1. успешном дозвоне
         2. нажатии на саму кнопку ПД
         3. нажатии на кнопку ОТБОЙ
ADD: 10.42 Аварийное оповещение. У кнопки ГГС, при включенном флаге "Функция аварийного оповещения", цвет текста
     на кнопке меняется на красный и при успешном соединении вызываемому абоненту выдаётся звуковой сигнал "Зуммер".
     Работает как на обычных симплексных, полу и полнодуплексных кнопках ГГС, так и на циркулярных.
     Для аварийного оповещения, в папке "voices" рядом с СТКУ добавлен файл "11 Зуммер (тревога без паузы).alaw",
     который можно в СТКУ назначить на сигнал Зуммер в конфигурации нужного ЦТРС.
     Позже, в систему будет добавлен новый отдельный тип звукового сигнала для аварийного оповещения.

20.07.2015 [ksrs-terminal-server] 3.0.0.103
FIX: Отсутствовала возможность переадресовать вызов, по которому был произведен предварительный ответ (RINGING,PROGRESS)
FIX: На команду перезагрузки ЦТРС выполнялась команда выключения питания

20.07.2015 [ksrs-terminal-gui] 3.0.0.117
FIX: Загадочное зависание интерфейса после перезагрузки ЦТРС.

21.07.2015 [ksrs-terminal-server] 3.0.0.104
FIX: Некорректно индицировался статус ЦТРС во время влючения режима переадресации (периодически кнопка становилась оранжевой, а в
     логе приходило событие о блокировке)

21.07.2015 [ksrs-control] 3.0.0.107
ADD: 10.37 Редактор ЦТРС. Параметр "Максимальное количество одновременных разговоров".
     Влияет на "занятость" ЦТРС для вызываемых абонентов. Участвует в функциях типа АвтоПереадресации по занятости и Автодозвон.

21.07.2015 [ksrs-terminal-gui] 3.0.0.117
ADD: Учёт максимального кол-ва активных разговоров (по умолчанию = 1) и ответ занятостью на входящие вызовы
     при превышении порогового значения. Не влияет на прослушку, вторжение, симплекс. Так же, вызовы поставленные
     на удержание на ЭТОМ ЦТРС не считаются активными.
ADD: 10.37 Автоматическая переадресация. Настраивается параметрами на СТКУ.

22.07.2015 [ksrs-terminal-server] 3.0.0.105
CHG: Теперь вызовы, сформированные после перенаправления в предответной фазе (по недоступности, неответу или занятости)
     имеют следующий формат поля адреса вызываемого: <CalledLocalID>|<CalledRemoteID>. CalledLocalID - адрес, который
     выставил переводящий при перенаправлении вызова. CalledRemoteID - адрес, который набирал вызывающий изначально.

22.07.2015 [ksrs-terminal-gui] 3.0.0.118
FIX: Автопереадресация по неответу. Происходило падение приложения, не останавливалось проигрывание сигнала входящего вызова,
     если вызов был на прямую кнопку то на ней не выключалась индикация входящего вызова.
CHG: Красный цвет у разных функциональных кнопок заменён на другие цвета.
ADD: Отображение признака переадресованности на кнопках активных вызовов.

22.07.2015 [ksrs-control] 3.0.0.108
ADD: 10.48 Страница "Статистика по ЦТРС" в главном окне СТКУ.
ADD: Редактор ЦТРС. "Перестройка частоты РСТ" в функциональных кнопках.
ADD: Отключение дистанционной переадресации ЦТРС из меню.

23.07.2015 [ksrs-control] 3.0.0.109
ADD: Индикатор доступности подсистемы наблюдения ТОПАЗ

23.07.2015 [ksrs-terminal-gui] 3.0.0.119
FIX: ПДРМ. Некорректно работало проигрывание файлов при пересечении максимальной продолжительности записи.

24.07.2015 [ksrs-terminal-gui] 3.0.0.120
FIX: Был поломан приоритет тангенты.
CHG: Ретрансляция Радио. При выключении ПРМ или ПРД режим ретрансляции на этой РСТ отключается.
FIX: Ретрансляция Радио. На первый взгляд починилась ретрансляция передачи. Ретрансляция приёма пока не выходит.
ADD: Радио. Отображение плохого статуса линейного интерфейса шлюза в списке РСТ. Пока временно в виде символа "Х".

24.07.2015 [ksrs-collector-snmp] 3.0.0.55
ADD: Обновление БД №31 - процедура очистки статистики разговоров

24.07.2015 [ksrs-control] 3.0.0.109
ADD: Статистика по ЦТРС. Кнопка очистки статистики. Требуется коллектор версии 3.0.0.55.

24.07.2015 [ksrs-terminal-server] 3.0.0.106
FIX: Не выполнялась команда удаления файла звукозаписи в варианте "без сессии"

26.07.2015 [ksrs-terminal-gui] 3.0.0.121
FIX: Частичная ретрансляция Радио (ретрансляция передачи). Алгоритм включения тангент других РСТ в группе
     не срабатывал при использовании аппаратной тангенты.
FIX: Полная ретрансляция Радио (ретрансляция приёма). Пробный вариант. Тангенты других РСТ в группе
     включаются/выключаются по детектору голоса на ПРМ.

27.07.2015 [ksrs-terminal-gui] 3.0.0.121
FIX: При активном режиме добавления РСТ в группу рестрансляции, менялась логика нажатия кнопок ГГС
FIX: Окно акустических сигналов. Плеер не останавливался при закрытии окна "не крестиком".
FIX: Статистика по разговорам. Неотвеченный вызовы попадали в статистику с нулевой датой.

30.07.2015 [ksrs-terminal-gui] 3.0.0.121
FIX: КДРМ. Работал только в режиме ПДРМ.
FIX: Ретрансляция передачи работала не во всех случаях.

30.07.2015 [ksrs-control] 3.0.0.109
CHG: Убрано упоминание БД.

31.07.2015 [ksrs-terminal-gui] 3.0.0.122
FIX: КДРМ. Не регистрировались входящие вызовы.
FIX: Статистика по ЦТРС. Не регистрировались входящие вызовы.

31.07.2015 [ksrs-control] 3.0.0.110
FIX: Шлюз ЛЭМЗ. Устаревшая подсказка по параметру Радио:удаленное управление.
ADD: ЦТРС: Параметр ГГС "Контроль непроизводительного занятия канала, в секундах". На самом ЦТРС не реализовано.

01.08.2015 [ksrs-terminal-gui] 3.0.0.122
FIX: Fullscreen. Очередная попытка исключить падения под Windows. Таймаут активации fullscreen увеличен до 10000мс.
FIX: Не пропадала индикация о пропущенных косвенных вызовах.

01.08.2015 [ksrs-control] 3.0.0.110
ADD: Шлюз ЛЭМЗ. Добавлены параметры RXVADHANGUP, DRURISUBSCRIBE, TXVADHANGUP, RXFRAMEHANGUP, DCONTYPESIGNAL, AUTOANSWER.

01.08.2015 [ksrs-collector-snmp] 3.0.0.56
ADD: Обновление БД №32 - процедура получения ИТОГО по статистике разговоров

02.08.2015 [ksrs-collector-snmp] 3.0.0.56
ADD: Обновление БД №32 - процедура получения поканального ИТОГО по статистике разговоров

02.08.2015 [ksrs-control] 3.0.0.110
ADD: Статистика по ЦТРС. Добавлена отдельная таблица с распределением нагрузки поканально.
     Пока в ней только Радио-каналы, т.к. они едины для всей системы. С ГГС нужно ещё думать.

06.08.2015 [ksrs-terminal-server] 3.0.0.107
FIX: Для сборки под LINUX исключены сообщения типа WARNING
CHG: Для библиотеки PJSIP из-за эффекта накопления памяти штатная политика распределения памяти заменена на собственную

07.08.2015 [ksrs-terminal-server] 3.0.0.108
CHG: Теперь состояние терминала не должно высылаться чаще чем раз в 1 секунду

18.08.2015 [ksrs-control] 3.0.0.111
CHG: Вернули пункты меню связанные с БД (убирали на сертификацию).
CHG: Спрятан мониторинг Топаза (добавляли на сертификацию).
FIX: После изменения состава ЦТРС, в БД не скручивался номер версии конфигурации и не мигала необходимость обновления ЦТРС. #693
     Это было сделано ещё 11.07.2014, но почему-то закоментировано.

18.08.2015 [ksrs-terminal-gui] 3.0.0.123
FIX: Статистика разговоров. Дублировались записи о входящих вызовах.

19.08.2015 [ksrs-terminal-server] 3.0.0.110
FIX: Устранен ряд уязвимостей в коде взаимодействия с PJSIP

26.08.2015 [ksrs-terminal-server] 3.0.0.111
FIX: Исключена ситуция "гонок" при переоформлении подписок в новой версии библиотеки
FIX: Исключен эффект накопления таймерных (и прочих) событий в случае увличения нагрузки на SIP-стек.
     Это приводило к непроизводительному использованию оперативной памяти (кучи)

14.09.2015 [ksrs-control] 3.0.0.112
FIX: Редактор ЦТРС. Радиокнопки. Проблемы с отображением назначенных шрифтов.
FIX: После функции "Восстановление БД" и при переподключении к БД после потери связи,
     не перезачитывалось актуальное состояние объектов системы мониторинга.

14.09.2015 [ksrs-terminal-gui] 3.0.0.124
FIX: Радиокнопки. Проблемы с отображением назначенных шрифтов.
     Так же шрифт сбрасывался на шрифт по умолчанию при изменении состояния кнопок.

15.09.2015 [ksrs-collector-snmp] 3.0.0.57
ADD: Обновление БД №33 - переименования шлюзовых типов системных объектов: ЛЭМЗ>БЛИ-А, РИНО>БЛИ-Ц

15.09.2015 [ksrs-control] 3.0.0.112
CHG: Замена названия "Приориетный вызов" обратно на "Вторжение".
CHG: Редактор ЦТРС. Подписки. Переименование ЛЭМЗ>БЛИ-А.
FIX: Зацикливание на 'Авторизации' при первоначальном восстановлении связи с БД.

15.09.2015 [ksrs-terminal-gui] 3.0.0.124
CHG: Замена названия "Приориетный вызов" обратно на "Вторжение".

16.09.2015 [ksrs-terminal-server] 3.0.0.112
CHG: Временно закоментирован "валидатор" звукового потока RTP (причина: потеря пакета приводит к потере звука в 2 секунды)

17.09.2015 [ksrs-terminal-gui] 3.0.0.125
CHG: Сетевые интерфейсы теперь сортируются в порядке поступления информации об их состоянии.

18.09.2015 [ksrs-control] 3.0.0.113
FIX: БЛИ-А. Исправлено описание параметра "Приоритет PTT и SQL".
FIX: Изменены внутренние функции Перезагрузки и Зваершения работы, теперь СТКУ должно успевать сохранить свои персональные настройки на диск.
FIX: Редактор ЦТРС. Список сопряженных РСТ. При изменении частоты РСТ в списке оставалось только название РСТ.
ADD: Редактор ЦТРС. Основные\разное. Параметр для автоматического закрытия неиспользуемых второстепенных окон ЦТРС.
ADD: Кнопка блокировки перемещения объектов на схеме.
ADD: Добавлено автоматическое обновление страниц Журнал и Статистика при их активации.

18.09.2015 [ksrs-terminal-gui] 3.0.0.126
ADD: Второстепенные окна (Номеронабиратель и т.п..) теперь автоматически прячутся при неактивности.
ADD: КРДМ. Добавлены временные засечки на активность ПРМ (по VAD).

22.09.2015 [ksrs-terminal-gui] 3.0.0.127
CHG: КДРМ. Убрана отладочная информация о длительностях. По радио добавлено где ПРМ где ПРД.

22.09.2015 [ksrs-control] 3.0.0.114
CHG: Теперь из СТКУ вызывается Скрипт бэкапа "v2". В скрипте путь к fb заменен по умолчанию на "/usr/local/firebird"
FIX: У объектов с многострочными названиями исправлено отображение в окне Информации.
ADD: Меню Файл\Питание\Перезапуск ГУИ
CHG: Меню Файл\Питание\Перезапуск и Завершение работы системы. Убрана минутная задержка перед выполнением системной команды
     и соответственно изменена процедура завершения работы программы.
ADD: Масштаб схемы. Теперь сохраняется, восстанавливается и отображает ближайшее реальное значение в выпадающем списке.

23.09.2015 [ksrs-control] 3.0.0.114
CHG: Окно изменения состава объекта. Добавлена сортировка элементов по "расположению".

23.09.2015 [ksrs-terminal-gui] 3.0.0.128
CHG: КДРМ. Временные засечки Радио ПРМ теперь ставятся не по морганию VAD а по фактическому изменению статуса VAD в протоколе.
CHG: Радио. В тестовом режиме (из-за КДРМ ПРМ), убрана постоянная коммутация микрофона при активной кнопке ПРД.
     Теперь микрофон подключается/отключается только одновременно с тангентой.
     Это сделано для того чтобы микрофон не попадал в документирование активности ПРМ.

24.09.2015 [ksrs-control] 3.0.0.115
CHG: Окно изменения состава объекта. Изменена сортировка элементов.
ADD: Редактор ЦТРС. Новый параметр "Запрещено документирование (КДРМ)" у радиокнопки.
     Позволяет исключить из КДРМ кнопки которые записывать не требуется, например АТИС.
     По умолчанию выключен.

24.09.2015 [ksrs-terminal-gui] 3.0.0.129
FIX: КДРМ. В документирование попадали 'разговоры' даже по неактивным (серым) ПРМ.
ADD: КДРМ. Поддержка параметра "Запрещено документирование (КДРМ)".

25.09.2015 [ksrs-terminal-server] 3.0.0.113
CHG: Теперь если ЦТРС захватил тангенту, то будет всегда индикация о том, что ЦТРС на РАДИО

25.09.2015 [ksrs-terminal-snmp] 3.0.0.46
FIX: Затирались флаги индикации статуса операций по радиостанции
30.09.2015 [ksrs-collector-snmp] 3.0.0.58
ADD: Обновление БД №34 - подкручены параметры мониторинга инвертора

30.09.2015 [ksrs-control] 3.0.0.116
CHG: Схема. Изменена сетка и теперь при перетаскивании пиктограммы автоматически выравниваются по новой сетке.
ADD: Журнал и Статистика. Ограничение вывода кол-ва записей - максимум 1000. На ИТОГО в Статистике не влияет.

01.10.2015 [ksrs-terminal-gui] 3.0.0.130
ADD: КДРМ. В документировании добавлена информация о типе ГГС - входящий, симплекс, вторжение, полудуплекс.
FIX: Номеронабиратель. Кнопка набора в случае совпадения адресов начинала реагировать на статус удаленного абонента,
     например становилась оранжевой.
ADD: Радиосвязь. Приоритет приёма выставленныйв настройках для одной РСТ, автоматически применяется и для всех её сопряженных РСТ,
     если они конечно назначены.

01.10.2015 [ksrs-control] 3.0.0.116
ADD: Кнопка рядом с часами, для изменения системного времени.

01.10.2015 [ksrs-collector-snmp] 3.0.0.59
ADD: Обновление БД №35 - добавлен мониторинг сетевых портов БЛИ-А

02.10.2015 [ksrs-control] 3.0.0.117
CHG: Редактор ЦТРС. У радиокнопок спрятан параметр настройки частоты. Он всё равно на ЦТРС заменяется реальным значением из БЛИ-А.
ADD: Редактор ЦТРС. Основные\Радио связь. Коэффициент изменения громкости приёма неприоритетных РСТ при срабатывании настройки 'Приоритет приёма'.
CHG: Редактор ЦТРС. Изменена сетка панелей и теперь все кнопки при перетаскивании автоматически выравниваются по сетке 4x4.
FIX: Изменение системного времени не работало под Linux.
CHG: Подкручены стили календарей везде где они встречаются в программе.

02.10.2015 [ksrs-terminal-gui] 3.0.0.131
FIX: В загадочных случаях обычный входящий вызов мог индицироваться как переведенный с другого ЦТРС.
ADD: Применение настройки коэффициента изменения громкости приёма неприоритетных РСТ при срабатывании настройки 'Приоритет приёма'.

05.10.2015 [ksrs-terminal-gui] 3.0.0.132
FIX: На панелях не скрывалась редакторная сетка.
CHG: КДРМ. В список записей добавлены пиктограммы намекающие на тип вызова.
FIX: КДРМ. Исключено пропадание второй строки на записях с длинным названием.

05.10.2015 [ksrs-control] 3.0.0.118
FIX: Если открыть редактор ЦТРС в обоих СТКУ, и затем произвести изменения на любом из них,
     то на другом СТКУ при закрытии редактора неверно запрашивались текущие версии с ЦТРС.
     Это приводило к индикации о наличии изменений сразу на всех ЦТРС схемы.

06.10.2015 [ksrs-terminal-gui] 3.0.0.133
FIX: Переход на РП по умолчанию и обратно не срабатывал на радиокнопках у которых была неактивна тангента.

06.10.2015 [ksrs-control] 3.0.0.119
CHG: Печать событий на принтер.
     Переделана на прямую запись в устройство принтера.
     Временно в окне настроек задаётся полное имя устройства принтера, например /dev/usb/lp0.
     Печатаются только важные события (имеющие красные иконки в окне протокола).

07.10.2015 [ksrs-control] 3.0.0.119
FIX: Печать событий на принтер. Многострочные названия системных объектов нарушали красивость печати.
FIX: Опять загадочный глюк с применением шрифтов на кнопках.

08.10.2015 [ksrs-control] 3.0.0.120
ADD: Редактор БЛИ-А. Добавлены и изменены параметры в соответствии с прошивкой 10193.
CHG: Печать на принтер вынесена в очередь и отдельный поток. Отсутствие бумаги в принтере больше не завешивает приложение.

13.10.2015 [ksrs-terminal-gui] 3.0.0.134
CHG: При активации режима добавления абонентов в конференцию теперь блокируются другие функциональные кнопки (Вторжение, Прослушивание,...).

13.10.2015 [ksrs-control] 3.0.0.121
ADD: Редактор БЛИ-А. Сортировка параметров канала по имени.

14.10.2015 [ksrs-terminal-server] 3.0.0.115
ADD: Вернулась поддержка аудиоустройств под WIN32

16.10.2015 [ksrs-control] 3.0.0.122
ADD: Редактор БЛИ-А. Простые поля редактирования заменены на редакторы типа чекбоксов, выпадающих списков,....

19.10.2015 [ksrs-control] 3.0.0.123
FIX: Редактор БЛИ-А. В выпадающих списках не обрабатывались отрицательные значения параметров.

21.10.2015 [ksrs-control] 3.0.0.124
ADD: Редактор БЛИ-А. Добавлена ветка "Состояние".

22.10.2015 [ksrs-control] 3.0.0.124
ADD: Редактор БЛИ-А. Добавлены ветки с состоянием ЛИ и сетевых интерфейсов шлюза.

22.10.2015 [ksrs-terminal-server] 3.0.0.116
FIX: Не работало отключение параметра СТКУ "Индикация занятости при активной передаче"

23.10.2015 [ksrs-control] 3.0.0.125
FIX: Редактор БЛИ-А. Была поломана синхронизация каналов с БД.

26.10.2015 [ksrs-collector-snmp] 3.0.0.60
CHG: Изменен механизм опроса переменных SNMP. Теперь это осуществляется в обход утилит snmp внутренними методами.

28.10.2015 [ksrs-collector-snmp] 3.0.0.61
ADD: DB Patch №36 - исправление ошибок операций с БЛИ-А в процедуре add_lemz_gw_resource
CHG: DB Patch №36 - добавлена поддержка получения значений TimeTicks в "чистых" миллисекундах

30.10.2015 [ksrs-control] 3.0.0.126
ADD: Редактор БЛИ-А. Добавлен код состояния работы 100 (работает от одного источника питания).
CHG: Небольшая оптимизация скорости вывода сообщений в окно мониторинга.

05.11.2015 [ksrs-collector-snmp] 3.0.0.62
ADD: DB Patch №37 - мониторинг БЛИ-А, уровень статуса питания заменен с красного на желтый

06.11.2015 [ksrs-terminal-gui] 3.0.0.135
FIX: Кнопки ГГС. При отбитии входящего вызова кнопка промелькивала синим статусом "удержания".

08.11.2015 [ksrs-terminal-gui] 3.0.0.136
FIX: Кнопки Радио. При отключении ПРД не отключалась тангента, если она была при этом включена.
FIX: ВНС. Каналы ранее исключенные из группы, при очередном включении ВНС не во всех случаях добавлялись обратно в группу.

12.11.2015 [ksrs-collector-snmp] 3.0.0.63
ADD: DB Patch №38 - мониторинг сетевых портов

16.11.2015 [ksrs-control] 3.0.0.126
FIX: Редактор ЦТРС. При копированиии кнопок ГГС, в новой копии перезаписывались некоторые параметры на параметры кнопок по умолчанию.

18.11.2015 [ksrs-terminal-server] 3.0.0.117
FIX: Введена защита на случай получения команд коммутации в процессе уничтожения сессии (приводило к падению приложения)

18.11.2015 [ksrs-control] 3.0.0.127
FIX: Была сломана процедура изменения системного времени.

20.11.2015 [ksrs-control] 3.0.0.128
ADD: Редактор ЦТРС. Основные\Радио связь. Коэффициент изменения громкости приёма РСТ в неприоритетных группах ВНС.
ADD: Системные настройки\Настройки СТКУ. Разница в часа между UTC и локальным временем.
     Влияет на отображение текущего времени в главном окне СТКУ.

20.11.2015 [ksrs-terminal-gui] 3.0.0.137
ADD: Применение настройки коэффициента изменения громкости приёма РСТ в неприоритетных группах ВНС.
CHG: Кнопка ВНС теперь активируется по долгому нажатию. По короткому нажатию происходит включение/выключение приоритетности группы.

23.11.2015 [ksrs-control] 3.0.0.129
ADD: Редактор БЛИ-А. Изменения в прошивке v0.10383_2015_11_23

24.11.2015 [ksrs-terminal-gui] 3.0.0.138
CHG: ВНС. Если одна механическая тангента одновременно назначена на несколько групп ВНС:
     - если приоритет ВНС не используется, то тангента активируется для всех РСТ во всех группах
     - если у одной из групп включен режим приоритета, то тангента активируется только для РСТ из этой группы
CHG: ВНС. Поддержка параметра СТКУ, разрешающего функцию повышения приоритета группы ВНС.
     - При разрешенном повышении приоритета группы ВНС, сама функция ВНС активируется/деактивируется долгим нажатием на кнопку.
       Приоритет включается/выключается коротким нажатием.
     - Если поддержка приоритета выключена, то ВНС активируется/деактивируется коротким нажатием на кнопку.

24.11.2015 [ksrs-control] 3.0.0.129
ADD: Редактор ЦТРС. Основные\Радио связь. Параметр разрешающий функцию повышения приоритета группы ВНС.

25.11.2015 [ksrs-terminal-gui] 3.0.0.138
CHG: Подкручены параметры радиокнопок чтобы при их небольшом размере текст ВНС не налезал на ПРМ и прочая косметика.

30.11.2015 [ksrs-control] 3.0.0.130
CHG: Изменения от 25.11.2015 временно убраны. Взамен добавлен новые параметр радиокнопки - ширина кнопки Тангенты в пикселях.
     При значении -1, ширина выставляется как раньше - автоматически.
CHG: Редактор ЦТРС. Окно выбора РСТ/ГГС теперь запоминает свои размеры и положение
ADD: Редактор ЦТРС. Окно параметров кнопок теперь запоминает свои размеры и положение,
     и первый раз позиционируется прижавшись справа к зеленой рамке рабочего поля кнопок ЦТРС.

30.11.2015 [ksrs-terminal-gui] 3.0.0.139
CHG: ВНС. Подкручен стиль приоритетной кнопки ВНС.
CHG: ВНС. При деактивации ВНС теперь отключаются ПРМ и ПРД у всех кнопок группы.
ADD: ВНС. На время активности ВНС на все кнопки группы назначаются РП с кнопки ВНС.

01.12.2015 [ksrs-terminal-gui] 3.0.0.139
FIX: ВНС. При активном ВНС, назначенные РП не перекоммутировались на кнопках группы. Нужно было выключить/включить ВНС.

03.12.2015 [ksrs-control] 3.0.0.131
ADD: Редактор БЛИ-А. Переключатель между версиями. Все новые таблицы конфигурации v2.

04.12.2015 [ksrs-collector-snmp] 3.0.0.64
ADD: DB Patch №39 - изменена процедура ADD_LEMZ_GW_RESOURCE. Поддержка 'виртуальных' каналов на основе таблицы пиров БЛИ-А.

06.12.2015 [ksrs-control] 3.0.0.132
ADD: Редактор БЛИ-А. Пиры можно регистрировать в качестве каналов через контекстное меню.

07.12.2015 [ksrs-collector-snmp] 3.0.0.65
ADD: DB Patch №40 - БЛИ-А КИТ выделен в отдельный тип системного элемента

07.12.2015 [ksrs-control] 3.0.0.133
ADD: Редактор БЛИ-А. Версия конфигурации выбирается автоматически по типу системного элемента.

08.12.2015 [ksrs-control] 3.0.0.133
FIX: Редактор БЛИ-А. В некоторых случаях неверно парсились SNMP ответы, которые в зависимости от содержимого
     могли вернуть строковые параметры как в виде строки, так и в виде hex-строки.
FIX: Редактор БЛИ-А. После изменений от 07.12 не обновлялись таблицы второй версии.

09.12.2015 [ksrs-control] 3.0.0.133
FIX: Не открывался редактор для MOXA.
FIX: Редактор БЛИ-А. Длинные строковые параметры при чтении из шлюза обрезались до 10 символов.
FIX: Редактор БЛИ-А. Параметры ruri и turi были поменяны местами.

09.12.2015 [ksrs-terminal-gui] 3.0.0.140
CHG: Частота на радиокнопках теперь не сбрасывается при отключении РСТ.
CHG: КДРМ Радио ПРМ. Добавлена защита от слишком частых срабатываний детектора голоса.
     Теперь вместо множества коротких сессий приёма радио должна быть одна продолжительная.
FIX: Номеронабиратель. Исходящие вызовы не попадали в КРДМ и Статистику.

10.12.2015 [ksrs-control] 3.0.0.134
FIX: Редактор БЛИ-А. Из-за перемены мест ruri и turi, в БД не работала некоторая логика по созданию радиостанций.
CHG: Изменен внутренний сетевой клиент ЦТРС, с целью устранить проблему 'зависания' в процессе обновления конфигурации
ADD: Обновление конфигурации ЦТРС. Пункт меню автоматически разблокируется через 20 секунд после начала процесса обновления.
     Так же, для борьбы с 'зависаниями'.

10.12.2015 [ksrs-terminal-gui] 3.0.0.140
FIX: Номеронабиратель. У записей в КДРМ отсутствовала адресная информация.
CHG: Смена частоты РСТ. Кнопки плюс/минус заменены на цифровую клавиатуру.

11.12.2015 [ksrs-control] 3.0.0.135
ADD: Редактор БЛИ-А. Можно редактировать название пиры - параметр "Имя канала КСРС" в таблице.
CHG: Редактор ЦТРС. Радиокнопки. Вернулся обратно параметр "Частота".
ADD: Редактор ЦТРС. Радиокнопки. Новый параметр "Устанавливать частоту при запуске ЦТРС".
     Нужен в первую очередь для БЛИ-А КИТ.
ADD: Редактор ЦТРС. Радиокнопки. Новый параметр "Разрешено изменение частоты".
     Чтобы прятать РСТ из списка на изменение частоты в ЦТРС.

11.12.2015 [ksrs-terminal-gui] 3.0.0.141
ADD: Обработка нового параметра радиокнопок "Разрешено изменение частоты".
ADD: Обработка нового параметра радиокнопок "Устанавливать частоту при запуске ЦТРС".
     Команда на установку частоты выдаётся сразу после активации радиосессии.
CHG: КДРМ. Немного расширено окно, не влезали косвенные адресаты
CHG: Входящие конференц-вызовы теперь тоже используют те РП, которые назначены на исходящую конференц-связь

12.12.2015 [ksrs-terminal-server] 3.0.1.1
ADD: Добавлена в стек RTP диагностика наличия звукового потока и его характеристик (введена для диагностики
     ситуаций пропадания звукового тракта)

14.12.2015 [ksrs-terminal-gui] 3.0.0.142
FIX: ВНС. Отключена коммутация РП на ПРМ до момента выбора активного канала.
     Ранее, при активации ВНС происходила коммутация РП на ПРМ всех кнопок, но при появлении
     первого активного канала все ПРМ группы всё равно заново перекоммутировались.

15.12.2015 [ksrs-control] 3.0.0.136
CHG: Обновление конфигурации ЦТРС. Проверочное чтение версий задержано на несколько секунд, т.к. приводило к неадекватным результатам.
     Дело в том что сервер может успешно принять конфигурацию, но реально применится она только тогда, когда ГУИ 'разрешит'.
     А ГУИ, в данный момент, разрешает серверу применить конфигурацию только после того как завершит все соединения, положит все сессии и т.д.
     Причем ГУИ, в далёком далёком будущем, вообще будет ждать разрешения пользователя на применение конфигурации.

17.12.2015 [ksrs-terminal-gui] 3.0.0.143
FIX: Входящие вызовы. Ошибочная длительность в статистике СТКУ.
FIX: Входящие вызовы. Работал возврат только к самому последнему из удержанных вызовов.

18.12.2015 [ksrs-control] 3.0.0.136
ADD: После смены IP адреса ЦТРС добавлен перезачет информации от системы мониторинга.

18.12.2015 [ksrs-terminal-gui] 3.0.0.143
FIX: Ретрансляция. Лишняя логика на этапе выбора 'источников' ретрансляции, которая по идее не влияла на работу.
CHG: Небольшие изменения в логировании в файл.

22.12.2015 [ksrs-terminal-gui] 3.0.0.144
CHG: Входящие косвенные вызовы. Добавлена кнопка вызова абонента из списка "История".
CHG: Входящие косвенные вызовы. Немного увеличены размеры окна.
CHG: Конференция. При включении режима конференции, сразу включается режим добавления участников.
     Ранее приходилось делать лишнее нажатие кнопки КОНФ.

22.12.2015 [ksrs-terminal-server] 3.0.1.2
FIX: Невозможно было позвонить на хост без указания адреса

23.12.2015 [ksrs-control] 3.0.0.136
FIX: Редактор ЦТРС. При загрузке конфигурации в редактор, у радиокнопок обнулялась ранее настроенная частота.

23.12.2015 [ksrs-terminal-gui] 3.0.0.145
CHG: P+T. Изменена логика работы. Теперь 'объединяемые с ГГС' радиокнопки выбираются по принципу конференции:
     долгим нажатием на P+T переключается вся функция, а коротким - режим выбора радиокнопок для трансляции в ГГС.

24.12.2015 [ksrs-terminal-gui] 3.0.0.145
CHG: Ретрансляция. Запрещена ретрансляция в РСТ которые сконфигурированы только на прослушивание.

25.12.2015 [ksrs-terminal-gui] 3.0.0.146
FIX: Для радиокнопки с активным ПРД, которую в новой конфигурации сделали "Только прослушивание",
     этот ПРД незаметно активировался при обновлении конфигурации и поэтому кнопка могла начать передачу в РСТ
     при нажатии назначенной аппаратной тангенты.
FIX: Радио. Прослушивание и Документирование. Если включена опция "Блокировка приемников РСТ во время ведения радиосвязи",
     то помимо отключения динамиков, теперь так же на время передачи от прослушки и документирования отключается и сама радиосессия.
     Это исключает возможное эхо при прослушивании РСТ с других ЦТРС и документировании.
CHG: Ретрансляция. Добавлена индикация детектора голоса на ПРД у РСТ в которые происходит ретрансляция.

28.12.2015 [ksrs-terminal-server] 3.0.1.3
FIX: RTCP пакеты "выгребались" из очереди только по приходу очередного RTP пакета

28.12.2015 [ksrs-terminal-gui] 3.0.0.147
CHG: Ретрансляция. Добавлена индикация активации ТНГ у РСТ в которые происходит ретрансляция.

28.12.2015 [ksrs-terminal-server] 3.0.1.4
FIX: В версии 3.0.1.3 допущена ошибка обработки POOL-событий. Приводило к быстрой блокировке приложения

15.01.2016 [ksrs-terminal-gui] 3.0.0.148
FIX: При перезапуске сервера слишком рано происходила обработка очереди P1AddressStatus
     и радио-кнопки не всегда отображали состояние доступности.

16.01.2016 [ksrs-terminal-gui] 3.0.0.149
CHG: Multicast. Тестовая версия со старым алгоритмом активации сессий Радио для снижения нагрузки.
ADD: Пиктограммы назначенных РП на кнопке вызова очереди косвенных вызовов и кнопке КОНФ.

18.01.2016 [ksrs-terminal-gui] 3.0.0.149
FIX: При перехвате тангенты с учетом приоритета не микшировался РП на ПРД.

18.01.2016 [ksrs-terminal-server] 3.0.1.5
ADD: Добавлена возможность для графического интерфейса получать идентификатор канала радиостанции в сообщении

19.01.2016 [ksrs-control] 3.0.0.137
FIX: Журнал. Некорректно отображались многострочные названия "устройств".

19.01.2016 [ksrs-terminal-gui] 3.0.0.149
FIX: Ретрансляция. Не включалась тангента если полная ретрансляция включалась уже с детектором голоса на ПРМ.
FIX: Ретрансляция. Не происходила перекоммутация если ретрансляция включалась до активации РСТ (кнопка была серая).
CHG: Сообщения подписки теперь обрабатываются не только по адресной информации, но и по номеру канала.
     Для этого требуется ksrs-terminal-server не старее версии 3.0.1.5.
ADD: Смена частоты РСТ. Если на ЦТРС есть РСТ у которых стоит разрешение на смену частоты,
     но все эти РСТ неактивны (нет зелёных ПРМ или ПРД), то выдаётся соответствующее сообщение и окно смены частоты не открывается.

20.01.2016 [ksrs-terminal-server] 3.0.1.6
CHG: Изменен формат пакета информации о статусе адреса. теперь идентификатор передается списком (см. документацию)

20.01.2016 [ksrs-terminal-gui] 3.0.0.149
CHG: Сообщения подписки теперь обрабатываются не только по адресной информации, но и по списку номеров каналов.
     Для этого требуется ksrs-terminal-server не старее версии 3.0.1.6.

21.01.2016 [ksrs-terminal-gui] 3.0.0.149
FIX: P+T. Из-за изменений для мультикаста, с ГГС не коммутировались те РСТ, которые были неактивны на момент добавления в список P+T.

22.01.2016  [ksrs-terminal-gui] 3.0.0.149
ADD: Адаптация для поддержки мультиязычности. Частичная англофикация интерфейса.

23.01.2016 [ksrs-control] 3.0.0.137
ADD: Адаптация для поддержки мультиязычности. Частичная англофикация интерфейса.

25.01.2016 [ksrs-control] 3.0.0.137
ADD: Редактор ЦТРС. В окно выбора конфигурации добавлена возможность удаления старых конфигураций.
     При попытке удаления текущей конфигурации будет выдана соответствующая ошибка. 
     В окне по кнопке "Открыть конфигурацию другого ЦТРС" удаление отключено.
     В окне по кнопке "Открыть предыдущую версию текущей конфигурации" удаление работает на 100%.
     В окне по кнопке "Открыть конфигурацию" удаление работает на 50%. Пока не учитывается, что под одним названием 
     скрывается сразу куча версий (вся история изменений конфигурации с этим названием). 

26.01.2016 [ksrs-terminal-gui] 3.0.0.150
CHG: Входящие косвенные вызовы. При вызове абонента из истории, адреса вида 123@ip теперь отображаются в Номеронабирателе без ip адреса.

27.01.2016 [ksrs-terminal-gui] 3.0.0.150
FIX: ВНС. При включении приоритета, команда на снижение громкости выдавалась по всем каналам в других группах, 
     а не только по активным. В результате у всех этих каналов на ПРМ подключался РП, чего не должно происходить.
CHG: ВНС. Подкручено отображение РП на кнопке активации ВНС. Теперь на активной кнопке пиктограммы белые.
CHG: Изменение частоты РСТ. Число цифр до точки увеличено с 4 до 5, для КВ РСТ.

27.01.2016 [ksrs-control] 3.0.0.137
ADD: Редактор ЦТРС. Редактор Подключений. Добавление подписок. Новый пункт меню с возможностью выбора ЦТРС из списка. 
ADD: Редактор ЦТРС. Редактор Подключений. Высоту настроечных таблиц можно изменять, изменения запоминаются. 

28.01.2016 [ksrs-terminal-server] 3.0.1.6
FIX: Некорректно происходила корректировка уровня при сложении более чем 2-х источников сигнала.

29.01.2016 [ksrs-collector-snmp] 3.0.0.66
ADD: DB Patch №41 - добавлен новый тип устройства - SHDSL модем Zyxel P-793H v2

29.01.2016 [ksrs-control] 3.0.0.137
FIX: При обновлении схемы по событию с другого СТКУ снималась включенная блокировка перемещения объектов. 

01.02.2016 [ksrs-control] 3.0.0.137
CHG: Адаптация для поддержки мультиязычности. Полная англофикация интерфейса.

01.02.2016 [ksrs-terminal-gui] 3.0.0.150
CHG: Адаптация для поддержки мультиязычности. Частичная англофикация интерфейса.

02.02.2016 [ksrs-control] 3.0.0.138
CHG: Редактор ЦТРС. Возможность удаления старых конфигураций временно отключена.
     Требуется доработка структуры БД.
ADD: Редактор ЦТРС. Редактор Подключений. Клавиатурный Del выполняет действие кнопки 'Удалить'. 

02.02.2016 [ksrs-terminal-gui] 3.0.0.151
FIX: Ретрансляция полная. В некоторых случаях, при отключении ПРМ у одной активной РСТ не отжималиcь тангенты у других РСТ. 

04.02.2016 [ksrs-control] 3.0.0.139
ADD: Редактор БЛИ-А. Добавлен параметр TransmiterDelay и новые статусы ЛИ.
FIX: Смена IP адреса. Добавлен реконнект к новому адресу, чтобы оперативно отобразить новые статусы элементов.

04.02.2016 [ksrs-terminal-gui] 3.0.0.152
CHG: Номеронабиратель. Записная книжка. При инициализации книжки записи сортируются быстрым способом по имени контакта. 

05.02.2016 [ksrs-control] 3.0.0.139
CHG: Редактор БЛИ-А. Частичная (пока только видимая) англофикация настроек.
FIX: Редактор БЛИ-А. Параметр приоритетов SQL и PTT имел неверные значения.

05.02.2016 [ksrs-terminal-gui] 3.0.0.152
FIX: ВНС. По каналу перестал выдаваться запрос значений качества при активации ВНС. 
     Было поломано в борьбе за оптимизацию мультикаста.
CHG: Входящие косвенные вызовы теперь проверяются по записной книжке. Если адресная информация совпадает,
     то и на кнопке вызова и в истории отображается имя контакта из записной книжки.
ADD: Пиктограммы РП на кнопках "Акустические сигналы" и "Документирование".

08.02.2016 [ksrs-collector-snmp] 3.0.0.67
ADD: DB Patch №42 - расширение параметров таблицы пользователей, добавлено битовое поле дополнительных прав

08.02.2016 [ksrs-control] 3.0.0.139
ADD: Настройки пользователей. Для Техников добавлена панелька с дополнительными правами.
     Пока на ней только один флаг - разрешение перезагружать ЦТРС.

08.02.2016 [ksrs-terminal-server] 3.0.1.8
ADD: Рестарт службы после успешной процедуры смены ip адреса с СТКУ.

09.02.2016 [ksrs-control] 3.0.0.140
FIX: После логина Техника некоторые пункты меню "перезагрузки" пропадали навсегда.
ADD: Редактор ЦТРС. Добавлена настройка дефолтных РП конференцсвязи.

09.02.2016 [ksrs-terminal-gui] 3.0.0.153
ADD: При получении настроек, если РП конференцсвязи не были назначены, то назначаются дефолтные РП с СТКУ.
CHG: При "сбросе РП" теперь помимо кнопочных сбрасываются и РП конференцсвязи и косвенных вызовов. 
ADD: Номеронабиратель. При перемещении по записной книжке кнопка выбора внешнего шлюза блокируется,
     если активная запись книжки не предполагает использование других шлюзов
     (содержит синтаксически полную строку набора вида "sip:....").

10.02.2016 [ksrs-control] 3.0.0.140
ADD: Попытка отследить потерю связи с ЦТРС при физическом отрыве сетевого кабеля.

12.02.2016 [ksrs-terminal-gui] 3.0.0.154
FIX: Проверка входящих косвенных вызовов по записной книжке.
     Отсутствие подходящего адреса в книжке приводило в вероломному падению приложения.
ADD: Добавлена адекватная реакция на ошибочный статус медиа в сессии. Пиктограммы РП теперь не пропадают,
     а значок наличия медиа (динамик в левом нижнем углу кнопки) меняет цвет с белого на красный.

12.02.2016 [ksrs-control] 3.0.0.140
CHG: Потеря связи с ЦТРС при физическом отрыве сетевого кабеля теперь отслеживается.
     Максимальное время детектирования потери связи - 10 секунд.

12.02.2016 [ksrs-collector-snmp] 3.0.0.68
CHG: Косметика - параметр файла snmp-collector.conf "Sever" теперь автоматом переименовывается в "Server".

16.02.2016 [ksrs-terminal-gui] 3.0.0.155
FIX: Обновление конфигурации ЦТРС после прослушивания любой записи в КДРМ, в некоторых случаях приводило к падению приложения.
CHG: Статус ЦТРС в СТКУ. Источник входящего вызова отображался в виде адреса sip:...., теперь отображается название кнопки куда попал этот вызов.
CHG: Статистика. Расширена информация о вызове.
     * Добавлено определение названия кнопки назначения для входящих вызовов, и если при этом название было определено 
     по адресной книжке Номеронабирателя, то именно оно будет в Статистике.
     * Адресная строка теперь отображается в виде "caller -> called" для всех типов вызовов
     * Обнаружена проблема - очень короткие входящие вызовы не попадают в статистику. Пока не решено.

16.02.2016 [ksrs-control] 3.0.0.141
CHG: Сокращено кол-во обращений к БД после закрытия окон редакторов объектов.
     Например теперь данные Мониторинга перезачитываются не по всем объектам, а только по тому который открывали в редакторе.

18.02.2016 [ksrs-control] 3.0.0.142
CHG: Ещё сокращено кол-во обращений к БД после закрытия окон редакторов объектов.
CHG: Попытка предотвращения зависаний процесса обновления конфигурации ЦТРС.

19.02.2016 [ksrs-terminal-gui] 3.0.0.155
FIX: Повторно. Обновление конфигурации ЦТРС после прослушивания любой записи в КДРМ, в некоторых случаях приводило к падению приложения.

19.02.2016 [ksrs-control] 3.0.0.142
ADD: Добавлено логирование неудачных попыток подключения к БД в файл.

20.02.2016 [ksrs-collector-snmp] 3.0.0.69
ADD: DB Patch №43 - отключен отладочный параметр Инвертора 1U

24.02.2016 [ksrs-terminal-gui] 3.0.0.155
CHG: При активации режима добавления РСТ в группу ретрансляции, остальные функциональные кнопки теперь блокируются.

24.02.2016 [ksrs-terminal-server] 3.0.1.9
FIX: Периодически некорректно формировался адрес переадресации. Приводило к нестабильным переводам вызовов
CHG: Отключен код анализа трафика ввиду неработоспособности некоторых функций с симплекс вызовами и полудуплексом

29.02.2016 [ksrs-control] 3.0.0.142
FIX: У объектов с многострочными названиями исправлено отображение событий в Журнале.

01.03.2016 [ksrs-terminal-gui] 3.0.0.156
CHG: КДРМ Радио ПРМ. Ранее была добавлена защита от слишком частых срабатываний детектора голоса
     (вместо множества коротких сессий приёма радио должна быть одна продолжительная).
     Таймер защиты увеличен до 1500мс.

02.03.2016 [ksrs-control] 3.0.0.143
FIX: При установке переадресации с ТТКУ, в активном журнале появляется ошибка "Ошибка при обновлении ЦТРС: ОК(0)". #822

02.03.2016 [ksrs-terminal-gui] 3.0.0.157
FIX: При отпускании кнопки ТНГ игнорировался приоритет тангенты и некоторые другие настройки,
     что приводило к перехвату тангенты и нарушению логики работы радиокнопки. #819

03.03.2016 [ksrs-terminal-gui] 3.0.0.158
FIX: Радиосвязь в КДРМ и Статистике. Приём и передача разделены на две разные логики, т.к. пересечение их временных засечек
     приводило к появлению как записей с некорректным временем, так и вообще к фиктивным записям.

04.03.2016 [ksrs-terminal-gui] 3.0.0.159
FIX: Не инициализировались некоторые внутренние структуры, что приводило к фантомным срабатываниям детектора голоса на радиокнопках и т.п...

05.03.2016 [ksrs-terminal-server] 3.0.1.10
FIX: При использовании селективного вызова не учитывалась возможность смены тангенты
FIX: Существовали случаи, когда ошибочно диагностировалось владение свободной тангентой

09.03.2016 [ksrs-control] 3.0.0.144
ADD: Редактор ЦТРС. Новые параметры тонкой настройки ВНС.

09.03.2016 [ksrs-terminal-gui] 3.0.0.160
ADD: ВНС. Применение новых параметров тонкой настройки.

11.03.2016 [ksrs-terminal-gui] 3.0.0.161
ADD: Перехват вызова.
CHG: Изменение логики работы с занятостью тангенты при работе с сервером версии >= 3.0.1.10

12.03.2016 [ksrs-terminal-gui] 3.0.0.161
ADD: Переадресация активных вызовов.
     1. Нажимаем ПЕРЕАДРЕС, затем нажимаем кнопку ГГС с мигающим желтым входящим вызовом.
        Этот вызов выбирается для перевода, кнопка выделяется пунктиром.
        Теперь выбираем куда переводить вызов - нажимаем другую нужную кнопку ГГС.
        Вызов переводится, кнопка ПЕРЕАДРЕС деактивируется.
     2. Всё то же самое что и в пункте 1, применимо и для отвеченного (зелёного) вызова.
        Но серверная часть пока не дописана, поэтому такая переадресация сейчас физически не сработает.  

13.03.2016 [ksrs-terminal-gui] 3.0.0.161
CHG: Переадресация активных вызовов немного допилена.
ADD: Статистика. Выделение приёмов по радио в качестве отдельных "разговоров" в статистике.
ADD: Звуковое событие "Подтверждение нажатия" повешено пока на все функциональные кнопки.
     Так же в окне настройки Звуковых Событий, для этого события добавлена кнопка отключения его проигрывания. 

13.03.2016 [ksrs-control] 3.0.0.144
ADD: Статистика. Прием по Радио.

13.02.2016 [ksrs-collector-snmp] 3.0.0.70
ADD: Patch 44. Расширено логирование неудачных попыток авторизации пользователей.

14.03.2016 [ksrs-terminal-gui] 3.0.0.162
ADD: "Перехват" тангенты при одновременном доступе двух операторов ЦТРС.
     При активации назначенной на радиокнопку аппаратной тангенты, РП на передаче меняется на РП чья тангенты была активирована.

15.03.2016 [ksrs-control] 3.0.0.144
FIX: Статистика. Прием по Радио. Не считались ИТОГО и не работала фильтрация.

15.03.2016 [ksrs-terminal-gui] 3.0.0.162
FIX: "Перехват" тангенты при одновременном доступе двух операторов ЦТРС. Особая обработка Педали.

16.03.2016 [ksrs-terminal-gui] 3.0.0.163
ADD: Выбор основной/резервной РСТ. В окно Смена Частоты добавлены кнопки выбора.
     Пока настроек нет! В качестве основной выбран интерфейс 0/канал 0, в качестве резервной интерфейс 1/канал 0.
ADD: Выбор основной/резервной РСТ. Если по данной РСТ кто-либо работает на передачу,
     то при попытке изменения комплекта выдаётся сигнал 'Ошибочное действие'.
ADD: Выбор основной/резервной РСТ. Индикация работы на резервной РСТ - на кнопке ПРМ красный уголок в левом верхнем углу.

18.03.2016 [ksrs-collector-snmp] 3.0.0.71
ADD: Patch 45. Расширено логирование адресов при авторизации в СТКУ.

18.03.2016 [ksrs-control] 3.0.0.145
ADD: Страница 'Журнал СТКУ' в главном окне. Там пока информация из БД по логинам в СТКУ.

20.03.2016 [ksrs-control] 3.0.0.146
ADD: При появлении в системе USB флэшки, на странице Журнал мониторинга появляется кнопка Экспорт,
     при нажатии на которую предлагается выбор флэшек куда нужно экспортнуть Журнал в виде CSV файла. 
     Флэшки пока детектируются только на лету (если флэшка воткнута ДО запуска СТКУ то её не будет видно).
     Размонтирования из СТКУ так же пока нет.

22.03.2016 [ksrs-control] 3.0.0.146
ADD: Кнопка Экспорт не только на Журнале Мониторинга, но и на Статистике ЦТРС и Логинах. 

23.03.2016 [ksrs-collector-snmp] 3.0.0.72
ADD: Patch 46. Расширение списка статусов БЛИ-А.

23.03.2016 [ksrs-terminal-gui] 3.0.0.164
FIX: ВНС. Изменение громкости РП при активном ВНС оперативно не применялось на все каналы группы.
CHG: Файлы англофикации теперь ищутся строго рядом с исполняемым файлом.

23.03.2016 [ksrs-control] 3.0.0.146
CHG: Файлы англофикации теперь ищутся строго рядом с исполняемым файлом.

24.03.2016 [ksrs-collector-snmp] 3.0.0.73
ADD: Patch 47. Расширение списка статусов БЛИ-А, корректировка параметров инвертора 1U.

24.03.2016 [ksrs-control] 3.0.0.147
CHG: Расширена реакция на изменения схемы с других СТКУ.

30.03.2016 [ksrs-terminal-gui] 3.0.0.165
FIX: ВНС. Отключена выдача команды в БЛИ-А на вкл и выкл ВНС, т.к. ломалась логика 
     в случае когда ВНС был включен на нескольких ЦТРС.

04.04.2016 [ksrs-terminal-gui] 3.0.0.166
FIX: ВНС. Изменение громкости РП при активном ВНС оперативно не применялось на все каналы группы.

05.04.2016 [ksrs-control] 3.0.0.148
FIX: Никогда не останавливалось проигрывание звуковых сообщений при возникновении аварийных ситуаций.

07.04.2016 [ksrs-terminal-gui] 3.0.0.167
CHG: При открытии окна настройки акустических сигналов теперь восстанавливается выбранное в прошлый раз звуковое событие.
     Дополнительно, теперь кнопки РП доступны сразу после открытия окна, раньше они были заблокированы до первого выбора события.
ADD: РП для плеера КДРМ теперь назначается отдельно. Раньше использовался тот же РП что и для Акустических сигналов.  

08.04.2016 [ksrs-control] 3.0.0.149
CHG: Расширена реакция на изменения схемы с других СТКУ. Например постановка объекта на техобслуживание не всегда доходила до других СТКУ. 

08.04.2016 [ksrs-terminal-gui] 3.0.0.168
ADD: В окне выбора РП добавлена кнопка включения генератора.
     Временно функция реализована в таком виде: 
       Если кнопка ГГС, то она должна быть зелёная (активное соединение).
       Если кнопка Радио, то должена быть активна кнопка ПРД. Но фактически генератор будет передаваться только при нажатой тангенте. 
     На сервере, в папке voices должен лежать файлик с именем "gen". В дистрибутиве он уже есть, в нём синус 425Гц.

09.04.2016 [ksrs-terminal-gui] 3.0.0.169
CHG: Кнопка включения генератора вынесена на правую панель функциональных кнопок и работает по принципу кнопок типа ПРОСЛУШИВАНИЕ,
     т.е. нажали, выбрали кнопку Радио или ГГС для которой следует активировать генератор.
     На выбранной кнопке при этом появится символ синусоиды рядом с РП.
     Теперь при активации кнопок ГГС или тангенты, если на ней есть символ синусоиды, то в канал будет проигрываться генератор.

09.04.2016 [ksrs-control] 3.0.0.149
ADD: Редактор ЦТРС. Функциональные кнопки. Генератор. 

12.04.2016 [ksrs-terminal-gui] 3.0.0.170
ADD: Номеронабиратель. Если цифры нажимаются при установленном соединении, то они отправляются в соединение в виде DTMF.  
ADD: Акустические сигналы. Разрешено полное выключение сигнала КПВ. Ранее можно было отключить только "Подтверждение нажатия". 
ADD: При входящем косвенном вызове, на кнопке очереди выводится информация о вызывающем абоненте.
     Если вызовов несколько, выводится информация только по первому из очереди на ОБЩИЙ ОТВЕТ вызову.

14.04.2016 [ksrs-terminal-gui] 3.0.0.171
FIX: Переадресация входящих вызовов по неответу срабатывала даже при пустом адресе для переадресации.  

15.04.2016 [ksrs-terminal-gui] 3.0.0.171
ADD: Оперативная смена канала (ОСН/РЕЗ) добавлена прямо в радиокнопку. Настраивается в параметрах каждой кнопки на СТКУ в Редакторе ЦТРС.
     В окне смены частоты функция так же осталась.

18.04.2016 [ksrs-terminal-gui] 3.0.0.172
CHG: Акустические сигналы. РП теперь назначаются отдельно на каждое событие.
     Пиктограмма РП на кнопке открытия окна настройки сигналов будет отображаться только если на все события назначен один и тот же РП.
FIX: Генератор уничтожался не во всех случаях при завершении соединений и потом примешивался в записях КДРМ.

20.04.2016 [ksrs-terminal-gui] 3.0.0.172
FIX: Смена РП на входящем косвенном вызове не всегда сразу отображалась на кнопке открытия очереди косвенных вызовов.
FIX: Шрифт номера РП на кнопке открытия очереди косвенных вызовов отличался от остальных кнопок (было поломано в версии 3.0.0.170).
FIX: Статус ЦТРС на СТКУ. При вызовах из Номеронабирателя был без указания вызываемого адреса: "Исходящий косв ГГС на".
FIX: Статус ЦТРС на СТКУ. Расширен статус для входящих косвенных вызовов, добавлена информация из Записной Книжки, если она есть.

20.04.2016 [ksrs-control] 3.0.0.149
ADD: Название окна СТКУ теперь берётся со схемы. Т.е. если на схеме есть этот СТКУ (его ip адрес совпадает 
     с одним из адресов сетевых интерфейсов текущего компа), то в заголовок окна попадёт название элемента со схемы. 

22.04.2016 [ksrs-collector-snmp] 3.0.0.74
ADD: Patch 48. Перевод EN/RU, отключение расширенного логирования SNMP, удаление системных элементов через процедуру.
     В БД протокольные таблицы теперь содержат только идентификаторы событий, а не полный текст,
     поэтому размер файла БД через некоторое время (когда удалятся старые записи) значительно уменьшится!

22.04.2016 [ksrs-control] 3.0.0.150
ADD: События Мониторинга и журнал теперь переводится RU/EN по таблицам БД.
     Язык переключается руками в DB_OPTIONS, по умолчанию значение RU. После смены языка пока требуется перезапуск ГУИ СТКУ.
CHG: Удаление системных элементов сделано через процедуру в БД.

25.04.2016 [ksrs-control] 3.0.0.151
FIX: Состав объекта. Статусы элементов не переводились на язык системы, отображались в виде кодов. #869
FIX: Статистика по ЦТРС. Не облагораживались многострочные имена кнопок. #870
ADD: Статистика по ЦТРС. Добавлена поканальная загрузка для ПРМ Радио. Для ГГС пока нет, там сложнее. #871

25.04.2016 [ksrs-terminal-gui] 3.0.0.173
FIX: Не снималась индикация о пропущенных косвенных вызовах при нажатии кнопки ОТБОЙ. #873

25.04.2016 [ksrs-collector-snmp] 3.0.0.75
ADD: Patch 49. Поправки в переводах.

27.04.2016 [ksrs-terminal-gui] 3.0.0.174
FIX: ВНС. Занятие тангенты с других ЦТРС считалось для логики ВНС как занятие тангенты на этом ЦТРС. #865
FIX: ВНС. При перезагрузке шлюза с активным в данный момент каналом ВНС, канал не исключался из работы 
     и вокруг недоступной кнопки оставалась красная рамка активности канала ВНС.

29.04.2016 [ksrs-terminal-server] 3.0.1.11
FIX: Jitter Buffer при достижении верхней границы не переходил в режим корректировки скорости, что приводило
     к щелчкам в звуковом тракте
CHG: Теперь в таймирование микшера введен алгоритм корректировки на погрешность, вносимую операционной системой
     при переключении контекстов задач

04.05.2016 [ksrs-terminal-server] 3.0.1.12
FIX: Падение при возобновлении подписки, которая была временно недоступна
FIX: Существовало несколько ситуаций, когда после недоступности ресурса подписка на этот ресурс не переподнималась

04.05.2016 [ksrs-control] 3.0.0.152
FIX: Редактор ЦТРС. Конфигурация всегда сохранялась от имени пользователя root(0),
     поэтому сохранение отвалилось сразу после удаления этого пользователя из БД. 

04.05.2016 [ksrs-collector-snmp] 3.0.0.76
ADD: Patch 50. Изменен FK на таблице Users, не позволявший удалять некоторых пользователей.
ADD: Patch 50. Процедура сохранения конфигурации ГУИ ЦТРС работала прикинувшись пользователем root(0).

05.05.2016 [ksrs-control] 3.0.0.152
CHG: Временно отключена поддержка Java во встроеном браузере из-за проблем с плагином icedtea-web. 

11.05.2016 [ksrs-collector-snmp] 3.0.0.77
CHG: Переведены на русский язык все оставшиеся зашитые в коде английские сообщения. #867

11.05.2016 [ksrs-control] 3.0.0.153
CHG: "Выход" доступен только для Админа и через подтверждение. #880

12.05.2016 [ksrs-control] 3.0.0.153
FIX: Двойное подтверждение "Выхода" при использовании команд на перезагрузку. #880

12.05.2016 [ksrs-terminal-gui] 3.0.0.175
CHG: КДРМ. Изменен порядок разговоров в списке, теперь самые свежие сверху, а старые снизу. 

13.05.2016 [ksrs-terminal-gui] 3.0.0.176
CHG: Индикация РП на кнопке выбора РП. Упорядочены пиктограммы РП.
     Приоритет такой: динамики >> трубки >> гарнитуры >> микрофоны >> педали >> линейные интерфейсы.
CHG: Индикация РП на кнопке выбора РП. Добавлены пиктограммы мониторинга интерфейсов документирования.
CHG: Окно выбора РП. Ограничения на регулировку ПРМ сделаны +10...-10 вместо +20...-20. #877 

14.05.2016 [ksrs-terminal-gui] 3.0.0.176
FIX: 'Залипание' механической тангенты. #888 

15.05.2016 [ksrs-terminal-gui] 3.0.0.177
FIX: 'Залипание' экранной тангенты при открытом окне назначения РП. #888 
ADD: На кнопках для первого динамика добавлено отображение единички. #877
CHG: Подкрутил стиль пиктограмм линейных интерфейсов, чтобы соответствовали остальным РП. #877
CHG: Окно выбора РП и окно настройки Звуковых Событий. #877
     РП отсортированы так же как и на основной кнопке.
     Добавлены номера динамиков. На предмет пятого динамика ещё надо додумать.

16.05.2016 [ksrs-terminal-gui] 3.0.0.178
FIX: Радиокнопки. При поступлении флага "Питание", радиосессия создавалась даже в случаях когда ни одна кнопка РСТ не нажата.  
FIX: ВНС. Исключенная из группы выключением ПРМ кнопка, самовольно возвращалась в группу при появлении флага SQL.  
FIX: ВНС. Улучшено изменение активности канала при недоступности шлюза (когда кнопка чернеет и потом возвращается в работу обратно).  
ADD: ВНС. Добавлена обработка статуса ЛИ. Нормальным статусом для работы ВНС считается статус 0..299.
     При плохом статусе канал исключается из группы, при нормальном возвращается в работу. 

17.05.2016 [ksrs-terminal-gui] 3.0.0.178
FIX: В различных местах обновлены декларации моноширинных шрифтов.  
FIX: Улучшен парсер имён аудиоустройств на TiPro.  

18.05.2016 [ksrs-terminal-gui] 3.0.0.179
CHG: На всех кнопках обновлены шрифты, стили и т.п.. Визуально мало кто заметит изменения, но они есть :)  

19.05.2016 [ksrs-terminal-gui] 3.0.0.180
CHG: Устранены различные визуальные глюки связанные с новыми шрифтами.   
CHG: Для уменьшения объёма логов, до заглавных букв сокращены имена классов объектов. Например был TerminalChannelManager, стало TCM.
FIX: ВНС. Если при нажатой механической тангенте функция ВНС наглым образом выбирала активным другой канал, 
     то последующее отпускание тангенты игнорировалось на первом канале, т.к. он переставал быть активным, и тангента 'залипала'.

20.05.2016 [ksrs-collector-snmp] 3.0.0.78
ADD: Patch 51. Убрано время из мониторинга GUI ТТКУ. #872

20.05.2016 [ksrs-terminal-gui] 3.0.0.181
FIX: Радиосвязь. После деактивации ПРМ, радиосессия оставалась на прослушке и документировании. #894   

23.05.2016 [ksrs-terminal-gui] 3.0.0.182
FIX: Падение Терминала при попадании своего исходящего вызова себе же во входящие косвенные. #899   

24.05.2016 [ksrs-terminal-server] 3.0.1.15
FIX: Существовала вероятность падения сервера при встречном разъединении вызваной сессии SIP
CHG: Версия содержит экспериментальный код для ALSA устройств. Теперь JB (простой режим) обладает только стартовой эластичностью.

24.05.2016 [ksrs-terminal-gui] 3.0.0.182
FIX: Генератор. Генератор выдавался во входящие сессии Прослушки даже без наличия реальных разговорных соединений. #894   
FIX: ВНС. Активность каналов не учитывалась при работе Прослушки. #864
ADD: Теперь переадресация входящих вызовов "по занятости" происходит так же и по занятости передачей по Радио.
     На СТКУ при этом должна стоять галка 'Основные\Радиосвязь\Индикация занятости ЦТРС при активной передаче по РСТ'. #834

25.05.2016 [ksrs-control] 3.0.0.154
CHG: Основные настройки системы. Переделано окно редактирования пользователей. #881

25.05.2016 [ksrs-terminal-gui] 3.0.0.183
FIX: В информационном окне СТКУ отображалась только адресная информация о входящих прямых вызовах.
     Теперь берётся информация с кнопки принявшей вызов. #882   

26.05.2016 [ksrs-terminal-gui] 3.0.0.184
FIX: КПВ начинало проигрываться и тут же прерывалось для дуплексного вызова в случае Автоответа на вызываемой стороне. #726
     Теперь КПВ проигрывается только если от вызываемой стороны приходит Alerting и медиасреда не поднята.

26.05.2016 [ksrs-control] 3.0.0.154
FIX: Была поломана обработка пиктограмм аудиоустройств TiPro.

27.05.2016 [ksrs-control] 3.0.0.155
ADD: Редактор ЦТРС. Основные\Радиосвязь. Параметр "Подключать на ПРД микрофон того РП, чьей тангентой активировали передачу". #897

27.05.2016 [ksrs-terminal-gui] 3.0.0.185
ADD: Обработка параметра "Подключать на ПРД микрофон того РП, чьей тангентой активировали передачу". #897

31.05.2016 [ksrs-control] 3.0.0.156
FIX: Изменение номера версии конфигурации каналов системы при создании новых объектов не возбуждало желание обновиться у всех ЦТРС. #831
ADD: Запоминание параметров таблиц Журнала, Статистики и Логинов. #876

01.06.2016 [ksrs-terminal-gui] 3.0.0.185
ADD: Уровни логирования сделаны как в ksrs-terminal-server и ksrs-collector-snmp.
     Но в окно протоколирования сообщения будут валиться всегда когда оно открыто.

01.06.2016 [ksrs-control] 3.0.0.157
ADD: Уровни логирования сделаны как в ksrs-terminal-server и ksrs-collector-snmp.
ADD: Запоминается расположение тулбаров. Так же, при смене прав пользователя пустые тулбары скрываются совсем. #904
ADD: Пункт меню Питание\Выход из Графического Интерфейса. #905
CHG: Кнопка Выход теперь доступна только Админу и Инженеру и производит не выход из приложения, а перелогин под дефолтным техником. #905

02.06.2016 [ksrs-terminal-gui] 3.0.0.186
FIX: Не во всех случаях корректно обрабатывалось удержание вызова с внешних абонентов. #775

02.06.2016 [ksrs-control] 3.0.0.158
FIX: Редактор ЦТРС. Подключения. Пункты меню типа "Добавить подписки на все ЦТРС" и т.п. работали некорректно 
     при наличии нескольких sip-подключений.

03.06.2016 [ksrs-terminal-server] 3.0.1.16
ADD: ALSA аудиоустройства теперь каждые 10 часов работы переоткрываются. Эксплуатация показала, что через 26-28 часов
     непрерывной работы возникали проблемы с проигрыванием потока данных непосредственно в драйвере аппаратуры (это
     заплата)

14.06.2016 [ksrs-collector-snmp] 3.0.0.79
ADD: Patch 52. Процедурой приведения БД к начальному виду удалялся пользователь Техник по умолчанию. #907

14.06.2016 [ksrs-terminal-server] 3.0.1.17
ADD: Поддержка трубки с индикацией положения (поднята или опущена)

16.06.2016 [ksrs-terminal-gui] 3.0.0.187
FIX: При рестарте БЛИ-А, на активных РСТ не срабатывала функция применения заданной частоты.

17.06.2016 [ksrs-terminal-gui] 3.0.0.188
FIX: Удержание пыталось примениться к кнопке группового вызова, поэтому поставить на удержание можно было, а снять потом нельзя. #909

17.06.2016 [ksrs-control] 3.0.0.159
ADD: Редактор БЛИ-А. Добавлены новые параметры таблицы каналов.

21.06.2016 [ksrs-control] 3.0.0.160
ADD: Редактор БЛИ-А. Добавлена таблица параметров ИВА.

22.06.2016 [ksrs-control] 3.0.0.160
ADD: Редактор БЛИ-А. Добавлена таблица параметров DTMF.
ADD: Редактор БЛИ-А. Добавлена таблица параметров MB.
ADD: Редактор БЛИ-А. Добавлена таблица параметров FXO.
ADD: Редактор БЛИ-А. Добавлена таблица параметров FXS.

24.06.2016 [ksrs-terminal-gui] 3.0.0.188
CHG: На кнопке с пустой адресной информацией и пустым названием скрыто отображение РП 
     и кнопка не реагиреут на нажатия (а-ля пустая кнопка у Мегафона).

24.06.2016 [ksrs-collector-snmp] 3.0.0.80
ADD: Patch 53. Процедурой приведения БД к начальному виду удалялась базовая конфигурация звуковых файлов.

24.06.2016 [ksrs-control] 3.0.0.160
ADD: Схема. В папку config\images\scheme\ добавлены пиктограммы коммутаторов Advantech EKI-7656C и EKI-7659C. 

28.06.2016 [ksrs-control] 3.0.0.161
ADD: Редактор ЦТРС. Сохранение названия ЦТРС в передаваемой конфигурации.  

28.06.2016 [ksrs-terminal-gui] 3.0.0.189
ADD: Название ЦТРС над часами

08.07.2016 [ksrs-control] 3.0.0.161
FIX: Звуковое оповещение о критических событиях нельзя было задушить, пока оно 10 раз не отыграет.  

11.07.2016 [ksrs-collector-snmp] 3.0.0.81
ADD: Patch 54. Поддержка смещения нумерации в конфигурации комплекта системного элемента.
                                                                                
27.07.2016 [ksrs-control] 3.0.0.162
CHG: Редактор ЦТРС. Изменена настройка доступных функций, добавлена визуальная настройка панелей функциональных кнопок.   

27.07.2016 [ksrs-terminal-gui] 3.0.0.190
CHG: Новый вид панелей функциональных кнопок.   
ADD: Регулятор глобальной громкости на правой панели. Переключение Радио/ГГС осуществляется кнопкой над ползунком.   

28.07.2016 [ksrs-control] 3.0.0.162
FIX: Вроде поправлено пропадание информационного окна на Linux при одновременном выделении нескольких объектов на схеме.   

28.07.2016 [ksrs-terminal-gui] 3.0.0.190
FIX: Неверно формировалась адресная информация исходящих вызовов, если у кнопки в настройках адресов отсутствовали "sip:" и "@".   

16.08.2016 [ksrs-terminal-server] 3.0.1.18
ADD: Добавлена возможность создавать канал звукозаписи в сеть. Для этого нужно создать сессию на файловом канале в формате:
     CalledID=rtp:<main IP>:<Main Port>[,<slave IP>:<slave Port>]. В документе, описывающем взаимодействие по протоколу Р1
     внесены необходимые изменения

18.08.2016 [ksrs-terminal-gui] 3.0.0.191
CHG: Окно 'Входящие косвенные вызовы' интегрировано в 'Номеронабиратель'. История вызовов объединена с исходящими косвенными.
ADD: Косвенная связь. В записной книжке добавлен вызов экранной клавиатуры и фильтрация записей. 
FIX: TiPro. Не отображалась пиктограмма для РП типа Speaker.   

19.08.2016 [ksrs-control] 3.0.0.163
ADD: Редактор ЦТРС. Основные настройки, Разное. Настройка интерфейсов внешнего документирования.
     Теперь зашитые ранее линии магнитофона можно изменить, а так же новый тип документирования - RTP.   

19.08.2016 [ksrs-terminal-gui] 3.0.0.192
ADD: Применение новых настроек интерфейсов внешнего документирования.   

24.08.2016 [ksrs-collector-snmp] 3.0.0.82
ADD: Patch 55. При создании новых ЦТРС, в таблицу локальных устройств (обычно устройства ППРП) этих ЦТРС 
     ошибочно вносились элементы других типов, что приводило к нарушению логики работы других процедур.

25.08.2016 [ksrs-terminal-server] 3.0.1.19
FIX: Не транслировался поток данных с канала VoIP магнитофона

30.09.2016 [ksrs-terminal-server] 3.0.1.20
FIX: Если канал линии магнитофона настроен с резервом, то последния цифра порта основной линии отрезалась
CHG: Теперь канал линии магнитофона транслирует данные только тогда, когда есть активные соединения
ADD: Добавлен механизм "keep a life" с трансляцией статуса терминала в специальном пакете расширения без звуковых данных:
     <Protocol ID>=0x1338+<Строковое описание статуса> (SILENCE|EMPTY|BUSYOUT|BUSYIN|FREE|BLOCKED|RADIO)

30.08.2016 [ksrs-terminal-gui] 3.0.0.193
FIX: Логика новых интерфейсов внешнего документирования активировалась в некоторых случаях не сразу после чтения конфигурации. 
CHG: Немного изменена логика открытия/закрытия нового окна косвенной связи и клавиатуры в нём.

05.09.2016 [ksrs-terminal-gui] 3.0.0.194
FIX: Косвенная связь. Если окно входящих вызовов открывалось после ответа на вызов, кнопка вызова иногда отрисовывалась не полностью.
CHG: ТЕСТ. При осуществлении циркулярного вызова убрана вся индикация активности на входящих в циркуляр кнопках.

05.09.2016 [ksrs-control] 3.0.0.164
CHG: Редактор ЦТРС. Спрятана функциональная кнопка Номеронабиратель. 'Входящие косвенные' переименованы в 'Косвенную связь'.  

06.09.2016 [ksrs-control] 3.0.0.164
CHG: Схема. Пиктограмма статуса мониторинга теперь отображается даже на недоступных (серых) объектах.  

12.09.2016 [ksrs-terminal-gui] 3.0.0.195
ADD: Поддержка новой трубки.

13.09.2016 [ksrs-terminal-gui] 3.0.0.196
FIX: Поддержка новой трубки. В определенной конфигурации РП не срабатывал ОТБОЙ вызовов при опускании трубки.

14.09.2016 [ksrs-terminal-gui] 3.0.0.196
ADD: Поддержка новой трубки. Если трубка была поднята ДО нажатия кнопки какого-либо дуплексного вызова, 
     то при нажатии кнопки вызова, назначенные на эту кнопку РП автоматически переключаются на снятую трубку.
     После отбоя вызова, РП возвращаются с трубки на исходные значения.

15.09.2016 [ksrs-terminal-gui] 3.0.0.197
FIX: Косвенная связь. При одном входящем вызове иногда появлялась надпись об отсутствии входящих вызовов.
CHG: Поддержка новой трубки. В большинстве случаев, поднятие и опускание трубки теперь влияет не только на первый найденный подходящий вызов,
     а на все найденные вызовы. В режиме конференции, например, при опускании трубки будут отбиты одновременно сразу все абоненты.
ADD: Поддержка новой трубки. Теперь на УЖЕ снятую трубку автоматически привязываются все дуплексные входящие вызовы.

22.09.2016 [ksrs-control] 3.0.0.165
ADD: Редактор БЛИ-Ц. Выделен в отдельный тип редактора. Добавлена страница для регистрации радиостанций БЛИ-Ц в системе.  

22.09.2016 [ksrs-collector-snmp] 3.0.0.83
ADD: Patch 56. Добавлен мониторинг каналов ЛИ БЛИ-А.

23.09.2016 [ksrs-collector-snmp] 3.0.0.83
ADD: Patch 57. Изменён мониторинг каналов ЛИ БЛИ-А. Поправки для регистрации радиостанций БЛИ-Ц. 

29.09.2016 [ksrs-terminal-gui] 3.0.0.198
CHG: Шаг регулировки громкости изменен с 1дБ до 0.1дБ. Требуется сервер версии >= 3.0.1.21.
FIX: Поддержка новой трубки. Уже снятая трубка начинала приставать не только к дуплексным вызовам, но и к симплексным и даже к радиосвязи.  
FIX: При потере физической связи с Радио (статус канала = недоступен), мигающие желтым страницы
     продолжали моргать до следующего появления сигнала от Радио.  

29.09.2016 [ksrs-terminal-server] 3.0.1.21
CHG: Шаг регулировки громкости изменен с 1дБ до 0.1дБ. Требуется ГУЙ версии >= 3.0.0.198.

30.09.2016 [ksrs-terminal-gui] 3.0.0.198
CHG: Главный регулятор громкости теперь немного удачнее отзывается на нажатия "в молоке".

03.10.2016 [ksrs-terminal-gui] 3.0.0.199
FIX: На время обновления конфигурации теперь отключается различная служебная логика, т.к. в каких-то случаях она возможно приводила к падению.

04.10.2016 [ksrs-terminal-server] 3.0.1.22
FIX: При регулировки уровня и дублирующих перекоммутациях в микшере терялись звуковые пакеты. На слух это воспринималось как треск.

04.10.2016 [ksrs-control] 3.0.0.166
CHG: Информационное окно объекта. Если ВМ имеет неопределенный статус (кирпич, истекло время ожидания и т.п.),
     то все индикаторы и прочие элементы замены из состава объекта скрываются до появления нормального статуса ВМ.  

04.10.2016 [ksrs-collector-snmp] 3.0.0.85
ADD: Patch 58. Добавлена процедура пересоздания переменных и индикаторов для всех элементов.
     Её нужно применять в патчах например при создании новых индикаторов, чтобы они автоматически привязывались ко всем
     уже существующим объектам. Ранее, чтобы у уже существующего объекта появились новые индикаторы, его требовалось пересоздавать целиком.    

05.10.2016 [ksrs-terminal-gui] 3.0.0.200
CHG: Убрано раздельное назначение РП на кнопку в Номеронабирателе и на входящие косвенные вызовы.
     Теперь РП назначаются сразу на всю косвенную связь.

06.10.2016 [ksrs-terminal-gui] 3.0.0.200
FIX: Настройка Акустических сигналов. Прерывался звук при регулировке громкости.

07.10.2016 [ksrs-control] 3.0.0.166
CHG: Редактор Терминала. ПРИО переименовано обратно в ВТОРЖ.

07.10.2016 [ksrs-terminal-gui] 3.0.0.201
CHG: ПРИО переименовано обратно в ВТОРЖ.
FIX: При включенной опции "Занятость при активной передаче по РСТ" отбивались даже вызовы Вторжения. 
CHG: Удаление старого кода обработки входящих косвенных вызовов.

10.10.2016 [ksrs-terminal-gui] 3.0.0.202
CHG: Убран отбой входящих вызовов при включенной опции "Занятость при активной передаче по РСТ". Вызовы теперь пропускаются 
     дальше в интерфейс, но при этом отключается звук индикации о входящем вызове, как при опции "Блокировка автоответа...". 

10.10.2016 [ksrs-control] 3.0.0.167
ADD: Редактор БЛИ-А. Добавлены новые параметры Радио.

11.10.2016 [ksrs-terminal-server] 3.0.1.23
ADD: Подержка установки RTE (для переведения РСТ в специальный режим при трансляции оповещения SELCAL) и режима SQL со стороны терминала 

11.10.2016 [ksrs-control] 3.0.0.168
ADD: Редактор ЦТРС. Добавлен новый параметр Радио - исключение кнопки из влияния общего регулятора громкости.
ADD: Редактор ЦТРС. Добавлен новые параметры ГГС и Радио - проигрывать сигнал 'Подтверждение нажатия'.

11.10.2016 [ksrs-terminal-gui] 3.0.0.203
ADD: Акустический сигнал "Подтверждение нажатия" теперь проигрывается и на успешное соединение ГГС соединений (в т.ч. циркуляр),
     и на успешное подключение тангенты, ПРМ и ПРД. Естественно только если эти действия были инициированы нажатием экранных кнопок.
     Управляется опциями на странице основных настроек ЦТРС в СТКУ. 
ADD: Общая громкость. Исключение из работы Радиокнопок с соответствующей опцией. 

12.10.2016 [ksrs-collector-snmp] 3.0.0.86
ADD: Patch 59. Удаление лишних ранее созданных портов у всех БЛИ-А.

12.10.2016 [ksrs-control] 3.0.0.169
FIX: Редактор ЦТРС. При отсутствии настроенных кнопок ГГС, в конфигурацию ЦТРС вообще не попадал SIP endpoint.
     Становилась недоступна даже косвенная связь. #588
CHG: Редактор ЦТРС. Кнопка Частота РСТ выделена в отдельную функциональную кнопку.
ADD: Редактор ЦТРС. Параметры Радиокнопки. Режим излучения SELCAL. *В РАЗРАБОТКЕ*  

12.10.2016 [ksrs-terminal-gui] 3.0.0.204
CHG: Кнопка Частота РСТ выделена в отдельную функциональную кнопку.
ADD: Частота РСТ. Добавлен переключатель режима Шумоподавителя.
ADD: SELCAL. Переключение режима излучения РСТ на время работы SELCAL. *В РАЗРАБОТКЕ*  

13.10.2016 [ksrs-control] 3.0.0.169
ADD: Редактор ЦТРС. Параметры Радиокнопки. Режим излучения SELCAL.  

13.10.2016 [ksrs-terminal-gui] 3.0.0.204
FIX: Акустический сигнал "Подтверждение нажатия" проигрывался при стартовом восстановлении активных Радиокнопок.
ADD: SELCAL. Переключение режима излучения РСТ на время работы SELCAL. Пока без индикации режимов.

13.10.2016 [ksrs-terminal-server] 3.0.1.24
FIX: Если задан некорректный формат адреса регистратора (не в формате IPv4 или IPv6), то при выгрузке или перезагрузке параметров
     происходит исключительная ситуация, сопровождающаяся "падением" сервиса как описано http://bugs.rinotel.com/view.php?id=939#c4383

14.10.2016 [ksrs-terminal-server] 3.0.1.25
FIX: Команды RTE и SQL уходили в обрезанном виде

18.10.2016 [ksrs-terminal-gui] 3.0.0.205
FIX: Падение при включении АВТОДОЗВОНА на кнопку без фиксации с активным входящим вызовом. #846
ADD: КДРМ. Панель фильтров.

21.10.2016 [ksrs-collector-snmp] 3.0.0.87
ADD: Patch 60. Добавлена возможность скрывать индикаторы от мониторинга и СТКУ.

21.10.2016 [ksrs-control] 3.0.0.170
ADD: Редактор параметров мониторинга. Вызывается через контекстное меню объекта. Пока там только видимость индикаторов.  

26.10.2016 [ksrs-collector-snmp] 3.0.0.88
FIX: Patch 61. Для индикаторов 'состоящих' из нескольких параметров (OID), процедура пересоздания индикаторов 
     пересоздавала только первый параметр индикатора.
ADD: Patch 61. Новый тип объекта - Сервер мониторинга. Индикаторы объема дискового пространства.

26.10.2016 [ksrs-control] 3.0.0.171
ADD: Новый тип объекта - Сервер мониторинга.

27.10.2016 [ksrs-terminal-gui] 3.0.0.206
FIX: Убрана лишняя перекоммутация РП в том случае, когда становится недоступным РП, являющийся РП по умолчанию.

08.11.2016 [ksrs-collector-snmp] 3.0.0.89
ADD: Patch 62. Расширение параметров процедур для передачи предыдущих значений индикаторов в коллектор. 

11.11.2016 [ksrs-collector-snmp] 3.0.0.90
ADD: Patch 63. Новые индикаторы. 

21.11.2016 [ksrs-collector-snmp] 3.0.0.91
ADD: Patch 64. В мониторинг добавлен SIP-телефон. 

24.11.2016 [ksrs-control] 3.0.0.171
ADD: Меню Настройки Системы\Конфигурация ЦТРС Тренажера.
     Выбираем ЦТРС1, ЦТРС2, Конфиг1, Конфиг2. Жмём OK. В окне сообщений будут выводиться статусы операций.
       В UI файлах заменяются ip-адреса по следующему принципу:
       1. Если значения параметров кнопки caller и called оканчиваются на "@", то нужный ip-адрес просто подставляется в конец строки.
          Например: значение "sip:123@" заменится на "sip:123@192.168.12.xx"
          Ip-адрес будет подставлен соответствующий, на ЦТРС1 для caller подставится адрес ЦТРС1, для called ЦТРС2. На ЦТРС2 наоборот. 
       2. Более простой вариант. Существуют макросы LOCALIP и REMOTEIP. Их можно использовать не только в кнопках,
          но и например в параметре "АОН по-умолчанию". В зависимости от того, чей UI файл изменяется,
          вместо LOCALIP будет подставлен ip-адрес ЦТРС _с которого_ производится вызов,
          а вместо REMOTEIP - ip-адрес ЦТРС _на который_ производится вызов.
          Пример: Параметр кнопки "Адрес для исходящих вызовов" должен иметь вид "sip:123@REMOTEIP",
          а параметр "АОН" - "sip:321@LOCALIP".
       Т.е. по сути, для идентификации вызовов (чтобы вызов попал из определённой кнопки на ЦТРС1 в определённую кнопку на ЦТРС2)
       в каждой кнопке нужны только некие идентификаторы - то что идёт до символа "@".
       Всё что идёт после "@",  при обновлении конфигураций будет заменяться на нужные адреса.

24.11.2016 [ksrs-terminal-gui] 3.0.0.207
ADD: КДРМ. При переключении фильтров плодились записи разговоров.

29.11.2016 [ksrs-collector-snmp] 3.0.0.92
FIX: В СТКУ выдавались сообщения об изменении индикаторов даже когда их статус не изменялся. 

29.11.2016 [ksrs-control] 3.0.0.172
ADD: Поддержка объектов типа ЦПС. 

30.11.2016 [ksrs-collector-snmp] 3.0.0.93
ADD: Patch 65. Новый тип объекта ЦПС. Изменение процедуры получения списка конфигураций терминалов. 

05.12.2016 [ksrs-collector-snmp] 3.0.0.94
ADD: Patch 66. Правки для Тренажера. 

07.12.2016 [ksrs-terminal-gui] 3.0.0.207
FIX: Номеронабиратель. В DTMF не передавались символы # и *. 

08.12.2016 [ksrs-collector-snmp] 3.0.0.95
FIX: Patch 67. Значение индикатора переписывало состояние ВМ. #941 

08.12.2016 [ksrs-control] 3.0.0.173
ADD: Тренажер. Схема. На ЦТРС добавлен пункт "Обновить конфигурацию (Тренажер)", вызывающий окно загрузки конфигураций. 
CHG: Тренажер. Схема. На ЦТРС убрана информация о номерах версий конфигураций и мигалка о необходимости обновления.
     Вместо этого выводится название загруженной конфигурации (в том числе и в подсказке, вылезающей при наведении мыши на объект).  
ADD: На объектах, рядом с пиктограммой общего статуса теперь выводится и пиктограмма состояния индикаторов.
     Для отображения выбирается худший статус из всех индикаторов. #784 

12.12.2016 [ksrs-terminal-server] 3.0.1.26
CHG: Теперь если от графического интерфейса приходит длительность ДТМФ, равная 0, то она заменяется на 270 мс

12.12.2016 [ksrs-control] 3.0.0.174
CHG: Тренажер. Редактор ЦТРС. Окно загрузки конфигураций. В таблице убрана сортировка по-умолчанию,
     сделана сортировка по паре Имя+Комментарий, и спрятаны старые версии каждой конфигурации.   
ADD: Тренажер. Схема. На ЦТРС тип загруженной конфигурации определяется по имени конфигурации (ищутся слова "Автоном" и "Компл")
     и отображается на объекте в виде символов А и К.    

12.12.2016 [ksrs-terminal-gui] 3.0.0.208
CHG: Тренажер. Убраны символы * с функциональных кнопок.
CHG: Тренажер. "Экстр.громкость" сделана +3дБ.
     
13.12.2016 [ksrs-terminal-gui] 3.0.0.208
CHG: Тренажер. Немного изменен внешний вид и поведение основных регуляторов громкости.
CHG: Тренажер. "Экстр.громкость" сделана по-умолчанию = +4дБ и работает на все (и существующие и новые) входящие вызовы
     пока нажата функциональная кнопка.

13.12.2016 [ksrs-control] 3.0.0.175
CHG: Тренажер. Редактор ЦТРС. Основные. ГГС. Настройка уровня Экстренной Громкости.
CHG: Тренажер. Обновление конфигураций. Обработка параметра Пеленг для автономного режима.

14.12.2016 [ksrs-terminal-gui] 3.0.0.208
FIX: Тренажер. Ошибочно применялись настройки тулбаров от КАРС.

14.12.2016 [ksrs-control] 3.0.0.176
FIX: Тренажер. Схема. Неоперативно обновлялись символы А и К при замене конфигураций. 
CHG: Тренажер. Обновление конфигураций. Комплексный режим.
     Адрес пеленга у всех кнопок Радио(Кит) устанавливается равным 10.34.144.215:50000.
     Основные макросы для подстановки ip-адресов в параметры кнопок следующие:
       INSTRIP1,INSTRIP2,INSTRIP3,INSTRIP4 и т.д. - адреса инструкторов
       DISPIP1,DISPIP2,DISPIP3,DISPIP4 и т.д. - адреса диспетчеров
     Так же, как и для автономного режима, доступен макрос LOCALIP и подстановка адреса в поле АОН,
     если значение поля в кнопке оканчивается на символ "@". Описание см. выше: "24.11.2016 [ksrs-control] 3.0.0.171".

15.12.2016 [ksrs-control] 3.0.0.177
FIX: Тренажер. Схема. Всё равно неоперативно (со второго раза) обновлялись символы А и К при замене конфигураций. 
CHG: Тренажер. Обновление конфигураций. В списках ЦТРС спрятаны 'фантомные' ЦТРС, а в списках конфигураций и ЦТРС сделана 
     зависимость диспетчер/инструктор (для диспетчера предлагается только диспетчерское, для инструктора - инструкторское). 
CHG: Тренажер. Обновление конфигураций. Комплексный режим.
     Изменена логика замены адресов в кнопках на подобие автономного режима + спецобработка кнопок диспетчеров.
     Адреса в кнопках существующих конфигураций теперь можно особо не настраивать, т.к.: 
       1. не обязательно иметь адреса в кнопках вида "sip:xxx@". Нужный ip заменит существующий целиком.
       2. для кнопок связи между диспетчерами автоматически подставляется одинаковый contactname = 123321.

16.12.2016 [ksrs-control] 3.0.0.178
FIX: Тренажер. Схема. Символы А и К не прорисовывались при старте СТКУ. 

16.12.2016 [ksrs-terminal-gui] 3.0.0.209
CHG: Тренажер. ПРМ и ПРД у Радиокнопок КИТ теперь всегда активируются при старте и загрузке конфигурации.

18.12.2016 [ksrs-terminal-gui] 3.0.0.209
FIX: Тренажер. ПРМ и ПРД у Радиокнопок КИТ теперь всегда активируются при старте и загрузке конфигурации.

18.12.2016 [ksrs-control] 3.0.0.179
CHG: Тренажер. Адрес пеленга комплексного режима изменен на 10.34.144.220.
FIX: Тренажер. Редактор ЦТРС. При загрузке чужих конфигураций иногда в БД сохранялось несколько SIP-каналов,
     что приводило к последующему зависанию сервера ЦТРС при получении такой конфигурации. 

19.12.2016 [ksrs-collector-snmp] 3.0.0.96
FIX: Patch 68. Корректировка процедуры генерации конфигураций под нужды Тренажера. 

19.12.2016 [ksrs-control] 3.0.0.180
ADD: Тренажер. Обновлялка. Сообщения из окна теперь попадают и в файлы логов СТКУ.
FIX: Тренажер. Обновлялка. Не во всех случаях корректно генерировались файлы конфигурации каналов ЦТРС,
     например поэтому не с первого раза запускался АТИС. Но теперь в БД требуется Patch 68 (ksrs-collector-snmp 3.0.0.96). 

19.12.2016 [ksrs-terminal-gui] 3.0.0.210
FIX: Номеронабиратель. При срабатывании таймера на бездействие, после скрытия окна на экране могло остаться меню выбора внешних шлюзов.

20.12.2016 [ksrs-terminal-gui] 3.0.0.210
ADD: Тренажер. Кнопка "Акустические сигналы" добавлена на панель Настроек.

20.12.2016 [ksrs-control] 3.0.0.181
ADD: Тренажер. Через ~5 секунд после обновления конфигурации, по ЦТРС выдаётся команда на обновление статусов мониторинга.
     Это временное решение проблемы с плохим мониторингом при одновременном массовом обновлении ЦТРС.

21.12.2016 [ksrs-terminal-gui] 3.0.0.211
ADD: Тренажер. Кнопки РадиоКит. РП на кнопках ПРМ и ПРД теперь отображаются всегда, независимо от активности сессии. Если сессия неактивна, 
     то все пиктограммы черного цвета. Если есть входящий вызов, то РП на ПРМ белый, а при исходящем вызове РП на ПРД белый.
FIX: Тренажер. Кнопки РадиоКит. Аппаратная тангента пыталась активировать исходящую сессию при наличии активной входящей. При этом и 'приём'
     отбивался и передача не начиналась.

22.12.2016 [ksrs-collector-snmp] 3.0.0.97
FIX: Patch 69. Процедура генерации конфигураций создавала некорректную конфигурацию каналов после удаления РП из состава объекта
     и последующей загрузке старой версии UI, в которой этот РП использовался. 

28.12.2016 [ksrs-terminal-server] 3.0.1.27
ADD: Поддержка регуляторов уровня динамика и чувствительности микрофона для ЦПС

31.12.2016 [С НОВЫМ ГОДОМ!]



04.01.2016 [ksrs-terminal-server] 3.0.1.28
CHG: Для поддержки ЦПС изменен алгоритм работы с РП. Версия только для стенда. Не ставить на объекты!

05.01.2016 [ksrs-terminal-server] 3.0.1.29
ADD: Добавлен код регулировки предусиления(функционал отключен)
FIX: Не собиралось под win32

09.01.2017 [ksrs-terminal-gui] 3.0.0.211
ADD: Тренажер. На первую панель закладок теперь всегда добавляется страница 'Набор' для работы с косвенной связью.

10.01.2016 [ksrs-terminal-server] 3.0.1.30
ADD: Добавлен код тестирования уровня микрофона

12.01.2017 [ksrs-terminal-gui] 3.0.0.212
FIX: Тренажер. КДРМ. Спрятаны записи для входящих вызовов в кнопки РадиоКит. Они дублировались и как входящие ГГС и как Радио ПРМ.

13.01.2017 [ksrs-terminal-gui] 3.0.0.213
FIX: Тренажер. Регулировка громкости регулятором ГГС влияла на входящие соединения РадиоКит. Попытка всё это исправить.
FIX: Тренажер. Регулировка громкости регулятором ГГС активировала РП по умолчанию на входящих соединениях, 
     даже если использовались назначенные РП.
FIX: Тренажер. Номеронабиратель. При исходящем вызове на кнопке ОТБОЙ не выводилось имя вызванного абонента.

16.01.2017 [ksrs-terminal-gui] 3.0.0.213
ADD: Тренажер. Кнопка "Разъединить" теперь повторяет действие кнопки "ОТБОЙ".
ADD: Тренажер. Входящие несимплексные вызовы попадающие в кнопку РадиоКит теперь ведут себя как симплексные.
     В реальной эксплуатации при правильных настройках такая ситуация невозможна, но дырку нужно было прикрыть.
FIX: Тренажер. Отжатие ПРМ на кнопках РадиоКит не приводило к отбою входящего соединения.

18.01.2017 [ksrs-terminal-gui] 3.0.0.214
FIX: Тренажер. Не пропускалось несколько одновременных входящих симплексных вызовов, все вызовы кроме первого отбивались.
     А кнопки РадиоКит симплексные.

19.01.2017 [ksrs-terminal-gui] 3.0.0.214
ADD: Тренажер. В регуляторы громкости добавлена красная зона.

20.01.2017 [ksrs-control] 3.0.0.182
ADD: Тренажер. Редактор ЦТРС. Добавлен параметр "Адрес пеленга по умолчанию".

20.01.2017 [ksrs-terminal-gui] 3.0.0.215
CHG: Тренажер. Адрес для пеленга теперь принимается в формате addr:port:pid. А отправляется в старом строчном виде, 
     но вместо признака нажатой тангенты передаётся идентификатор пеленгатора. Частота отправки изменена с 1000 на 500 мс.
     Если в адресе не указан pid, то передаётся pid = 0.  
ADD: Тренажер. Применение параметра "Адрес пеленга по умолчанию". Параметр будет применяться только для тех кнопок, 
     у которых не настроен собственный адрес пеленга.

23.01.2017 [ksrs-control] 3.0.0.183
CHG: Тренажер. Обновлялка. Для обновления конфигураций в автономном режиме реализован выбор сразу нескольких 
     пар диспетчер-инструктор (как и в комплексном режиме).

24.01.2017 [ksrs-collector-snmp] 3.0.0.98
ADD: Patch 70. Добавлены таблицы и процедуры для работы с наборами конфигураций Тренажера. 

24.01.2017 [ksrs-control] 3.0.0.184
ADD: Тренажер. Обновлялка. Добавлен функционал сохранения/восстановления наборов конфигураций. Требуется БД версии 70.
     Сохраненный набор можно удалить, если при его выборе в меню "Открыть" одновременно удерживать Shift.

24.01.2017 [ksrs-terminal-server] 3.0.1.31
CHG: Трансляция сообщений пеленга в текстовом виде. Статус PTT (0 или 1) заменён на ID получаемый от ГУИ ЦТРС.

27.01.2017 [ksrs-control] 3.0.0.185
ADD: Тренажер. Передача режима работы (автономный или комплексный) на ЦТРС. 
ADD: Тренажер. Обновлялка. Страница настроек обновлялки (ещё в процессе наполнения). 

27.01.2017 [ksrs-terminal-gui] 3.0.0.216
ADD: Тренажер. Отображение режима работы при обновлении с СТКУ - символ А или К рядом с названием ЦТРС. 

29.01.2017 [ksrs-terminal-gui] 3.0.0.216
ADD: Тренажер. Функции "Быстрая телефонная трубка" и "Быстрая микротелефонная гарнитура". 
